/************ LOW LEVEL ROUTINES *****************/
// tempo
void tempo (uns16 durationms,bit locked)		// max 65 sec but no validity check on param
{
	tempoms = durationms + 1; 
	timer1 = 1;
	if (locked)
	while (timer1);
} 
/*
void tempo2 (uns16 durationms,bit locked)		// max 65 sec but no validity check on param
{
	tempoms2 = durationms + 1; 
	timer2 = 1;
	if (locked)
	while (timer2);
} 
*/
void BellTempo (uns16 durationms)		// max 65 sec but no validity check on param
{

	BEEP = 1;		
	BTempo = durationms + 1; 
	BTimer = 1;
} 

// beep
/*void beep (uns16 ms)
{
	beeptmp = ms;
	BEEP = 1;
		
}*/

void cvhexbcd (uns16 valcnv)
{
	uns16 tmpv;
	
	dmil = valcnv / 10000;
	tmpv = (long)dmil * 10000;
	valcnv = valcnv - tmpv;
	mil = valcnv / 1000;
	tmpv = (long)mil * 1000;
	valcnv = valcnv - tmpv;
	cent = valcnv / 100;
	tmpv = (long)cent * 100;
	valcnv = valcnv - tmpv;
	dix = valcnv / 10;
	tmpv = (long)dix * 10;
	un = valcnv - tmpv;	
	dmil = dmil + 0x30;
	mil = mil + 0x30;
	cent = cent + 0x30;
	dix = dix + 0x30;
	un = un + 0x30;
}

void cvhexbcdL (uns24 valcnv)
{
	uns24 tmpv;
	
	million = valcnv / 1000000;
	tmpv = million * 1000000;
	valcnv = valcnv - tmpv;	
	cmil = valcnv / 100000;
	tmpv = (uns24)cmil * 100000;
	valcnv = valcnv - tmpv;
	dmil = valcnv / 10000;
	tmpv = (uns24)dmil * 10000;
	valcnv = valcnv - tmpv;
	mil = valcnv / 1000;
	tmpv = (uns24)mil * 1000;
	valcnv = valcnv - tmpv;
	cent = valcnv / 100;
	tmpv = (uns24)cent * 100;
	valcnv = valcnv - tmpv;
	dix = valcnv / 10;
	tmpv = (uns24)dix * 10;
	un = valcnv - tmpv;
	million = million + 0x30;
	cmil = cmil + 0x30;
	dmil = dmil + 0x30;
	mil = mil + 0x30;
	cent = cent + 0x30;
	dix = dix + 0x30;
	un = un + 0x30;
}
void dispval (char xx,char yy, char nbdigits,char virgule,char font)
{
	char cntr;
	
	cntr = 0;
	switch (nbdigits)
	{
		case 1:
		{
			txt[0] = un;
			txt[1] = 0;
			break;
		}
		case 2:
		{
			txt[cntr] = dix;
			cntr ++;
			if (virgule == 1)
			{
				txt[cntr] = ',';
				cntr++;
			}
			txt[cntr] = un;
			cntr++;
			txt[cntr] = 0;
			break;
		}
		case 3:
		{
			txt[cntr] = cent;
			cntr ++;
			if (virgule == 1)
			{
				txt[cntr] = ',';
				cntr++;
			}
			txt[cntr] = dix;
			cntr++;
			if (virgule == 2)
			{
				txt[cntr] = ',';
				cntr++;
			}
			txt[cntr] = un;
			cntr ++;
			txt[cntr] = 0;
			break;
		}		
		case 4:
		{
			txt[cntr] = mil;
			cntr++;
			if (virgule == 1)
			{
				txt[cntr] = ',';
				cntr++;
			}
			txt[cntr] = cent;
			cntr++;
			if (virgule == 2)
			{
				txt[cntr] = ',';
				cntr++;
			}
			txt[cntr] = dix;
			cntr++;
			if (virgule == 3)
			{
				txt[cntr] = ',';
				cntr++;
			}
			txt[cntr] = un;
			cntr++;
			txt[cntr] = 0;
			break;
		}
		case 5:
		{
			txt[cntr] = dmil;
			cntr++;
			if (virgule == 1)
			{
				txt[cntr] = ',';
				cntr++;
			}
			txt[cntr] = mil;
			cntr++;
			if (virgule == 2)
			{
				txt[cntr] = ',';
				cntr++;
			}
			txt[cntr] = cent;
			cntr++;
			if (virgule == 3)
			{
				txt[cntr] = ',';
				cntr++;
			}
			txt[cntr] = dix;
			cntr++;
			if (virgule == 4)
			{
				txt[cntr] = ',';
				cntr++;
			}
			txt[cntr] = un;
			cntr++;
			txt[cntr] = 0;
			break;
		}			
	}		
	LCDK_PrintLine(font,xx,yy,0);
}	

// eeprom rtgs
char readprom (char eadr)
{

	EEADR = eadr;
	EECON1.2 = 0;		//WREN
	EECON1.7 = 0;		//EEPGD
	EECON1.6 = 0; 		// CFGS
	EECON1.0 = 1;

	return EEDATA;
}

void writeprom (char eadr , char edata)
{	while (EECON1.1 == 1);
	EEADR = eadr;
	EEDATA = edata;	
	STATUS.05 = 1;
	EECON1.07 = 0;
	GIE = 0;
	EECON1.02 = 1;
	EECON2 = 0x55;
	EECON2 = 0xAA;
	EECON1.1 = 1;
	STATUS.05 = 0;
	EECON1.02 = 0;
	GIE = 1;
}
// rotary switch
	
void HandelRotary (void)
{

	if (RotaryDebounce == 0)
	{ 
		if (oldselA != SELA)
		{
			rochg = 1;
			oldselA = SELA;
			RotaryDebounce = RotDebounceTmr; 
		}
		if (oldselB != SELB)
		{
			rochg = 1;
			oldselB = SELB;
			RotaryDebounce = RotDebounceTmr;
		}
		if (oldselSW != SELSW)
		{
			
			oldselSW = SELSW;
			if (oldselSW == 0) RselSWchg = 1;
			RotaryDebounce = RotDebounceTmr;	
		}

	}
	if (rochg != 0)
	{
		Rselchg = 1;
		rochg = 0;
		newsel.1 = oldselB;
		newsel.0 = oldselA ;	
	
		switch (Roldsel)
		{
			case (0b00):
			{
				if (newsel == 0b10)
				{
					 if (upcntr < 250) upcntr++;
				}	
				if (newsel == 0b01)
				{
					 if (upcntr > 0) upcntr--;
				}	 
				break;
			}
			/*	
			case (0b01):
			{
				if (newsel == 0b11)
				{
					 upcntr++;
					 if (upcntr > 127) upcntr = 127;
				}	
				if (newsel == 0b00)
				{
					 upcntr--;
					 if (upcntr < 0) upcntr = 0;
				}	 
				break;
			}
			case (0b10):
			{
				if (newsel == 0b00)
				{
					 upcntr++;
					 if (upcntr > 127) upcntr = 127;
				}	
				if (newsel == 0b11)
				{
					 upcntr--;
					 if (upcntr < 0) upcntr = 0;
				}	 
				break;	
			}

			case (0b11):
			{
				if (newsel == 0b10)
				{
					if (lclcnt > 0) lclcnt--;
				}
				
				if (newsel == 0b01)
				{
				 if (lclcnt < 250) lclcnt++;
				} 
				break;
			}
			*/
		}
		Roldsel = newsel;
	}
}
void InitRotary (void)
{

	oldselA = SELA;
	oldselB = SELB;
	Roldsel = 3;
	upcntr = 0;
}

void HandelKeys(void)
{
	if ((PORTSW1 == 0) || (PORTSW2 == 0) || (PORTSW3 == 0))
	{
		FlashFg = 0;
		LED = 0;
	}
	else 
	{
		if (FlashFg == 0)
		{
			FlashFg = 1;
			LED = 1;
		}
	}		
		
	if (SwDebounce == 0) 
	{ 
		if (PORTSW1 == 0) 
		{
			if (StatSw1 == 0)
			{
				SW1 = 1;
				StatSw1 = 1;
				SwDebounce = KDebounceTmr;
			}	
		}
		else
		{
			if (StatSw1 == 1)
			{
				StatSw1 = 0;
				SwDebounce = KDebounceTmr;
			}
		}
		if (PORTSW2 == 0)
		{
			if (StatSw2 == 0)
			{
				SW2 = 1;
				StatSw2 = 1;
				SwDebounce = KDebounceTmr;
			}	
		}
		else
		{
			if (StatSw2 == 1)
			{
				StatSw2 = 0;
				SwDebounce = KDebounceTmr;
			}
		}
		if (PORTSW3 == 0)
		{
			if (StatSw3 == 0)
			{
				SW3 = 1;
				StatSw3 = 1;
				SwDebounce = KDebounceTmr;
			}	
		}
		else
		{
			if (StatSw3 == 1)
			{
				StatSw3 = 0;
				SW3 = 0;
				SwDebounce = KDebounceTmr;
			}
		}		 		 		 
	}	
}

void TxData(void)
{
	char i;

	while (TXIF != 1);
	TXREG1 = 0x55;
	for (i=0; i!=5;i++)
	{
		while (TXIF != 1);
		TXREG1 = TxBuf[i];
	}
	for (i=0;i!=5;i++)		//prepare pading of 0's for next tx
	{
		TxBuf[i] = 0;
	}
	TxDataFlg = 0;			
}

void RcvData (char Check)
{
	char RData,i;
	
	OkMsg = 0;
	RxStat = 0;
	NextMsg = 0;
	i = 0;
	SrlTimeout = SrlRcvTout;
	SrlToutFlg = 1;
	while (SrlToutFlg == 1)
	{
		if (RCIF == 1)
		{
			if (NextMsg == 1)	
			{
				RxBuf[i] = RCREG1;			
				i++;
				if (i == 5)
				{
					SrlToutFlg = 0;
					NextMsg = 0;
					RxStat = 2;	
				}
			}	
			else 
			{
				RData = RCREG1;
				if (RData == 0xAA)
				{
					NextMsg = 1;
					RxStat = 1;
					i = 0;	
				}			
			}
		}
		RData = RxBuf[0];
		if (RData == Check) OkMsg = 1;
	}

}		

/* send data to electronic pot ************/
void SrlTfr (char dato)
{
	char i;
	
	for (i=0;i!=8;i++)
	{
		SDOUT = dato.7;
		dato *= 2 ;
		SCKL = 0;
		nop();
		SCKL = 1;
	}	 
	
}
	
void LoadPot (char Branch)
{
	char dati,dato;
	
	CSPOT1 = 0;
	switch (Branch)
	{
		case 0:
		{
			dato = 0b00010001;
			SrlTfr(dato);
			dato = VPot[0];
			if (dato > 230) dato = 230;
			SrlTfr(dato);	
			break;
		}
		case 1:
		{
			dato = 0b00010010;
			SrlTfr(dato);
			dato = VPot[1];
			if (dato > 230) dato = 230;
			SrlTfr(dato);	
			break;
		}
		case 2:
		{
			dato = 0b00010001;
			SrlTfr(dato);
			dato = VPot[2];
			if (dato > 230) dato = 230;
			SrlTfr(dato);	
			SrlTfr(0);
			SrlTfr(0);	
			break;
		}
		case 3:
		{
			dato = 0b00010010;
			SrlTfr(dato);
			dato = VPot[3];
			if (dato > 230) dato = 230;
			SrlTfr(dato);		
			SrlTfr(0);
			SrlTfr(0);				
			break;
		}				
	}	
	CSPOT1 = 1;
}	

/****************************************************
   Set all potetiometers to 0
*******************************************************/
void ClearPot(void)
{
	char i;
	
	for (i = 0; i!=4; i++)
	{
		VPot[i] = 0;
		LoadPot(i);
		ValI[i] = 0;
		Curr[i] = 0;
		State[i].1 = 0;
		State[i].2 = 0;
	}	
	
}	


/********************************************************
Sequencialy read each analog port. Result updated by interrupt
(values of current)
if mode bit is set, read also voltage values from slave processor. 
**********************************************************/


void ADCModule (bit mode)
{
	char i;
	
	if (OpsStart == 1) SlvCntr = 0;	

	while (GO != 0);			// adc is ready and 1 ms passed
	{
		NextANP++;	
		if (NextANP == 4) NextANP = 0;
		i = NextANP * 4;
		i = i & 0b1100;
		i = i|0b00000001;
		ADCON0 = i;		// prepare conversion
		nop();
		nop();
		nop();
		nop();
		nop();
		nop();
		nop();
		nop();
		nop();
		GO = 1;			// start AD	
		MesI[0] = MesI0;
		MesI[1] = MesI1;
		MesI[2] = MesI2;
		MesI[3] = MesI3;
	}
	if (mode == 1)		// extended mode, include data from slave
	{
		if (OpsStart == 1) // load once all ports
		{
			for (i=0;i!=4;i++)
			{
				TxBuf[0] = i+2;
				TxData();
				RcvData(i+2);
				MesV[i].high8 = RxBuf[1];
				MesV[i].low8 = RxBuf[2];
			}
		}
		else 
		{	
			TxBuf[0] = NextANP+2;
			TxData();
			RcvData(NextANP+2);
			MesV[NextANP].high8 = RxBuf[1];
			MesV[NextANP].low8 = RxBuf[2];
		}

	}
	
}



/**********************************************
convert value af temperature adc to dec C
result of 200 is 20.0 degree
***************************************************/
void CalcDegC (void)
{
/*
#if defined Float24
	float24 calc,calc1,calc2,ValCTN;
#else
	float32 calc,calc1,calc2,ValCTN;

#endif
	TxBuf[0] = 6;
	TxData();
	RcvData();
	TempADC.high8 = RxBuf[1];
	TempADC.low8 = RxBuf[2];
	// process value of temperature
	// first calculate value of voltage in mV
	calc = TempADC; 
	calc1 = calc/1023;
	
	// then value of resitor in ohms : R = (Vs * R1) / (Ve - Vs)
	calc2 = 5.000 * calc1;		// Ve = 5.000 V, calc2 = vs
	calc1 = calc2 * 18000;		// r1 = 18K
	calc2 = 5.000 - calc2; 
	ValCTN = calc1 / calc2;
	// apply formula of SteinHart-Hart
	calc1 = log(ValCTN);
	calc = CoefC * calc1;	//+ (C *(log R)^3)
	calc = calc * calc1;
	calc = calc * calc1;
	calc2 = CoefB * calc1;	//+ (B * log R)
	calc += calc2;
	calc += CoefA;			//+A
	calc = 1/calc;		// 1/T completes formula 
	calc -= 273.15;		// convert deg K to deg C
	//then assign value for return
	Temp = calc;

*/

	TxBuf[0] = 8;
	TxData();
	RcvData(8);
	Temp.high8 = RxBuf[1];
	Temp.low8 = RxBuf[2];

}

void HeatGestion (void)
{
	char i,k;
	char svvpot[4];
	
	cvhexbcd (Temp);
	txt[0] = cent;
	txt[1] = dix;
	txt[2] = un;
	txt[3] = 0;
	LCDK_PrintLine(1,15,7,0);	
	if (Temp > 40)
	{
		VENTILO = 1;		// start fan
		HeatStat = 1;
	}	
	if (Temp < 35)
	{
		VENTILO = 0;		// stop fan
		HeatStat = 0;
	}	
	if (Temp > 70)		// overheat, put process on hold
	{
		HeatStat = 2;
		VENTILO = 1;
		for (i=0;i!=4;i++)
		{
			k=VPot[i];
			svvpot[i] = k;
			VPot[i] = 0;
			LoadPot(i);
		}
		if ((OpsMode == 1) || (OpsMode == 2))	
		{
			txt[0] = '-';
			txt[1] = '-';
			txt[2] = '-';
			txt[3] = '-';
			txt[4] = 0;
			k=2;
			for (i = 0;i!= 4;i++)
			{
				if (State[i].0 == 1)
				{
					LCDK_PrintLine(1,2,k,0);
					k++;
				}	
			}
		}
		while ((Temp > 61) && (HeatStat == 2))
		{
			if (secflg ==1)
			{
				CalcDegC();
				cvhexbcd (Temp);
				txt[0] = cent;
				txt[1] = dix;
				txt[2] = un;
				txt[3] = 0;
				LCDK_PrintLine(1,15,7,0);
				secflg = 0;
			}
		}	
		if (HeatStat == 2) HeatStat = 3;	
		if (HeatStat == 3)  
		{
			for (i=0;i!=4;i++)
			{
				k=svvpot[i];
				VPot[i] = k;
				LoadPot(i);
			}
			HeatStat = 1;
			VENTILO = 1;
		}
					
		
	}	
}	

/***************************************************
Convert adc voltage value to Volts.
2000 is 2.000 volts.
****************************************************/
uns16 CalculeVolt (uns16 VDAC,char port)
{
	uns32 calc1;
	uns16 calc2,calc3;

	calc1 = 0;
	calc2 = 0;
	calc3 = 0;
	calc3 = KVolt[port];
	calc1 = (uns32)VDAC;
	calc1 = calc1 * 1000000;
	calc1 = calc1 / calc3;
	calc2 = calc1;
//	calc2.low8 = calc1.low8;
//	calc2.high8 = calc1.mid8;
	return calc2;
}

/******************************************************
Convert adc current value to Amperes
2000 is 2.000 A
******************************************************/

uns16 CalculeAmp (uns16 ADAC,char port)
{
	uns24 calc1;
	uns16 calc2,calc3;
	
	calc3 = KAmp[port];
	calc1 = (uns24)ADAC * calc3;
	calc1 = calc1 / 1000;
	calc2.low8 = calc1.low8;
	calc2.high8 = calc1.mid8;
	return calc2;
}
/***************************

************************/
/*
uns16 CumulI (void)
{
	uns16 calc16,LocValI;
	char i;
	
	NextANP = 0;
	for (i = 0;i!=3;i++)
	{
		ADCModule(0);
	}
	ADCModule(1);	
	LocValI = CalculeAmp (MesI[0],0);
	ValI[0] = LocValI;
	calc16 = CalculeAmp (MesI[1],1);
	ValI[1] = calc16;
	LocValI = LocValI + calc16;
	calc16 = CalculeAmp (MesI[2],2);
	ValI[2] = calc16;
	LocValI = LocValI + calc16;
	calc16 = CalculeAmp (MesI[3],3);
	ValI[3] = calc16;
	LocValI = LocValI + calc16;
	return LocValI;
}

*/	
/***********************************************************
This routine checks each port to see if a battery is connected or not.
If no barttery, State.0 = 0 otherwise 1;
Update value of displayed ligne for each port as needed.
If DispLgn is equel 0, line is not displayed.
************************************************************/
void CheckActive (void)
{	
	char i,LgnCtr;
	uns16 calci;
	bit NobatFlg;
	
	NobatFlg = 1;

	for (i=0;i!=4;i++)		// kill unused entries
	{
		DispLgn[i] = 0;
		calci = MesV[i];
		if (calci > 30) // More 1V, assume battery present
		{
			NobatFlg = 0;
			State[i].0 = 1;				
		}
		else State[i] = 0;	
	}	
	if (NobatFlg == 1) ErrorCode = 1;
	else if (OpsMode != 3)
	{
		LgnCtr = 2;
		if (Inputs == 1)
		{
			if (State[0].0 == 1)
			{
				if (State[1].0 == 1) ErrorCode = 2;
				if (State[2].0 == 1) ErrorCode = 2;
				if (State[3].0 == 1) ErrorCode = 2;
				State[0] = 0b10000001;
				State[1] = 0b10000000;
				State[2] = 0b10000000;
				State[3] = 0b10000000;
				DispLgn[0] = LgnCtr;
			}	
		}
		if ((Inputs == 2) || (Inputs == 3))
		{
			if (State[0].0 == 1)
			{
				if (State[1].0 == 1) ErrorCode = 2;
				State[0] = 0b10000001;
				State[1] = 0b10000000;
				DispLgn[0] = LgnCtr;
				LgnCtr++;
			}
			if (State[2].0 == 1)
			{
				if (State[3] == 1) ErrorCode = 2;
				State[2] = 0b10000001;
				State[3] = 0b10000000;
				DispLgn[2] = LgnCtr;
			}
		}
		if (Inputs == 4)
		{
			if (State[0].0 == 1)
			{
				State[0] = 0b10000001;
				DispLgn[0] = LgnCtr;
				LgnCtr++;
			}
			if (State[1].0 == 1)
			{
				State[1] = 0b10000001;
				DispLgn[1] = LgnCtr;
				LgnCtr++;
			}
			if (State[2].0 == 1)
			{
				State[2] = 0b10000001;
				DispLgn[2] = LgnCtr;
				LgnCtr++;
			}
			if (State[3].0 == 1)
			{
				State[3] = 0b10000001;
				DispLgn[3] = LgnCtr;
			}		
		}
	}		
}

/* ****************************************************
Check measured current Mes[i] against ADCCurr[i]
state.1 is set if decrease done, no more check for decrease
state.2 is set if increase done, no more check
****************************************************** */
void AdjustI(char port)
{

	char stcpy;
	uns16 calc,calc2;

	stcpy = State[port];
	if (stcpy.7 == 1) 	//  valid port continue
	{
		calc = MesI[port];
		calc2 = ADCCurr[port];
		if (stcpy.1 == 0)	//above value not yet corrected
		{
			if (calc > calc2)
			{
				VPot[port]--;
				LoadPot(port);
			}
			else
			{
				stcpy.1 = 1;
				State[port] = stcpy;
				VPot[port]--;
				LoadPot(port);	
			}		
		}
		else if (stcpy.2 == 0)		// under value not yet corrected
		// correction done only after above correction is done.
		{
			if (calc <= calc2)
			{
				VPot[port]++;
				LoadPot(port);	
			}
			else 
			{
				stcpy.2 = 1;
				State[port] = stcpy;
			}
		}		
	}
}
/**********************************************************
 Display error message
 Input is the error code.
 > err 1 : No battery detected
 > err 2 : more than one battery on parallel ports
***********************************************************/
void ErHdlOps (char code)
{
	LCDK_Cls(0x00);
	txt[0] = 'E';
	txt[1] = 'R';
	txt[2] ='R';
	txt[3] ='E';
	txt[4] ='U';
	txt[5] ='R';
	txt[6] =' ';
	txt[7] = code + 0x30;
	txt[8] =0;
	LCDK_PrintLine(1,1,2,0);
	txt[0] = 'A';
	txt[1] = 'p';
	txt[2] ='p';
	txt[3] ='u';
	txt[4] ='y';
	txt[5] ='e';
	txt[6] ='z'; 
	txt[7] =' ';
	txt[8] ='M';
	txt[9] ='E';
	txt[10] ='N';
	txt[11] ='U';
	txt[12] =0;
	LCDK_PrintLine(1,1,4,0);
	while (SW2!= 1)
	{
			//HandelKeys();
	}
	SW2 = 0;	
}
		