
/**********************************************************************
	Execution of OPS
***********************************************************************/

void OpsExec(bit MSClk,bit SecClk)
{
	uns16 calc16,LocValI,LocalValV,LocalValDiffV,DispI,DispV;

	
	size2 const char *point = MenuTxt[0].pt1;
	uns16 LocCapa,tp16;
	uns32 calc32;
	uns24 calc24;
	char Port,CurOfs,Rel,j,i,k;
	bit Rev,Vflg;

// **************************************************************
// ********* Discharge for measure of capacity or for storage ***
	if (((OpsMode == 1) || (OpsMode == 2)) && (MSClk == 1))
	{
			Bell (BMode);
			DispCtr ++;
			ActionCtr++;
			Vflg = 1;

			if (DispCtr == DispRefresh) DispCtr = 0;	// update display every 200ms
			if (ActionCtr == 5) ActionCtr = 0;	// update ports every 5ms 
		if (DispCtr == 0)
		{
			cvhexbcd (hour);
			txt[0] = dix;
			txt[1] = un;
			txt[2] = ':';
			cvhexbcd (min);
			txt[3] = dix;
			txt[4] = un;
			txt[5] = ':';
			cvhexbcd (sec);
			txt[6] = dix;
			txt[7] = un;
			txt[8] = ' ';
			if (OpsMode == 1)
			txt[9] = 'C';
			if (OpsMode == 2)
			txt[9] = 'S';
			un = Elements + 0x30;
			txt[10] = un;
			txt[11] = 'S';
			txt[12] = 0;
			LCDK_PrintLine(1,0,7,0);	
			
		}
		for (Port=0;Port!=4;Port++)		//scan ports 
		{
			if((State[Port].0 == 1) && (ActionCtr == 0))		// active ports only
			{
				stport++;
				if (stport >= 5)
				{
					Vflg = 1;
				}
				else stport = 6;	
				tp16 = MsCtr[Port];
				i++;
				MsCtr[Port] = tp16;
				if (tp16 >= 2000)
				{
					MsCtr[Port] = 0;
					Vflg = 1;
				}	
		// ***** Measure Current 
				if (Inputs == 4)
				{
					LocValI = CalculeAmp (MesI[Port],Port);
					ValI[Port] = LocValI;
				}
				if ((Inputs == 3) || (Inputs == 2))
				{
					if (Port == 0)
					{
						LocValI = CalculeAmp (MesI[0],0);
						ValI[0] = LocValI;
						calc16 = CalculeAmp (MesI[1],1);
						ValI[1] = calc16;
						LocValI = LocValI + calc16;
					}
					if (Port == 2)
					{
						LocValI = CalculeAmp (MesI[2],2);
						ValI[2] = LocValI;
						calc16 = CalculeAmp (MesI[3],3);
						ValI[3] = calc16;
						LocValI = LocValI + calc16;
					}						
				}
				if (Inputs == 1)
				{
					if (Port == 0)
					{
						LocValI = CalculeAmp (MesI[0],0);
						ValI[0] = LocValI;
						calc16 = CalculeAmp (MesI[1],1);
						ValI[1] = calc16;
						LocValI = LocValI + calc16;
						calc16 = CalculeAmp (MesI[2],2);
						ValI[2] = calc16;
						LocValI = LocValI + calc16;
						calc16 = CalculeAmp (MesI[3],3);
						ValI[3] = calc16;
						LocValI = LocValI + calc16;
					}
				}
		// ***** Measure Voltage
		
				if (Vflg)
				{
					Vflg = 0;
					if (Inputs == 4)
					{
						i = VPot[Port]; 
						SvPot[Port] = i;
						VPot[Port] = 0;		// Measure at 0amp
						LoadPot(Port);
						
					}
					if (Inputs == 2)
					{
						j = Port;
						i = VPot[j];	
						SvPot[j] = i;
						VPot[j] = 0;		// Measure at 0amp
						LoadPot(j);
						j = j + 1;
						i = VPot[j]; 
						SvPot[j] = i;
						VPot[j] = 0;		// Measure at 0amp
						LoadPot(j);
					}
					if (Inputs == 1)
					{
												j = Port;
						i = VPot[j];	
						SvPot[j] = i;
						VPot[j] = 0;		// Measure at 0amp
						LoadPot(j);
						j = j + 1;
						i = VPot[j]; 
						SvPot[j] = i;
						VPot[j] = 0;		// Measure at 0amp
						LoadPot(j);
						j++;
						i = VPot[j];	
						SvPot[j] = i;
						VPot[j] = 0;		// Measure at 0amp
						LoadPot(j);
						j = j + 1;
						i = VPot[j]; 
						SvPot[j] = i;
						VPot[j] = 0;		// Measure at 0amp
						LoadPot(j);
					}		
					tempo(8,1);
					i = Port + 2;
					TxBuf[0] = i;
					TxData();
					RcvData();
					MesV[Port].high8 = RxBuf[1];
					MesV[Port].low8 = RxBuf[2];
					LocalValV = CalculeVolt(MesV[Port],Port);
					ValV[Port] = LocalValV;
					if (Inputs == 4)
					{
						i = SvPot[Port];
						VPot[Port] = i;		// Restore current
						LoadPot(Port);
					}
					if (Inputs == 2)
					{
						j = Port;
						i = SvPot[j];
						VPot[j] = i;		// Restore current
						LoadPot(j);
						j++;
						i = SvPot[j];
						VPot[j] = i;		// Restore current
						LoadPot(j);
					}
					if (Inputs == 1)
					{
						j = Port;
						i = SvPot[j];
						VPot[j] = i;		// Restore current
						LoadPot(j);
						j++;
						i = SvPot[j];
						VPot[j] = i;		// Restore current
						LoadPot(j);	
						j++;
						i = SvPot[j];
						VPot[j] = i;		// Restore current
						LoadPot(j);
						j++;
						i = SvPot[j];
						VPot[j] = i;		// Restore current
						LoadPot(j);
					}			
					tempo(1,1);
				}	
		// ***** Take Action			
				LocalValV = ValV[Port];
				if (OpsMode == 1)		//discharge
				{
					if (LocalValV < TargetV)
					{
						if (State[Port].7 == 1)
						{
							State[Port].7 = 0;
							beeptmp = 2000;
							BellFg = 1;
							BMode = 0;
							Bell(BMode);	
						}	
						if (Inputs == 4)
						{
							VPot[Port] = 0;
							LoadPot(Port);
						}
						if ((Inputs == 2) || (Inputs == 3))
						{
						// get relays status
							TxBuf[0] = 7;
							TxData();
							RcvData();
							Rel = RxBuf[1];
							Rel /= 8;
							if (Port == 0)
							{
								VPot[0]	= 0;
								LoadPot(0);
								VPot[1] = 0;
								LoadPot(1);
								Rel &= 0b110;
								
								
							}
							else
							{
								VPot[2]	= 0;
								LoadPot(2);
								VPot[3] = 0;
								LoadPot(3);	
								Rel &=0b011;
							}
							TxBuf[0]='1';
							TxBuf[1]=Rel;
							if (RCIF) i=RCREG1;
							TxData();
							RcvData();
						}
						if  (Inputs == 1)
						{
							ClearPot();	
						}
						token[Port] = 'T';	//Termine
					}		
				}
				else			//storage
				{ 
					calc16 = 8 * (uns16)Elements;		// 3.8v per element + 0.08
					calc16 = TargetV + calc16;
					if (LocalValV < calc16)
					{
						if (State[Port].5 == 0)
						{
							// *** set bit 5 and reduce current
							State[Port].5 = 1;
							beeptmp = 1000;
							BellFg = 1;
							BMode = 1;
							Bell(BMode);
							if (Inputs == 4)
							{
								VPot[Port] = 0;
								LoadPot(Port);
								calc16 = Curr[Port] / 5;
								Curr[Port] = calc16;
								if (calc16 < 50) Curr[Port] = 50; 
								State[Port].1 = 0;
								State[Port].2 = 0;
								token[Port] ='R';	//Reduit
								tempo(2000,1);
							}
							if (Inputs == 1)
							{
								ClearPot();
								State[1].7 = 0;
								State[2].7 = 0;
								State[3].7 = 0;
								TxBuf[0] = '1';
								TxBuf[1]=0;		// stop all relays
								if (RCIF) i=RCREG1;
								TxData();
								RcvData();
								Curr[0] = Current /5;
								if (Curr[0] < 50) Curr[Port] = 50; 
								if (Curr[0] > 800) Curr[0] = 800;
								State[0].1 = 0;
								State[0].2 = 0;
								token[0] ='R';	
								tempo(2000,1);	
							}
							if ((Inputs == 2) || (Inputs == 3))	 
							{
								// get relays status
								TxBuf[0] = 7;
								if (RCIF) i=RCREG1;
									TxData();
								RcvData();
								Rel = RxBuf[1];
								Rel /= 32;
								if (Port == 0)
								{
									VPot[0] = 0;
									LoadPot(0);
									VPot[1] = 0;
									LoadPot(1);
									State[1].7 = 0;
									Curr[0] = Current / 5;
									if (Curr[0] < 50) Curr[0] = 50; 
									State[0].1 = 0;
									State[0].2 = 0;
									token[0] ='R';
									Rel &= 0b110;	
									tempo(2000,1);		
								}
								else
								{
									VPot[2] = 0;
									LoadPot(2);
									VPot[3] = 0;
									LoadPot(3);
									State[3].7 = 0;
									Curr[2] = Current / 5;
									if (Curr[2] < 50) Curr[2] = 50; 
									State[2].1 = 0;
									State[2].2 = 0;
									token[2] ='R';
									Rel &= 0b011;	
									tempo(2000,1);
								}
								TxBuf[0]='1';
								TxBuf[1]= Rel;		// update relays
								if (RCIF) i=RCREG1;
								TxData();
								RcvData();	
							}			
						}
					}
					if (LocalValV < TargetV)
					{
						if (State[Port].7 == 1)
						{
							beeptmp = 2000;
							BellFg = 1;
							BMode = 0;
							Bell(BMode);
							State[Port].7 = 0;		// disable port
						}
						VPot[Port] = 0;				//stop current
						LoadPot(Port);
						token[Port] = 'P';	//Pret
					}		
				}		

			// update display here
				if ((DispCtr == 0) && (DispLgn[Port] != 0))
				{
					txt[0] = Port+0x30;
					txt[0] ++;
					txt[1] = 0;
					LCDK_PrintLine(FONT8X8,0,DispLgn[Port],0);
					DispI = LocValI / 10;
					cvhexbcd (DispI);
					dispval (2,DispLgn[Port],3,1,1);
					cvhexbcd (ValV[Port]/10);
					dispval	(7,DispLgn[Port],4,2,1);
					if (token[Port] != 0)
					{
						txt[0] = token[Port];
						txt[1] = 0;
						LCDK_PrintLine(Font6x8,17,DispLgn[Port],1);
					}
					LocCapa = CurCumul[Port]/ 3620;  //1 hour plus compensate Volt Measure
					cvhexbcd (LocCapa);
					txt[0] = mil;
					txt[1] = cent;
					txt[2] = dix;
					txt[3] = un;
					txt[4] = 0;
					LCDK_PrintLine(Font6x8,13,DispLgn[Port],0);	
				}
			}
			if (SecClk == 1)
			{
				if (State[Port].0 == 1)
				{
					calc16 = ValI[Port];
					CurCumul[Port] += calc16;
					if ((Inputs == 2) || (Inputs == 3))
					{
						if (Port == 0)
						{
							calc16 = ValI[1];
							CurCumul[0] += calc16;
						}
						if (Port == 2)
						{
							calc16 = ValI[3];
							CurCumul[2] += calc16;
						}
					}
					if (Inputs == 1)
					{
						calc16 = ValI[1];
						CurCumul[0] += calc16;
						calc16 = ValI[2];
						CurCumul[0] += calc16;
						calc16 = ValI[3];
						CurCumul[0] += calc16;
					}				
				}
			}			
		}
	
		AdjustI(MSClk,1);		// check & adjust current as needed
	}
// *************************************************************
// ************* Measure of resistance, 1 Port only	***********
	if ((OpsMode == 3) && (MSClk == 1))		// measure resist
	{
		//LocValI = CumulI();
		ResState = Res2;
		switch (ResState)
		{
			case 0:
		// first 1 amp
			{
				AjFlg = 0;
				ClearPot();
				Res2 = 1;		
				for (k = 0; k != 4;k++)
				{
					
					Curr[k] = 250;
					SetI(k,250);
					State[k].1 = 0;
					State[k].2 = 0;
				}
				AjComplete = 0;
				break;
			}	
			case 1:
			{
				AjFlg = 1;
				LocValI = CumulI();
				ResValI[0] = LocValI;
				if (AjComplete == 0x0F)	 
				{
					
					Res2 = 2;
					ResValV = CalculeVolt(MesV[0],0);	
					ClearPot();
					AjFlg = 0;
					tempo(500,0);
				}
				
				break;
			}
			case 2:
			{
				if (timer1 == 0)
				{
					LocalValDiffV = CalculeVolt(MesV[0],0);	
					ValDiffV[0] = LocalValDiffV - ResValV ;
					Res2 = 3;
				}	
				break;
			}
			case 3:
			{
				ClearPot();
				for (i = 0; i != 4;i++)
				{
				
					Curr[i] = 500;
					SetI(i,500);
				}
				Res2 = 4; 
				AjComplete = 0;
				break;
			}			
			case 4:
			{
				AjFlg = 1;
				LocValI = CumulI();
				ResValI[1] = LocValI;
				if (AjComplete == 0x0F)	 
				{
					Res2 = 5;
					ResValV = CalculeVolt(MesV[0],0);	
					ClearPot();
					AjComplete = 0;
					AjFlg = 0;
					tempo(500,0);
				}
				break;
			}
			case 5:
			{
				if (timer1 == 0)
				{
					LocalValDiffV = CalculeVolt(MesV[0],0);	
					ValDiffV[1] = LocalValDiffV - ResValV ;
					Res2 = 6;
				}
				break;
			}
			case 6:
			{
				ClearPot();
				for (i = 0; i != 4;i++)
				{
					Curr[i] = 1000;
					SetI(i,1000);
					VPot[i] = 100;
					LoadPot(i);
				}
				Res2 = 7; 
				break;
			}			
			case 7:
			{
				AjFlg = 1;
				LocValI = CumulI();
				ResValI[2] = LocValI;
				if (AjComplete == 0x0F)	 
				{
					
					Res2 = 8;
					ResValV = CalculeVolt(MesV[0],0);	
					ClearPot();
					AjComplete = 0;
					AjFlg = 0;
					tempo(500,0);
				}
				break;
			}
			case 8:
			{
				if (timer1 == 0)
				{
					LocalValDiffV = CalculeVolt(MesV[0],0);	
					ValDiffV[2] = LocalValDiffV - ResValV ;
					Res2 = 9;
				}	
				break;
			}
			case 9:
			{
				ClearPot();
				for (i = 0; i != 4;i++)
				{
					Curr[i] = 2000;
					SetI(i,2000);
				}
				Res2 = 10; 
				break;
			}			
			case 10:
			{
				AjFlg = 1;
				LocValI = CumulI();
				ResValI[3] = LocValI;
				if (AjComplete == 0x0F)	 
				{
					Res2 = 11;
					ResValV = CalculeVolt(MesV[0],0);	
					ClearPot();
					AjComplete = 0;
					AjFlg  = 0;
					tempo(500,0);
				}
				break;
			}
			case 11:
			{
				if (timer1 == 0)
				{
					LocalValDiffV = CalculeVolt(MesV[0],0);	
					ValDiffV[3] = LocalValDiffV - ResValV ;
					Res2 = 12;
				}	
				break;
			}
			case 12:
			{
				ClearPot();
				AjFlg = 0;
				break;
			}		
		}				
//		if (MSClk == 1)
		{
			DispCtr++;
			if (DispCtr == DispRefresh)
			{
				DispCtr = 0;	
				// disp I
				cvhexbcd (ResValI[0]);
				dispval(1,2,4,1,Font6x8);
				cvhexbcd (ResValI[1]);
				dispval(1,3,4,1,Font6x8);
				cvhexbcd (ResValI[2]);
				dispval(1,4,4,1,Font6x8);
				cvhexbcd (ResValI[3]);
				dispval(1,5,4,1,Font6x8);
				// disp diff V
				cvhexbcd (ValDiffV[0]);
				dispval(7,2,4,0,Font6x8);
				cvhexbcd (ValDiffV[1]);
				dispval(7,3,4,0,Font6x8);
				cvhexbcd (ValDiffV[2]);
				dispval(7,4,4,0,Font6x8);
				cvhexbcd (ValDiffV[3]);
				dispval(7,5,4,0,Font6x8);
				// dis val R
				calc32 = (uns32)ValDiffV[0] * 1000;
				calc32 = calc32 / ResValI[0];
				calc16 = calc32;
				cvhexbcd (calc16);
				dispval(12,2,4,1,Font6x8);
				calc32 = (uns32)ValDiffV[1] * 1000;
				calc32 = calc32 / ResValI[1];
				calc16 = calc32;
				cvhexbcd (calc16);
				dispval(12,3,4,1,Font6x8);
				calc32 = (uns32)ValDiffV[2] * 1000;
				calc32 = calc32 / ResValI[2];
				calc16 = calc32;
				cvhexbcd (calc16);
				dispval(12,4,4,1,Font6x8);
				calc32 = (uns32)ValDiffV[3] * 1000;
				calc32 = calc32 / ResValI[3];
				calc16 = calc32;
				cvhexbcd (calc16);
				dispval(12,5,4,1,Font6x8);
				
				
				cvhexbcd (ResState);
				dispval(0,7,2,0,Font6x8);
				cvhexbcd (CalculeVolt(MesV[0],0));
				dispval(5,7,5,2,Font6x8);
			}
		}
	if (AjFlg == 1) AdjustI(1,1);
	}	
// *************************************************************	
// 	************* Calibration ***********************************
	if (OpsMode == 4)		//calibrate
	{
		//  calibrate voltage
		if (MenuItem == 40)	
		{
			if (MSClk == 1)
			{
				ActionCtr++;
				if (ActionCtr == 5) ActionCtr = 0;
				DispCtr++;
				if (DispCtr == 250)
				{
					DispCtr = 0;
					for (i = 0;i!=4;i++)
					{
						un = i+0x31;
						dispval (0,i+1,1,0,1);
						LocalValV = MesV[i];
						cvhexbcd (LocalValV);
						//dispval	(2,i+1,4,0,0);
						LocalValV = CalculeVolt (LocalValV,i);
						cvhexbcd (LocalValV);
						dispval	(7,i+1,5,2,0);
						cvhexbcd (KVolt[i]);
						dispval	(14,i+1,5,0,0);
					}
					cvhexbcd(RealVolt);
					txt[0] = dmil;
					txt[1] = mil;
					txt[2] = ',';
					txt[3] = cent;
					txt[4] = dix;
					txt[5] = un;
					txt[6] = 0;
					LCDK_PrintLine(FONT8X8,0,7,0);
					switch (VoltStep)
					{
						case 0:
						{
							txt[0] = dmil;
							txt[1] = mil;
							txt[2] = 0;
							LCDK_PrintLine(FONT8X8,0,7,1);
							break;
						}
						case 1:
						{
							txt[0] = cent;
							txt[1] = 0;
							LCDK_PrintLine(FONT8X8,3,7,1);
							break;
						}
						case 2:
						{
							txt[0] = dix;
							txt[1] = 0;
							LCDK_PrintLine(FONT8X8,4,7,1);
							break;
						}
						case 3:
						{
							txt[0] = un;
							txt[1] = 0;
							LCDK_PrintLine(FONT8X8,5,7,1);
							break;
						}			
					}			
				}

			}
			if (RselSWchg == 1)
			{
				RselSWchg = 0;
				VoltStep ++;
				upcntr = 100;
				OldRot = 100;
				if (VoltStep == 4) VoltStep = 0;
			}
			if (OldRot != upcntr)
			{
				Rev = 1;
				if (OldRot > upcntr) Rev =0;
				OldRot = upcntr;
				switch (VoltStep)
				{
					case 0:
					{ 
						if (Rev)
						RealVolt += 1000;
						else RealVolt -= 1000;
						break;
					}
					case 1:
					{
						if (Rev)
						RealVolt += 100;
						else RealVolt -= 100;
						break;
					}
					case 2:
					{
						if (Rev)
						RealVolt += 10;
						else RealVolt -= 10;
						break;
					}	
					case 3:
					{
						if (Rev)
						RealVolt += 1;
						else RealVolt -= 1;
						break;
					}
				}
				
				if (RealVolt > 30000)
				{
					RealVolt = 0;
				}								
			}	
			if (ActionCtr == 0)
				{
					CPort++;
					if (CPort == 4) CPort = 0;
					calc16 = MesV[CPort];
					calc32 = (uns32)calc16 * 1000000;
					calc32 = calc32 / RealVolt;
					calc16.low8 = calc32.low8;
					calc16.high8 = calc32.mid8;
					KVolt[CPort] = calc16;
				}	
	 
			if (SW3 == 1)
			{
				for (i=0;i!=4;i++)
				{
					k= i*6;
					calc16 = KVolt[i];
					writeprom(k,calc16.high8);
					writeprom(k+1,calc16.low8);
				}	
				TxtDisp(18,6,point,292,1,0,0);
				SW3 = 0;
			}				
		}
		
		// calibrate current

		if (MenuItem == 41)
		{
			CPort = Inputs - 1;
			if (SW2 == 1)
			{
				SW2 = 0;
				TogglePotMes = !TogglePotMes;
				if (TogglePotMes == 0)
				{
					upcntr = VPot[CPort];
					OldRot = upcntr;
				}
				txt[0] = ':';
				txt[1] = ' ';
				txt[2] = ' ';
				txt[3] = ' ';
				txt[4] = ' ';
				txt[5] = ' ';
				txt[6] = ' ';
				txt[7] = ' ';
				txt[8] = ' ';
				txt[9] = 0;
				txt[10] = 0;
				LCDK_PrintLine(1,9,4,0);
				LCDK_PrintLine(1,9,6,0);	
			}	
			if (MSClk == 1)
			{
				DispCtr++;
				if (DispCtr == DispRefresh)
				{
					DispCtr = 0;
					un = CPort+0x31;
					dispval (0,2,1,0,1);
					calc16 = CCurrent;
					cvhexbcd (CCurrent);
					dispval	(2,2,4,0,1);
					calc16 = CalculeAmp (calc16,CPort);
					cvhexbcd (calc16);
					dispval	(7,2,4,1,1);
					cvhexbcd (KAmp[CPort]);
					dispval	(14,2,4,0,1);
					cvhexbcd (VPot[CPort]);
					if (!TogglePotMes)
					dispval(8,4,3,0,2);
					else
					dispval(11,4,3,0,1);
					cvhexbcd(RealVolt);
					txt[0] = mil;
					txt[1] = ',';
					txt[2] = cent;
					txt[3] = dix;
					txt[4] = un;
					txt[5] = 0;
					if (TogglePotMes)
					LCDK_PrintLine(2,8,6,0);
					else
					LCDK_PrintLine(1,11,6,0);
					switch (VoltStep)
					{
						case 0:
						{
							txt[0] = mil;
							txt[1] = 0;
							if (TogglePotMes)
							LCDK_PrintLine(2,8,6,1);
							break;
						}
						case 1:
						{
							txt[0] = cent;
							txt[1] = 0;
							if (TogglePotMes)
							LCDK_PrintLine(2,10,6,1);
						break;
						}
						case 2:
						{
							txt[0] = dix;
							txt[1] = 0;
							if (TogglePotMes)
							LCDK_PrintLine(2,11,6,1);
							break;
						}
						case 3:
						{
							txt[0] = un;
							txt[1] = 0;
							if (TogglePotMes)
							LCDK_PrintLine(2,12,6,1);
							break;
						}					
					}	
				}
				
				calc24 = (uns24)RealVolt * 100;
				CCurrent = MesI[CPort];
				calc24 = calc24 / CCurrent;
				calc16.low8 = calc24.low8;
				calc16.high8 = calc24.mid8;
				KAmp[CPort] = calc16;
			}
			if (!TogglePotMes)
			{
				if (OldRot != upcntr)
				{
					i = VPot[CPort];
					Rev = 1;
					if (OldRot > upcntr) Rev =0;
					OldRot = upcntr;
					if (Rev)
					i ++;
					else i --;
					VPot[CPort] = i;
					LoadPot(CPort);
				}
			}	
			else
			{
				if (RselSWchg == 1)
				{
					RselSWchg = 0;
					VoltStep ++;
					upcntr = 100;
					OldRot = 100;
					if (VoltStep == 4) VoltStep = 0;
				}
				if (OldRot != upcntr)
				{
					Rev = 1;
					if (OldRot > upcntr) Rev =0;
					OldRot = upcntr;
					switch (VoltStep)
					{
						case 0:
						{ 
							if (Rev)
							RealVolt += 1000;
							else RealVolt -= 1000;
							break;
						}
						case 1:
						{
							if (Rev)
							RealVolt += 100;
							else RealVolt -= 100;
							break;
						}
						case 2:
						{
							if (Rev)
							RealVolt += 10;
							else RealVolt -= 10;
							break;
						}	
						case 3:
						{
							if (Rev)
							RealVolt += 1;
							else RealVolt -= 1;
							break;
						}
					}
					if (RealVolt > 2000)
					{
						RealVolt = 2000;
					}			
				}	
			}
			if (SW3 == 1)
			{
				SW3 = 0;
				i = CPort * 6;
				writeprom(i+2,calc16.high8);
				writeprom(i+3,calc16.low8);
			}	
		}
		
		 // calibrate temperature
		 
		if (MenuItem == 42)	
		{
			SW1 = 1;
		}
		
		// calibrate value electronic potentiometer
		
		if (MenuItem == 43)
		{

			if (upcntr > 3) upcntr = 3;
			{
				if (OldRot != upcntr)
				{
					CPort = upcntr;
					VPot[OldRot] = 0;
					LoadPot(OldRot);
					State[OldRot] = 0;
					un = CPort + 0x31;
					dispval (0,3,1,0,Font6x8);
					OldRot = upcntr;
					State[upcntr] = 0x81;
					Curr[upcntr] = Current;
				}		
			}
			LocValI = CalculeAmp (MesI[CPort],CPort);
			ValI[CPort] = LocValI;
			if (MSClk == 1)
			{
				DispCtr++;
				if (DispCtr == DispRefresh)
				{
					cvhexbcd (LocValI);
					dispval(4,3,4,1,Font6x8);
					cvhexbcd(VPot[CPort]);
					dispval(11,3,3,0,Font6x8);
					calc32 = ValI[CPort];
					calc32 *= 100;
					calc32 /= VPot[CPort];
					calc16.low8 = calc32.low8;
					calc16.high8 = calc32.mid8;	
					cvhexbcd(calc16);
					dispval(9,5,4,0,Font6x8);
					DispCtr = 0;
					
				}
			}
			if (SW3 == 1)	//Memorise value of coef
			{
				calc32 = ValI[CPort];
				calc32 *= 100;
				calc32 /= VPot[CPort];
				calc16.low8 = calc32.low8;
				calc16.high8 = calc32.mid8;	
				i = CPort * 6;
				writeprom(i+4,calc16.high8);
				writeprom(i+5,calc16.low8);		
			}				
			if (SW2	== 1)
			{
				AjTmr = AdjustTimr;
				tempo(50,1);
				TxBuf[0]='1';		// sets all relays to off
				TxBuf[1]=0;		// one measure for the 4 ports
				if (RCIF) i=RCREG1;
				TxData();
				RcvData();		
				while (StatSw2 == 1) HandelKeys();
				SW1 = 1;
				SW2 = 0;
			}
			AdjustI(MSClk,1);	
		}
		
	}	
	
}