
; CC5X Version 3.8, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************   5. Jul 2021   7:54  *************

        processor  16F1825
        radix  DEC

        __config 0x8007, 0x9C4
        __config 0x8008, 0x3EFF

INDF0       EQU   0x00
STATUS      EQU   0x03
FSR0L       EQU   0x04
FSR0H       EQU   0x05
INTCON      EQU   0x0B
Carry       EQU   0
Zero_       EQU   2
PORTA       EQU   0x0C
PORTC       EQU   0x0E
PIR1        EQU   0x11
TMR1L       EQU   0x16
TMR1H       EQU   0x17
T1CON       EQU   0x18
T1GCON      EQU   0x19
PR2         EQU   0x1B
T2CON       EQU   0x1C
TRISA       EQU   0x8C
TRISC       EQU   0x8E
PIE1        EQU   0x91
OPTION_REG  EQU   0x95
PCON        EQU   0x96
OSCTUNE     EQU   0x98
OSCCON      EQU   0x99
OSCSTAT     EQU   0x9A
ADRESL      EQU   0x9B
ADRESH      EQU   0x9C
ADCON0      EQU   0x9D
ADCON1      EQU   0x9E
LATA        EQU   0x10C
LATC        EQU   0x10E
FVRCON      EQU   0x117
ANSELA      EQU   0x18C
ANSELC      EQU   0x18E
EEADRL      EQU   0x191
EEADRH      EQU   0x192
EEDATL      EQU   0x193
EEDATH      EQU   0x194
EECON2      EQU   0x196
RCREG       EQU   0x199
TXREG       EQU   0x19A
SPBRGL      EQU   0x19B
SPBRGH      EQU   0x19C
RCSTA       EQU   0x19D
TXSTA       EQU   0x19E
BAUDCON     EQU   0x19F
WPUA        EQU   0x20C
WPUC        EQU   0x20E
STKPTR      EQU   0xFED
PEIE        EQU   6
GIE         EQU   7
TMR2IF      EQU   1
TXIF        EQU   4
RCIF        EQU   5
ADIF        EQU   6
EEIF        EQU   4
TMR1ON      EQU   0
TMR1IE      EQU   0
TMR2IE      EQU   1
RCIE        EQU   5
ADIE        EQU   6
EEIE        EQU   4
GO          EQU   1
RD          EQU   0
WR          EQU   1
WREN        EQU   2
FREE        EQU   4
LWLO        EQU   5
CFGS        EQU   6
EEPGD       EQU   7
TRMT        EQU   1
cntms       EQU   0x20
ADRes       EQU   0x22
secflg      EQU   0
msflg       EQU   1
OpsMS       EQU   2
timer1      EQU   3
tempoms     EQU   0x25
NbrLoopL    EQU   0x27
CtrLoopL    EQU   0x29
NbrLoopH    EQU   0x2B
CtrLoopH    EQU   0x2C
NewMsg      EQU   4
MsgComplete EQU   5
TxDataFlg   EQU   6
BufPtrRx    EQU   0x2D
RData       EQU   0x2F
RxBuf       EQU   0x31
TxBuf       EQU   0x37
CoefA       EQU   0x41
CoefB       EQU   0x44
CoefC       EQU   0x47
Bat1        EQU   0xC3
Bat2        EQU   0xC5
Bat3        EQU   0xC7
Bat4        EQU   0xC9
TempADC     EQU   0xCB
Temp        EQU   0xCD
NextANP     EQU   0xCF
SlvState    EQU   0xD0
ctr         EQU   0xD1
tmradc      EQU   0xD3
durationms  EQU   0xA0
locked      EQU   0
i           EQU   0xA4
i_2         EQU   0xA2
j           EQU   0xA3
i_3         EQU   0xA2
FpFlags     EQU   0xD4
FpOverflow  EQU   1
FpUnderFlow EQU   2
FpDiv0      EQU   3
FpDomainError EQU   5
FpRounding  EQU   6
arg1f24     EQU   0xAE
arg2f24     EQU   0xB1
aarg        EQU   0xBF
sign        EQU   0xC1
counter     EQU   0xC2
aarg_2      EQU   0xBF
sign_2      EQU   0xC1
counter_2   EQU   0xC2
xtra        EQU   0xBF
temp        EQU   0xC0
expo        EQU   0xC1
sign_3      EQU   0xC2
expo_2      EQU   0xBF
xtra_2      EQU   0xC0
sign_4      EQU   0xC1
rval        EQU   0xAE
sign_6      EQU   0xB4
expo_4      EQU   0xB5
xtra_4      EQU   0xB6
rval_3      EQU   0xAE
savedFlags  EQU   0xB4
xexp        EQU   0xB5
d           EQU   0xB6
c           EQU   0xB9
e           EQU   0xBC
calc_2      EQU   0xA2
calc1       EQU   0xA5
calc2       EQU   0xA8
ValCTN      EQU   0xAB
boot_OK     EQU   0
rxdata      EQU   0x1B9
bi          EQU   0x1BA
boot_tp     EQU   0x1BB
dmpadrh     EQU   0x1BC
dmpadrl     EQU   0x1BD
dmpdathrd   EQU   0x1BE
dmpdatlrd   EQU   0x1BF
dmpdathwr   EQU   0x1C0
dmpdatlwr   EQU   0x1C1
boot_bufflash EQU   0x220
rcvdata     EQU   0x1A0
i_6         EQU   0x1A1
BCC         EQU   0x1A3
boot_fadr   EQU   0x1A4
OutRng      EQU   0
kflash      EQU   0x1A9
fadr        EQU   0x1AB
k           EQU   0x1AF
pointr      EQU   0x1B3
svfadr      EQU   0x1B4
locadr      EQU   0x1B6
fadr_2      EQU   0x1AB
j_6         EQU   0x1AE
k_2         EQU   0x1AF
l_2         EQU   0x1B0
m_2         EQU   0x1B1
n_2         EQU   0x1B2
pointr_2    EQU   0x1B3
svfadr_2    EQU   0x1B4
outcar      EQU   0x1AB

        GOTO main

  ; FILE DischrgSlv.c
                        ;/* Processor accessory for relays */
                        ;
                        ;#include "int16Cxx.h"
                        ;#include "DischrgSlv.h"
                        ;
                        ;#pragma origin 4
        ORG 0x0004
                        ;interrupt intsrvc (void)
                        ;
                        ;{
intsrvc
                        ;	int_save_registers	//auto saved by this pic, but clears PCLATH 
        MOVLP 0
                        ;//	PCLATH = 0;
                        ;// ***** get analog values
                        ;
                        ;	if (ADIF)		
        MOVLB 0
        BTFSS 0x11,ADIF
        GOTO  m006
                        ;	{
                        ;		ADIF = 0;
        BCF   0x11,ADIF
                        ;		ADRes.high8= ADRESH;
        MOVLB 1
        MOVF  ADRESH,W
        MOVLB 0
        MOVWF ADRes+1
                        ;		ADRes.low8 = ADRESL;
        MOVLB 1
        MOVF  ADRESL,W
        MOVLB 0
        MOVWF ADRes
                        ;		switch (NextANP)
        MOVLB 1
        MOVF  NextANP,W
        BTFSC 0x03,Zero_
        GOTO  m001
        XORLW 1
        BTFSC 0x03,Zero_
        GOTO  m002
        XORLW 3
        BTFSC 0x03,Zero_
        GOTO  m003
        XORLW 1
        BTFSC 0x03,Zero_
        GOTO  m004
        XORLW 7
        BTFSC 0x03,Zero_
        GOTO  m005
        GOTO  m006
                        ;		{
                        ;			case 0:
                        ;			{
                        ;				Bat1 = ADRes;
m001    MOVLB 0
        MOVF  ADRes,W
        MOVLB 1
        MOVWF Bat1
        MOVLB 0
        MOVF  ADRes+1,W
        MOVLB 1
        MOVWF Bat1+1
                        ;				break;
        GOTO  m006
                        ;			}
                        ;			case 1:
                        ;			{
                        ;				Bat2 = ADRes;
m002    MOVLB 0
        MOVF  ADRes,W
        MOVLB 1
        MOVWF Bat2
        MOVLB 0
        MOVF  ADRes+1,W
        MOVLB 1
        MOVWF Bat2+1
                        ;				break;
        GOTO  m006
                        ;			}		
                        ;			case 2:
                        ;			{
                        ;				Bat3 = ADRes;
m003    MOVLB 0
        MOVF  ADRes,W
        MOVLB 1
        MOVWF Bat3
        MOVLB 0
        MOVF  ADRes+1,W
        MOVLB 1
        MOVWF Bat3+1
                        ;				break;
        GOTO  m006
                        ;			}
                        ;			case 3:
                        ;			{
                        ;				Bat4 = ADRes;
m004    MOVLB 0
        MOVF  ADRes,W
        MOVLB 1
        MOVWF Bat4
        MOVLB 0
        MOVF  ADRes+1,W
        MOVLB 1
        MOVWF Bat4+1
                        ;				break;
        GOTO  m006
                        ;			}
                        ;			case 4:
                        ;			{
                        ;				TempADC	= ADRes;
m005    MOVLB 0
        MOVF  ADRes,W
        MOVLB 1
        MOVWF TempADC
        MOVLB 0
        MOVF  ADRes+1,W
        MOVLB 1
        MOVWF TempADC+1
                        ;				SlvState.3 = 1;
        BSF   SlvState,3
                        ;				break;
                        ;			}	
                        ;		}
                        ;
                        ;	}
                        ;	
                        ;// ***** real time 1 ms clock		
                        ;	if (TMR2IF == 1)	
m006    MOVLB 0
        BTFSS 0x11,TMR2IF
        GOTO  m008
                        ;	{
                        ;		msflg = 1;
        BSF   0x24,msflg
                        ;		TMR2IF = 0;
        BCF   0x11,TMR2IF
                        ;		cntms ++;
        INCF  cntms,1
        BTFSC 0x03,Zero_
        INCF  cntms+1,1
                        ;		if (cntms == 1000)
        MOVF  cntms,W
        XORLW 232
        BTFSS 0x03,Zero_
        GOTO  m007
        MOVF  cntms+1,W
        XORLW 3
        BTFSS 0x03,Zero_
        GOTO  m007
                        ;		{
                        ;			NbrLoopL = CtrLoopL;
        MOVF  CtrLoopL,W
        MOVWF NbrLoopL
        MOVF  CtrLoopL+1,W
        MOVWF NbrLoopL+1
                        ;			NbrLoopH = CtrLoopH;
        MOVF  CtrLoopH,W
        MOVWF NbrLoopH
                        ;			CtrLoopL = 0;
        CLRF  CtrLoopL
        CLRF  CtrLoopL+1
                        ;			CtrLoopH = 0;
        CLRF  CtrLoopH
                        ;			cntms = 0;
        CLRF  cntms
        CLRF  cntms+1
                        ;			secflg = 1;
        BSF   0x24,secflg
                        ;		}	
                        ;// tempo 
                        ;		if (timer1 == 1)
m007    MOVLB 0
        BTFSS 0x24,timer1
        GOTO  m008
                        ;		{
                        ;			tempoms--;
        DECF  tempoms,1
        INCF  tempoms,W
        BTFSC 0x03,Zero_
        DECF  tempoms+1,1
                        ;			if (tempoms == 0)
        MOVF  tempoms,W
        IORWF tempoms+1,W
        BTFSC 0x03,Zero_
                        ;			{
                        ;				timer1 = 0;
        BCF   0x24,timer1
                        ;			}
                        ;		}
                        ;	}
                        ;
                        ;// ***** SRL data rcvd 
                        ;
                        ;	if (RCIF == 1)  
m008    MOVLB 0
        BTFSS 0x11,RCIF
        GOTO  m010
                        ;	{
                        ;		RData = RCREG;
        MOVLB 3
        MOVF  RCREG,W
        MOVLB 0
        MOVWF RData
                        ;		if (NewMsg == 1)
        BTFSS 0x24,NewMsg
        GOTO  m009
                        ;		{
                        ;			if (RData == 0x55)	//start of frame
        MOVF  RData,W
        XORLW 85
        BTFSS 0x03,Zero_
        GOTO  m010
                        ;			{
                        ;				BufPtrRx = 0;
        CLRF  BufPtrRx
                        ;				NewMsg = 0;
        BCF   0x24,NewMsg
                        ;			}
                        ;		}
                        ;		else
        GOTO  m010
                        ;		{
                        ;			if (MsgComplete == 0)
m009    MOVLB 0
        BTFSC 0x24,MsgComplete
        GOTO  m010
                        ;			{
                        ;				RxBuf[BufPtrRx] = RData;
        MOVLW 49
        ADDWF BufPtrRx,W
        MOVWF FSR0L
        CLRF  FSR0H
        MOVF  RData,W
        MOVWF INDF0
                        ;				BufPtrRx++;
        INCF  BufPtrRx,1
                        ;				if (BufPtrRx == 5)	// all msgs = 5 char, 00 must be added to complete 
        MOVF  BufPtrRx,W
        XORLW 5
        BTFSS 0x03,Zero_
        GOTO  m010
                        ;				{
                        ;					MsgComplete = 1;
        BSF   0x24,MsgComplete
                        ;					NewMsg = 1;
        BSF   0x24,NewMsg
                        ;				}
                        ;			}
                        ;			// else previous data not processed so block ignored	
                        ;		}		
                        ;	}
                        ;	int_restore_registers		//only for completness, no code generated
                        ;}   // end interupt
m010    RETFIE
                        ;
                        ;
                        ;void tempo (uns16 durationms,bit locked)		// max 65 sec but no validity check on param
                        ;{
tempo
                        ;	tempoms = durationms + 1; 
        MOVLB 1
        MOVF  durationms+1,W
        MOVLB 0
        MOVWF tempoms+1
        MOVLB 1
        INCF  durationms,W
        MOVLB 0
        MOVWF tempoms
        BTFSC 0x03,Zero_
        INCF  tempoms+1,1
                        ;	timer1 = 1;
        BSF   0x24,timer1
                        ;	if (locked)
        MOVLB 1
        BTFSS 0xA2,locked
        GOTO  m012
                        ;	while (timer1);
m011    MOVLB 0
        BTFSC 0x24,timer1
        GOTO  m011
                        ;} 
m012    RETURN
                        ;
                        ;
                        ;void TxData(void)
                        ;{
TxData
                        ;	char i;
                        ;
                        ;	while (TXIF != 1);
m013    MOVLB 0
        BTFSS 0x11,TXIF
        GOTO  m013
                        ;	TXREG = 0xAA;
        MOVLW 170
        MOVLB 3
        MOVWF TXREG
                        ;	for (i=0; i!=5;i++)
        MOVLB 1
        CLRF  i
m014    MOVLB 1
        MOVF  i,W
        XORLW 5
        BTFSC 0x03,Zero_
        GOTO  m016
                        ;	{
                        ;		while (TXIF != 1);
m015    MOVLB 0
        BTFSS 0x11,TXIF
        GOTO  m015
                        ;		TXREG = TxBuf[i];
        MOVLW 55
        MOVLB 1
        ADDWF i,W
        MOVWF FSR0L
        CLRF  FSR0H
        MOVF  INDF0,W
        MOVLB 3
        MOVWF TXREG
                        ;	}
        MOVLB 1
        INCF  i,1
        GOTO  m014
                        ;	for (i=0;i!=5;i++)		//prepare pading of 0's for next tx
m016    MOVLB 1
        CLRF  i
m017    MOVLB 1
        MOVF  i,W
        XORLW 5
        BTFSC 0x03,Zero_
        GOTO  m018
                        ;	{
                        ;		TxBuf[i] = 0;
        MOVLW 55
        ADDWF i,W
        MOVWF FSR0L
        CLRF  FSR0H
        CLRF  INDF0
                        ;	}
        INCF  i,1
        GOTO  m017
                        ;	TxDataFlg = 0;			
m018    MOVLB 0
        BCF   0x24,TxDataFlg
                        ;}	
        RETURN
                        ;#pragma codepage 0
                        ;void ProcCmd (void)
                        ;{
ProcCmd
                        ;	char i,j;
                        ;	// poll msgcomplete
                        ;	if (MsgComplete == 1)
        MOVLB 0
        BTFSS 0x24,MsgComplete
        GOTO  m039
                        ;	{
                        ;		i = RxBuf[0];	// command code
        MOVF  RxBuf,W
        MOVLB 1
        MOVWF i_2
                        ;		// here process rcvd datas
                        ;		switch (i)
        MOVF  i_2,W
        XORLW 49
        BTFSC 0x03,Zero_
        GOTO  m019
        XORLW 51
        BTFSC 0x03,Zero_
        GOTO  m026
        XORLW 1
        BTFSC 0x03,Zero_
        GOTO  m027
        XORLW 7
        BTFSC 0x03,Zero_
        GOTO  m028
        XORLW 1
        BTFSC 0x03,Zero_
        GOTO  m029
        XORLW 3
        BTFSC 0x03,Zero_
        GOTO  m030
        XORLW 1
        BTFSC 0x03,Zero_
        GOTO  m031
        XORLW 15
        BTFSC 0x03,Zero_
        GOTO  m032
        XORLW 1
        BTFSC 0x03,Zero_
        GOTO  m033
        XORLW 3
        BTFSC 0x03,Zero_
        GOTO  m034
        XORLW 1
        BTFSC 0x03,Zero_
        GOTO  m035
        GOTO  m036
                        ;		{
                        ;			case 0x31:		// action relay
                        ;			{
                        ;				j = RxBuf[1];
m019    MOVLB 0
        MOVF  RxBuf+1,W
        MOVLB 1
        MOVWF j
                        ;				Rel1 = j.0;
        BTFSS j,0
        GOTO  m020
        MOVLB 2
        BSF   LATC,1
        GOTO  m021
m020    MOVLB 2
        BCF   LATC,1
                        ;				Rel2 = j.1;
m021    MOVLB 1
        BTFSS j,1
        GOTO  m022
        MOVLB 2
        BSF   LATC,2
        GOTO  m023
m022    MOVLB 2
        BCF   LATC,2
                        ;				Rel3 = j.2;
m023    MOVLB 1
        BTFSS j,2
        GOTO  m024
        MOVLB 2
        BSF   LATC,3
        GOTO  m025
m024    MOVLB 2
        BCF   LATC,3
                        ;				TxDataFlg = 1;
m025    MOVLB 0
        BSF   0x24,TxDataFlg
                        ;				TxBuf[0] = 'A';
        MOVLW 65
        MOVWF TxBuf
                        ;				TxData();
        CALL  TxData
                        ;				break;
        GOTO  m036
                        ;			}
                        ;			case 2:		// tx Val Bat 1
                        ;			{
                        ;				TxBuf[0] = 2;
m026    MOVLW 2
        MOVLB 0
        MOVWF TxBuf
                        ;				TxBuf[1] = Bat1.high8;
        MOVLB 1
        MOVF  Bat1+1,W
        MOVLB 0
        MOVWF TxBuf+1
                        ;				TxBuf[2] = Bat1.low8;
        MOVLB 1
        MOVF  Bat1,W
        MOVLB 0
        MOVWF TxBuf+2
                        ;				TxDataFlg = 1;
        BSF   0x24,TxDataFlg
                        ;				TxData();
        CALL  TxData
                        ;				break;
        GOTO  m036
                        ;			}		
                        ;			case 3:		// tx Val Bat 2
                        ;			{
                        ;				TxBuf[0] = 3;
m027    MOVLW 3
        MOVLB 0
        MOVWF TxBuf
                        ;				TxBuf[1] = Bat2.high8;
        MOVLB 1
        MOVF  Bat2+1,W
        MOVLB 0
        MOVWF TxBuf+1
                        ;				TxBuf[2] = Bat2.low8;
        MOVLB 1
        MOVF  Bat2,W
        MOVLB 0
        MOVWF TxBuf+2
                        ;				TxDataFlg = 1;
        BSF   0x24,TxDataFlg
                        ;				TxData();
        CALL  TxData
                        ;				break;
        GOTO  m036
                        ;			}		
                        ;			case 4:
                        ;			{
                        ;				TxBuf[0] = 4;
m028    MOVLW 4
        MOVLB 0
        MOVWF TxBuf
                        ;				TxBuf[1] = Bat3.high8;
        MOVLB 1
        MOVF  Bat3+1,W
        MOVLB 0
        MOVWF TxBuf+1
                        ;				TxBuf[2] = Bat3.low8;
        MOVLB 1
        MOVF  Bat3,W
        MOVLB 0
        MOVWF TxBuf+2
                        ;				TxDataFlg = 1;
        BSF   0x24,TxDataFlg
                        ;				TxData();
        CALL  TxData
                        ;				break;
        GOTO  m036
                        ;			}		
                        ;			case 5:		// tx Val Bat 3
                        ;			{
                        ;				TxBuf[0] = 5;
m029    MOVLW 5
        MOVLB 0
        MOVWF TxBuf
                        ;				TxBuf[1] = Bat4.high8;
        MOVLB 1
        MOVF  Bat4+1,W
        MOVLB 0
        MOVWF TxBuf+1
                        ;				TxBuf[2] = Bat4.low8;
        MOVLB 1
        MOVF  Bat4,W
        MOVLB 0
        MOVWF TxBuf+2
                        ;				TxDataFlg = 1;
        BSF   0x24,TxDataFlg
                        ;				TxData();
        CALL  TxData
                        ;				break;
        GOTO  m036
                        ;			}	
                        ;			case 6:		// tx Val Temp, must be valid
                        ;			{
                        ;				TxBuf[0] = 6;
m030    MOVLW 6
        MOVLB 0
        MOVWF TxBuf
                        ;				TxBuf[1] = TempADC.high8;
        MOVLB 1
        MOVF  TempADC+1,W
        MOVLB 0
        MOVWF TxBuf+1
                        ;				TxBuf[2] = TempADC.low8;
        MOVLB 1
        MOVF  TempADC,W
        MOVLB 0
        MOVWF TxBuf+2
                        ;				TxDataFlg = 1;
        BSF   0x24,TxDataFlg
                        ;				TxData();
        CALL  TxData
                        ;				break;	
        GOTO  m036
                        ;			}				
                        ;			case 7:		// send status
                        ;			{
                        ;				TxBuf[0] = 7;
m031    MOVLW 7
        MOVLB 0
        MOVWF TxBuf
                        ;				j = PORTC;
        MOVF  PORTC,W
        MOVLB 1
        MOVWF j
                        ;				j &= 0x0F;
        MOVLW 15
        ANDWF j,1
                        ;				j *= 16;
        SWAPF j,W
        ANDLW 240
        MOVWF j
                        ;				SlvState &= 0x0F;
        MOVLW 15
        ANDWF SlvState,1
                        ;				SlvState |= j;
        MOVF  j,W
        IORWF SlvState,1
                        ;				TxBuf[1] = SlvState;
        MOVF  SlvState,W
        MOVLB 0
        MOVWF TxBuf+1
                        ;				TxBuf[2] = NbrLoopH;
        MOVF  NbrLoopH,W
        MOVWF TxBuf+2
                        ;				TxBuf[3] = NbrLoopL.high8;
        MOVF  NbrLoopL+1,W
        MOVWF TxBuf+3
                        ;				TxBuf[4] = NbrLoopL.low8;
        MOVF  NbrLoopL,W
        MOVWF TxBuf+4
                        ;				TxDataFlg = 1;
        BSF   0x24,TxDataFlg
                        ;				TxData();
        CALL  TxData
                        ;				SlvState = 1;	//will be updated again after all data collection done
        MOVLW 1
        MOVLB 1
        MOVWF SlvState
                        ;				break;
        GOTO  m036
                        ;			}	
                        ;			case 8:
                        ;			{
                        ;				TxBuf[0] = 8;
m032    MOVLW 8
        MOVLB 0
        MOVWF TxBuf
                        ;				TxBuf[1] = Temp.high8;
        MOVLB 1
        MOVF  Temp+1,W
        MOVLB 0
        MOVWF TxBuf+1
                        ;				TxBuf[2] = Temp.low8;
        MOVLB 1
        MOVF  Temp,W
        MOVLB 0
        MOVWF TxBuf+2
                        ;				TxBuf[3] = TMR1H;
        MOVF  TMR1H,W
        MOVWF TxBuf+3
                        ;				TxBuf[4] = TMR1L;
        MOVF  TMR1L,W
        MOVWF TxBuf+4
                        ;				TxDataFlg = 1;
        BSF   0x24,TxDataFlg
                        ;				TxData();
        CALL  TxData
                        ;				break;
        GOTO  m036
                        ;			}
                        ;
                        ;			case 9:
                        ;			{	
                        ;				TxBuf[0] = 9;
m033    MOVLW 9
        MOVLB 0
        MOVWF TxBuf
                        ;				CoefA.high8 = RxBuf[1];
        MOVF  RxBuf+1,W
        MOVWF CoefA+2
                        ;				CoefA.mid8 = RxBuf[2];
        MOVF  RxBuf+2,W
        MOVWF CoefA+1
                        ;				CoefA.low8 = RxBuf[3];
        MOVF  RxBuf+3,W
        MOVWF CoefA
                        ;				TxDataFlg = 1;
        BSF   0x24,TxDataFlg
                        ;				TxData();
        CALL  TxData
                        ;				break;
        GOTO  m036
                        ;			}
                        ;			case 10:
                        ;			{	
                        ;				TxBuf[0] = 10;
m034    MOVLW 10
        MOVLB 0
        MOVWF TxBuf
                        ;				CoefB.high8 = RxBuf[1];
        MOVF  RxBuf+1,W
        MOVWF CoefB+2
                        ;				CoefB.mid8 = RxBuf[2];
        MOVF  RxBuf+2,W
        MOVWF CoefB+1
                        ;				CoefB.low8 = RxBuf[3];
        MOVF  RxBuf+3,W
        MOVWF CoefB
                        ;				TxDataFlg = 1;
        BSF   0x24,TxDataFlg
                        ;				TxData();
        CALL  TxData
                        ;				break;
        GOTO  m036
                        ;			}			
                        ;			case 11:
                        ;			{	
                        ;				TxBuf[0] = 11;
m035    MOVLW 11
        MOVLB 0
        MOVWF TxBuf
                        ;				CoefC.high8 = RxBuf[1];
        MOVF  RxBuf+1,W
        MOVWF CoefC+2
                        ;				CoefC.mid8 = RxBuf[2];
        MOVF  RxBuf+2,W
        MOVWF CoefC+1
                        ;				CoefC.low8 = RxBuf[3];
        MOVF  RxBuf+3,W
        MOVWF CoefC
                        ;				TxDataFlg = 1;
        BSF   0x24,TxDataFlg
                        ;				TxData();
        CALL  TxData
                        ;				break;
                        ;			}												
                        ;		}
                        ;		// then open reception again
                        ;		for (i=0;i!=5;i++)		//prepare pading of 0's for next tx
m036    MOVLB 1
        CLRF  i_2
m037    MOVLB 1
        MOVF  i_2,W
        XORLW 5
        BTFSC 0x03,Zero_
        GOTO  m038
                        ;		{
                        ;			RxBuf[i] = 0;
        MOVLW 49
        ADDWF i_2,W
        MOVWF FSR0L
        CLRF  FSR0H
        CLRF  INDF0
                        ;		}
        INCF  i_2,1
        GOTO  m037
                        ;		MsgComplete = 0;
m038    MOVLB 0
        BCF   0x24,MsgComplete
                        ;	}	
                        ;}	
m039    RETURN
                        ;
                        ;#pragma codepage 0
                        ;void ProcADC(void)
                        ;{
ProcADC
                        ;	char i;
                        ;	
                        ;	while(GO != 0);
m040    MOVLB 1
        BTFSC 0x9D,GO
        GOTO  m040
                        ;		{
                        ;	NextANP++;
        MOVLB 1
        INCF  NextANP,1
                        ;	if (NextANP == 5)
        MOVF  NextANP,W
        XORLW 5
        BTFSS 0x03,Zero_
        GOTO  m041
                        ;	{
                        ;		NextANP= 0;
        CLRF  NextANP
                        ;		SlvState.2 = 1;
        BSF   SlvState,2
                        ;	}
                        ;	if (NextANP == 4) 	ADCON1 = 0b11010000;
m041    MOVLB 1
        MOVF  NextANP,W
        XORLW 4
        BTFSS 0x03,Zero_
        GOTO  m042
        MOVLW 208
        MOVWF ADCON1
                        ;	else 	ADCON1 = 0b11010011;
        GOTO  m043
m042    MOVLW 211
        MOVLB 1
        MOVWF ADCON1
                        ;	i = NextANP * 4;
m043    BCF   0x03,Carry
        MOVLB 1
        RLF   NextANP,W
        MOVWF i_3
        BCF   0x03,Carry
        RLF   i_3,1
                        ;	i = i|0b00000001;
        BSF   i_3,0
                        ;	ADCON0 = i;		// prepare conversion
        MOVF  i_3,W
        MOVWF ADCON0
                        ;	for (i=0;i!=10;i++);	//acquisition time approx 5us
        CLRF  i_3
m044    MOVLB 1
        MOVF  i_3,W
        XORLW 10
        BTFSC 0x03,Zero_
        GOTO  m045
        INCF  i_3,1
        GOTO  m044
                        ;	GO = 1;			// start ADC, interrupt handels result	
m045    MOVLB 1
        BSF   0x9D,GO
                        ;	}
                        ;}	
        RETURN
                        ;
                        ;void MainLoop(void)
                        ;{
MainLoop
                        ;	char i,j;
                        ;	CtrLoopL++;
        MOVLB 0
        INCF  CtrLoopL,1
        BTFSC 0x03,Zero_
        INCF  CtrLoopL+1,1
                        ;	if (Zero_) CtrLoopH++;
        BTFSC 0x03,Zero_
        INCF  CtrLoopH,1
                        ;	ProcCmd();
        CALL  ProcCmd
                        ;	ProcADC();
        CALL  ProcADC
                        ;	if (OpsMS)
        MOVLB 0
        BTFSS 0x24,OpsMS
        GOTO  m047
                        ;	{
                        ;		tmradc++;
        MOVLB 1
        INCF  tmradc,1
                        ;		if (tmradc == 10)		//200 measures per second
        MOVF  tmradc,W
        XORLW 10
        BTFSS 0x03,Zero_
        GOTO  m046
                        ;		{
                        ;			ProcADC();
        CALL  ProcADC
                        ;			tmradc = 0;
        MOVLB 1
        CLRF  tmradc
                        ;	}	
                        ;		ctr++;
m046    MOVLB 1
        INCF  ctr,1
        BTFSC 0x03,Zero_
        INCF  ctr+1,1
                        ;		if (ctr == 1001)		//1 conversion per second
        MOVF  ctr,W
        XORLW 233
        BTFSS 0x03,Zero_
        GOTO  m047
        MOVF  ctr+1,W
        XORLW 3
        BTFSS 0x03,Zero_
        GOTO  m047
                        ;		{
                        ;			ctr = 0;
        CLRF  ctr
        CLRF  ctr+1
                        ;			CalcDegC();
        MOVLP 8
        CALL  CalcDegC
        MOVLP 0
                        ;		}	
                        ;	}
                        ;}
m047    RETURN
                        ;
                        ;#pragma codepage 0
                        ;void Init()
                        ;{
Init
                        ;	OSCCON = 0b01111011;	// 16mhz
        MOVLW 123
        MOVLB 1
        MOVWF OSCCON
                        ;	OSCTUNE = 0;
        CLRF  OSCTUNE
                        ;	PCON = 0;
        CLRF  PCON
                        ;	INTCON = 0;		//  disable all interrupts /
        CLRF  INTCON
                        ;	STATUS = 0;
        CLRF  STATUS
                        ;	// init i/o ports
                        ;	LATA = 0;
        MOVLB 2
        CLRF  LATA
                        ;	LATC = 0;  
        CLRF  LATC
                        ;	TRISA = bin(111111);
        MOVLW 63
        MOVLB 1
        MOVWF TRISA
                        ;	TRISC = bin(11100001);
        MOVLW 225
        MOVWF TRISC
                        ;	OPTION_REG = 0b00000100;		//tmr0 presc 32
        MOVLW 4
        MOVWF OPTION_REG
                        ;	// init periph interrupts
                        ;	PIE1 = bin(00000000); // disabled int  
        CLRF  PIE1
                        ;	PIR1 = 0;
        MOVLB 0
        CLRF  PIR1
                        ;	// init ram to 0
                        ;	clearRAM();
        MOVLW 239
        MOVWF FSR0L
        MOVLW 35
        MOVWF FSR0H
        MOVLW 0
m048    MOVWI INDF0--
        BTFSC FSR0H,5
        GOTO  m048
        MOVWF FSR0H
m049    MOVWI INDF0--
        BTFSC FSR0L,4
        GOTO  m049
                        ;	// config ad converter
                        ;	WPUA = 0;
        MOVLB 4
        CLRF  WPUA
                        ;	WPUC = 0b1110000;
        MOVLW 112
        MOVWF WPUC
                        ;	ADCON0 = 0b00000001;		// adc on 
        MOVLW 1
        MOVLB 1
        MOVWF ADCON0
                        ;	ADCON1 = 0b11010011;		// fosc/16/right justif, ref = intrn vref,
        MOVLW 211
        MOVWF ADCON1
                        ;	ANSELA = 0b00010111;		// PORTA0-2,4 are analog
        MOVLW 23
        MOVLB 3
        MOVWF ANSELA
                        ;	ANSELC = 0b00000001;		// PORTC.0 analog
        MOVLW 1
        MOVWF ANSELC
                        ;	FVRCON = 0b10000011;		//vref = 4.096V
        MOVLW 131
        MOVLB 2
        MOVWF FVRCON
                        ;	ADIE = 1;					//interrupt mode
        MOVLB 1
        BSF   0x91,ADIE
                        ;	// init USART 115.2 Kbps / 8 bits
                        ;	//config USART
                        ;	TXSTA = 0b00100100;
        MOVLW 36
        MOVLB 3
        MOVWF TXSTA
                        ;	RCSTA = 0b10010000;
        MOVLW 144
        MOVWF RCSTA
                        ;	BAUDCON = 0b00001000;
        MOVLW 8
        MOVWF BAUDCON
                        ;	SPBRGL = (char)BAUDGEN;
        MOVLW 33
        MOVWF SPBRGL
                        ;	SPBRGH = 0;
        CLRF  SPBRGH
                        ;	RCIE = 1;					//receive in interrupt mode
        MOVLB 1
        BSF   0x91,RCIE
                        ;	// config timer2, real time clk 1ms
                        ;	T2CON = 0b00000110;			//no postscaler, /16 prescaler
        MOVLW 6
        MOVLB 0
        MOVWF T2CON
                        ;	PR2 = 249;					//for 1ms period
        MOVLW 249
        MOVWF PR2
                        ;	TMR2IE = 1;					//interrupt each ms
        MOVLB 1
        BSF   0x91,TMR2IE
                        ;	// config timer1, performance measure
                        ;	T1CON = 0b00000000;			//instr clk,presc 1,osc off,no sync, tmr off
        MOVLB 0
        CLRF  T1CON
                        ;	T1GCON = 0b00000000;			//no gate control
        CLRF  T1GCON
                        ;	TMR1IE = 0;					//no interrupt
        MOVLB 1
        BCF   0x91,TMR1IE
                        ;	//Turn on interrupts
                        ;	PEIE = 1;
        BSF   0x0B,PEIE
                        ;	GIE = 1;
        BSF   0x0B,GIE
                        ;}
        RETURN
                        ;void InitVar (void)
                        ;{
InitVar
                        ;	NewMsg = 1;
        MOVLB 0
        BSF   0x24,NewMsg
                        ;	MsgComplete = 0;
        BCF   0x24,MsgComplete
                        ;	SlvState = 0;
        MOVLB 1
        CLRF  SlvState
                        ;	TxDataFlg = 0;
        MOVLB 0
        BCF   0x24,TxDataFlg
                        ;	CoefA = CA;
        MOVLW 141
        MOVWF CoefA
        MOVLW 31
        MOVWF CoefA+1
        MOVLW 117
        MOVWF CoefA+2
                        ;	CoefB = CB;
        MOVLW 85
        MOVWF CoefB
        MOVLW 70
        MOVWF CoefB+1
        MOVLW 114
        MOVWF CoefB+2
                        ;	CoefC = CC;
        MOVLW 107
        MOVWF CoefC
        MOVLW 87
        MOVWF CoefC+1
        MOVLW 104
        MOVWF CoefC+2
                        ;}
        RETURN
                        ;
                        ;#pragma codepage 0
                        ;		
                        ;void main (void)
                        ;{
main
                        ;	STKPTR = 0;
        MOVLB 31
        CLRF  STKPTR
                        ;	OSCCON = 0b01101010;	// 4MHz intnl oscilator
        MOVLW 106
        MOVLB 1
        MOVWF OSCCON
                        ;	OSCSTAT = 1;
        MOVLW 1
        MOVWF OSCSTAT
                        ;	ADCON0 = 0;		// All analog ports as digital
        CLRF  ADCON0
                        ;	TRISA.5 = 1;
        BSF   TRISA,5
                        ;	if (PORTA.5 == 0)
        MOVLB 0
        BTFSC PORTA,5
        GOTO  m050
                        ;	{
                        ;#asm
                        ;	MOVLP 0x18
        MOVLP 24
                        ;	call bootprocess
        CALL  bootprocess
                        ;	MOVLP 0 
        MOVLP 0
                        ;#endasm
                        ;	}
                        ;	Init();
m050    CALL  Init
                        ;	InitVar();
        CALL  InitVar
                        ;	//	startup sequence
                        ;	tempo (100,1);
        MOVLW 100
        MOVLB 1
        MOVWF durationms
        CLRF  durationms+1
        BSF   0xA2,locked
        CALL  tempo
                        ;	Rel1 = 1;
        MOVLB 2
        BSF   LATC,1
                        ;	tempo (200,1);
        MOVLW 200
        MOVLB 1
        MOVWF durationms
        CLRF  durationms+1
        BSF   0xA2,locked
        CALL  tempo
                        ;	Rel2 = 1;
        MOVLB 2
        BSF   LATC,2
                        ;	tempo (200,1);
        MOVLW 200
        MOVLB 1
        MOVWF durationms
        CLRF  durationms+1
        BSF   0xA2,locked
        CALL  tempo
                        ;	Rel3 = 1;
        MOVLB 2
        BSF   LATC,3
                        ;	tempo (200,1);
        MOVLW 200
        MOVLB 1
        MOVWF durationms
        CLRF  durationms+1
        BSF   0xA2,locked
        CALL  tempo
                        ;	SlvState = 1;	
        MOVLW 1
        MOVLB 1
        MOVWF SlvState
                        ;	while (1)
                        ;	{
                        ;		if (msflg == 1)
m051    MOVLB 0
        BTFSS 0x24,msflg
        GOTO  m052
                        ;		{
                        ;			OpsMS = 1;
        BSF   0x24,OpsMS
                        ;			msflg = 0;
        BCF   0x24,msflg
                        ;		}	
                        ;		MainLoop();
m052    CALL  MainLoop
                        ;		OpsMS =0;
        MOVLB 0
        BCF   0x24,OpsMS
                        ;	}	
        GOTO  m051
                        ;}
                        ;
                        ;
                        ;#pragma codepage 1
        ORG 0x0800

  ; FILE C:\Users\mr_ro\OneDrive\CC5_8\cc5xfree\MATH24F.H
                        ;// *************************************************
                        ;// 24 bit basic floating point math operations
                        ;// Copyright (c) B Knudsen Data, Norway, 2000 - 2009
                        ;// *************************************************
                        ;
                        ;#pragma library 1
                        ;/* PROTOTYPES for page definition in application header file:
                        ;float24 operator* _fmul24( float24 arg1f24, float24 arg2f24);
                        ;float24 operator/ _fdiv24( float24 arg1f24, float24 arg2f24);
                        ;float24 operator+ _fadd24( float24 arg1f24, float24 arg2f24);
                        ;float24 operator- _fsub24( float24 arg1f24, float24 arg2f24);
                        ;float24 operator= _int24ToFloat24( int24 arg1f24);
                        ;float24 operator= _int32ToFloat24( int32 arg32);
                        ;int24 operator= _float24ToInt24( float24 arg1f24);
                        ;bit operator< _f24_LT_f24( float24 arg1f24, float24 arg2f24);
                        ;bit operator>= _f24_GE_f24( float24 arg1f24, float24 arg2f24);
                        ;bit operator> _f24_GT_f24( float24 arg1f24, float24 arg2f24);
                        ;bit operator<= _f24_LE_f24( float24 arg1f24, float24 arg2f24);
                        ;*/
                        ;
                        ;// DEFINABLE SYMBOLS (in the application code):
                        ;//#define FP_OPTIM_SPEED  // optimize for SPEED: default
                        ;//#define FP_OPTIM_SIZE   // optimize for SIZE
                        ;//#define DISABLE_ROUNDING   // disable rounding and save code space
                        ;
                        ;#define float24ToIEEE754(a) { a.mid8=rl(a.mid8); a.high8=rr(a.high8);\
                        ;                              a.mid8=rr(a.mid8); }
                        ;#define IEEE754ToFloat24(a) { a.mid8=rl(a.mid8); a.high8=rl(a.high8);\
                        ;                              a.mid8=rr(a.mid8); }
                        ;
                        ;
                        ;/*  24 bit floating point format:
                        ;
                        ;  address  ID
                        ;    X      a.low8  : LSB, bit 0-7 of mantissa
                        ;    X+1    a.mid8  : bit 8-14 of mantissa, bit 15 is the sign bit
                        ;    X+2    a.high8 : MSB, bit 0-7 of exponent, with bias 0x7F
                        ;
                        ;    bit 15 of mantissa is a hidden bit, always equal to 1
                        ;    zero (0.0) :  a.high8 = 0 (mantissa & sign ignored)
                        ;
                        ;   MSB    LSB
                        ;    7F 00 00  : 1.0   =  1.0  * 2**(0x7F-0x7F) = 1.0 * 1
                        ;    7F 80 00  : -1.0  = -1.0  * 2**(0x7F-0x7F) = -1.0 * 1
                        ;    80 00 00  : 2.0   =  1.0  * 2**(0x80-0x7F) = 1.0 * 2
                        ;    80 40 00  : 3.0   =  1.5  * 2**(0x80-0x7F) = 1.5 * 2
                        ;    7E 60 00  : 0.875 =  1.75 * 2**(0x7E-0x7F) = 1.75 * 0.5
                        ;    7F 60 00  : 1.75  =  1.75 * 2**(0x7E-0x7F) = 1.75 * 1
                        ;    7F 7F FF  : 1.999969482
                        ;    00 7C 5A  : 0.0 (mantissa & sign ignored)
                        ;    01 00 00  : 1.17549435e-38 =  1.0 * 2**(0x01-0x7F)
                        ;    FE 7F FF  : 3.40277175e+38 =  1.999969482 * 2**(0xFE-0x7F)
                        ;    FF 00 00  : +INF : positive infinity
                        ;    FF 80 00  : -INF : negative infinity
                        ;*/                 
                        ;
                        ;#define  FpBIAS  0x7F
                        ;
                        ;#ifndef FpFlags_defined
                        ; #define FpFlags_defined
                        ;
                        ; char FpFlags;
                        ; //bit IOV         @ FpFlags.0; // integer overflow flag: NOT USED
                        ; bit FpOverflow    @ FpFlags.1; // floating point overflow flag
                        ; bit FpUnderFlow   @ FpFlags.2; // floating point underflow flag
                        ; bit FpDiv0        @ FpFlags.3; // floating point divide by zero flag
                        ; //bit FpNAN       @ FpFlags.4; // not-a-number exception flag: NOT USED
                        ; bit FpDomainError @ FpFlags.5; // domain error exception flag
                        ; bit FpRounding    @ FpFlags.6; // floating point rounding flag, 0=truncation
                        ;                                // 1 = unbiased rounding to nearest LSB
                        ; //bit FpSaturate  @ FpFlags.7; // floating point saturate flag: NOT USED
                        ;
                        ; #pragma floatOverflow FpOverflow
                        ; #pragma floatUnderflow FpUnderFlow
                        ;
                        ; #define InitFpFlags()  FpFlags = 0x40 /* enable rounding as default */
                        ;#endif
                        ;
                        ;#ifdef DISABLE_ROUNDING
                        ; #pragma floatRounding 0
                        ;#endif
                        ;
                        ;
                        ;#if __CoreSet__ < 1410
                        ; #define genAdd(r,a) W=a; btsc(Carry); W=incsz(a); r+=W
                        ; #define genSub(r,a) W=a; btss(Carry); W=incsz(a); r-=W
                        ; #define genAddW(r,a) W=a; btsc(Carry); W=incsz(a); W=r+W
                        ; #define genSubW(r,a) W=a; btss(Carry); W=incsz(a); W=r-W
                        ;#else
                        ; #define genAdd(r,a) W=a; r=addWFC(r)
                        ; #define genSub(r,a) W=a; r=subWFB(r)
                        ; #define genAddW(r,a) W=a; W=addWFC(r)
                        ; #define genSubW(r,a) W=a; W=subWFB(r)
                        ;#endif
                        ;
                        ;
                        ;
                        ;float24 operator* _fmul24( sharedM float24 arg1f24, sharedM float24 arg2f24)
                        ;{
_fmul24
                        ;    uns16 aarg;
                        ;    W = arg1f24.mid8;
        MOVLB 1
        MOVF  arg1f24+1,W
                        ;    aarg.high8 = W;
        MOVWF aarg+1
                        ;
                        ;    // save sign
                        ;    char sign = arg2f24.mid8 ^ W;  // before first overflow test
        XORWF arg2f24+1,W
        MOVWF sign
                        ;
                        ;    W = arg1f24.high8;
        MOVF  arg1f24+2,W
                        ;    if (!Zero_)
        BTFSS 0x03,Zero_
                        ;        W = arg2f24.high8;
        MOVF  arg2f24+2,W
                        ;    if (Zero_)
        BTFSC 0x03,Zero_
                        ;        goto RES0;
        GOTO  m059
                        ;
                        ;    arg1f24.high8 += W /* arg2f24.high8 */;
        MOVLB 1
        ADDWF arg1f24+2,1
                        ;    W = FpBIAS-1;
        MOVLW 126
                        ;    if (Carry)  {
        BTFSS 0x03,Carry
        GOTO  m053
                        ;        arg1f24.high8 -= W;
        SUBWF arg1f24+2,1
                        ;        if (Carry)
        BTFSS 0x03,Carry
        GOTO  m054
                        ;            goto OVERFLOW;
        GOTO  m060
                        ;    }
                        ;    else  {
                        ;        arg1f24.high8 -= W;
m053    MOVLB 1
        SUBWF arg1f24+2,1
                        ;        if (!Carry)
        BTFSS 0x03,Carry
                        ;            goto UNDERFLOW;
        GOTO  m058
                        ;    }
                        ;    aarg.low8 = arg1f24.low8;
m054    MOVLB 1
        MOVF  arg1f24,W
        MOVWF aarg
                        ;
                        ;    aarg.15 = 1;
        BSF   aarg+1,7
                        ;    arg2f24.15 = 1;
        BSF   arg2f24+1,7
                        ;
                        ;    arg1f24.low16 = 0;
        CLRF  arg1f24
        CLRF  arg1f24+1
                        ;
                        ;    char counter = sizeof(aarg)*8;
        MOVLW 16
        MOVWF counter
                        ;
                        ;    do  {
                        ;        aarg = rr( aarg);
m055    MOVLB 1
        RRF   aarg+1,1
        RRF   aarg,1
                        ;        if (Carry)  {
        BTFSS 0x03,Carry
        GOTO  m056
                        ;            arg1f24.low8 += arg2f24.low8;
        MOVF  arg2f24,W
        ADDWF arg1f24,1
                        ;            genAdd( arg1f24.mid8, arg2f24.mid8);
        MOVF  arg2f24+1,W
        ADDWFC arg1f24+1,1
                        ;        }
                        ;        arg1f24.low16 = rr( arg1f24.low16);
m056    MOVLB 1
        RRF   arg1f24+1,1
        RRF   arg1f24,1
                        ;    } while (-- counter > 0);
        DECFSZ counter,1
        GOTO  m055
                        ;
                        ;    if (!arg1f24.15)  {
        BTFSC arg1f24+1,7
        GOTO  m057
                        ;        // catch Carry bit that was shifted out previously
                        ;        arg1f24.low16 = rl( arg1f24.low16);
        RLF   arg1f24,1
        RLF   arg1f24+1,1
                        ;        if (arg1f24.high8 == 0)
        MOVF  arg1f24+2,1
        BTFSC 0x03,Zero_
                        ;            goto UNDERFLOW;
        GOTO  m058
                        ;        arg1f24.high8 -= 1;
        MOVLB 1
        DECF  arg1f24+2,1
                        ;        W = rl( aarg.high8);
        RLF   aarg+1,W
                        ;        // restore bit behind LSB in Carry
                        ;    }
                        ;
                        ;   #ifndef DISABLE_ROUNDING
                        ;    if (FpRounding  &&  Carry)  {
m057    MOVLB 1
        BTFSS 0xD4,FpRounding
        GOTO  m062
        BTFSS 0x03,Carry
        GOTO  m062
                        ;        arg1f24.low8 += 1;
        INCFSZ arg1f24,1
                        ;        if (!arg1f24.low8)  {
        GOTO  m062
                        ;            arg1f24.mid8 += 1;
        INCFSZ arg1f24+1,1
                        ;            if (!arg1f24.mid8)  {
        GOTO  m062
                        ;                // Carry = 1; //OK
                        ;                arg1f24.low16 = rr( arg1f24.low16);
        RRF   arg1f24+1,1
        RRF   arg1f24,1
                        ;                arg1f24.high8 += 1;
        INCFSZ arg1f24+2,1
                        ;                if (Zero_)
        GOTO  m062
                        ;                    goto OVERFLOW;
        GOTO  m060
                        ;            }
                        ;        }
                        ;    }
                        ;   #endif
                        ;    goto SET_SIGN;
                        ;
                        ;  UNDERFLOW:
                        ;    FpUnderFlow = 1;
m058    MOVLB 1
        BSF   0xD4,FpUnderFlow
                        ;  RES0:
                        ;    arg1f24.high8 = 0;
m059    MOVLB 1
        CLRF  arg1f24+2
                        ;    goto MANTISSA;
        GOTO  m061
                        ;
                        ;  OVERFLOW:
                        ;    FpOverflow = 1;
m060    MOVLB 1
        BSF   0xD4,FpOverflow
                        ;    arg1f24.high8 = 0xFF;
        MOVLW 255
        MOVWF arg1f24+2
                        ;  MANTISSA:
                        ;    arg1f24.low16 = 0x8000;
m061    MOVLB 1
        CLRF  arg1f24
        MOVLW 128
        MOVWF arg1f24+1
                        ;
                        ;  SET_SIGN:
                        ;    if (!(sign & 0x80))
m062    MOVLB 1
        BTFSS sign,7
                        ;        arg1f24.15 = 0;
        BCF   arg1f24+1,7
                        ;    return arg1f24;
        MOVLB 1
        MOVF  arg1f24,W
        RETURN
                        ;}
                        ;
                        ;
                        ;
                        ;float24 operator/ _fdiv24( sharedM float24 arg1f24, sharedM float24 arg2f24)
                        ;{
_fdiv24
                        ;    uns16 aarg;
                        ;    W = arg1f24.mid8;
        MOVLB 1
        MOVF  arg1f24+1,W
                        ;    aarg.high8 = W;
        MOVWF aarg_2+1
                        ;
                        ;    // save sign
                        ;    char sign = arg2f24.mid8 ^ W;  // before first overflow test
        XORWF arg2f24+1,W
        MOVWF sign_2
                        ;
                        ;    W = arg2f24.high8;
        MOVF  arg2f24+2,W
                        ;    if (Zero_)
        BTFSC 0x03,Zero_
                        ;        goto Div0;
        GOTO  m073
                        ;    if (!arg1f24.high8)
        MOVLB 1
        MOVF  arg1f24+2,1
        BTFSC 0x03,Zero_
                        ;        goto RES0;
        GOTO  m075
                        ;
                        ;    arg1f24.high8 -= arg2f24.high8;
        MOVLB 1
        MOVF  arg2f24+2,W
        SUBWF arg1f24+2,1
                        ;    W = FpBIAS;
        MOVLW 127
                        ;    if (!Carry)  {
        BTFSC 0x03,Carry
        GOTO  m063
                        ;        arg1f24.high8 += W;
        ADDWF arg1f24+2,1
                        ;        if (!Carry)
        BTFSC 0x03,Carry
        GOTO  m064
                        ;            goto UNDERFLOW;
        GOTO  m074
                        ;    }
                        ;    else  {
                        ;        arg1f24.high8 += W;
m063    MOVLB 1
        ADDWF arg1f24+2,1
                        ;        if (Carry)
        BTFSC 0x03,Carry
                        ;            goto OVERFLOW;
        GOTO  m076
                        ;    }
                        ;
                        ;    aarg.low8 = arg1f24.low8;
m064    MOVLB 1
        MOVF  arg1f24,W
        MOVWF aarg_2
                        ;    aarg.15 = 1;
        BSF   aarg_2+1,7
                        ;    arg2f24.15 = 1;
        BSF   arg2f24+1,7
                        ;
                        ;    // division: shift & add
                        ;    char counter = 16;
        MOVLW 16
        MOVWF counter_2
                        ;    arg1f24.low16 = 0;  // speedup
        CLRF  arg1f24
        CLRF  arg1f24+1
                        ;
                        ;#if defined FP_OPTIM_SPEED || !defined FP_OPTIM_SIZE  // SPEED
                        ;
                        ;    goto START_ML;
        GOTO  m067
                        ;
                        ;  TEST_ZERO_L:
                        ;    W = aarg.low8 - arg2f24.low8;
m065    MOVLB 1
        MOVF  arg2f24,W
        SUBWF aarg_2,W
                        ;    if (!Carry)
        BTFSS 0x03,Carry
                        ;        goto SHIFT_IN_CARRY;
        GOTO  m070
                        ;    aarg.low8 = W;
        MOVLB 1
        MOVWF aarg_2
                        ;    aarg.high8 = 0;
        CLRF  aarg_2+1
                        ;    goto SET_AND_SHIFT_IN_CARRY;
        GOTO  m069
                        ;
                        ;// MAIN LOOP
                        ;    do  {
                        ;      LOOP_ML:
                        ;        if (!Carry)  {
m066    BTFSC 0x03,Carry
        GOTO  m068
                        ;           START_ML:
                        ;            W = aarg.high8 - arg2f24.mid8;
m067    MOVLB 1
        MOVF  arg2f24+1,W
        SUBWF aarg_2+1,W
                        ;            if (Zero_)
        BTFSC 0x03,Zero_
                        ;                goto TEST_ZERO_L;
        GOTO  m065
                        ;            if (!Carry)
        BTFSS 0x03,Carry
                        ;                goto SHIFT_IN_CARRY;
        GOTO  m070
                        ;        }
                        ;        aarg.low8 -= arg2f24.low8;
m068    MOVLB 1
        MOVF  arg2f24,W
        SUBWF aarg_2,1
                        ;        genSub( aarg.high8, arg2f24.mid8);
        MOVF  arg2f24+1,W
        SUBWFB aarg_2+1,1
                        ;      SET_AND_SHIFT_IN_CARRY:
                        ;        Carry = 1;
m069    BSF   0x03,Carry
                        ;      SHIFT_IN_CARRY:
                        ;        arg1f24.low16 = rl( arg1f24.low16);
m070    MOVLB 1
        RLF   arg1f24,1
        RLF   arg1f24+1,1
                        ;        // Carry = 0;  // ok, speedup
                        ;        aarg = rl( aarg);
        RLF   aarg_2,1
        RLF   aarg_2+1,1
                        ;    } while (-- counter > 0);
        DECFSZ counter_2,1
        GOTO  m066
                        ;
                        ;
                        ;
                        ;#else  // SIZE
                        ;
                        ;    goto START_ML;
                        ;
                        ;// MAIN LOOP
                        ;    do  {
                        ;      LOOP_ML:
                        ;        if (Carry)
                        ;            goto SUBTRACT;
                        ;      START_ML:
                        ;        W = aarg.low8 - arg2f24.low8;
                        ;        genSubW( aarg.high8, arg2f24.mid8);
                        ;        if (!Carry)
                        ;            goto SKIP_SUB;
                        ;       SUBTRACT:
                        ;        aarg.low8 -= arg2f24.low8;
                        ;        genSub( aarg.high8, arg2f24.mid8);
                        ;        Carry = 1;
                        ;       SKIP_SUB:
                        ;        arg1f24.low16 = rl( arg1f24.low16);
                        ;        // Carry = 0;  // ok
                        ;        aarg = rl( aarg);
                        ;    } while (-- counter > 0);
                        ;
                        ;#endif
                        ;
                        ;    if (!arg1f24.15)  {
        BTFSC arg1f24+1,7
        GOTO  m071
                        ;        if (!arg1f24.high8)
        MOVF  arg1f24+2,1
        BTFSC 0x03,Zero_
                        ;            goto UNDERFLOW;
        GOTO  m074
                        ;        arg1f24.high8 --;
        MOVLB 1
        DECF  arg1f24+2,1
                        ;        counter ++;
        INCF  counter_2,1
                        ;        goto LOOP_ML;
        GOTO  m066
                        ;    }
                        ;
                        ;   #ifndef DISABLE_ROUNDING
                        ;    if (FpRounding)  {
m071    MOVLB 1
        BTFSS 0xD4,FpRounding
        GOTO  m079
                        ;        if (Carry)
        BTFSC 0x03,Carry
                        ;            goto ADD_1;
        GOTO  m072
                        ;        aarg.low8 -= arg2f24.low8;
        MOVLB 1
        MOVF  arg2f24,W
        SUBWF aarg_2,1
                        ;        genSub( aarg.high8, arg2f24.mid8);
        MOVF  arg2f24+1,W
        SUBWFB aarg_2+1,1
                        ;        if (Carry)  {
        BTFSS 0x03,Carry
        GOTO  m079
                        ;          ADD_1:
                        ;            arg1f24.low8 += 1;
m072    MOVLB 1
        INCFSZ arg1f24,1
                        ;            if (!arg1f24.low8)  {
        GOTO  m079
                        ;                arg1f24.mid8 ++;
        INCFSZ arg1f24+1,1
                        ;                if (!arg1f24.mid8)  {
        GOTO  m079
                        ;                    arg1f24.low16 = rr( arg1f24.low16);
        RRF   arg1f24+1,1
        RRF   arg1f24,1
                        ;                    arg1f24.high8 ++;
        INCFSZ arg1f24+2,1
                        ;                    if (!arg1f24.high8)
        GOTO  m079
                        ;                        goto OVERFLOW;
        GOTO  m076
                        ;                }
                        ;            }
                        ;        }
                        ;    }
                        ;   #endif
                        ;    goto SET_SIGN;
                        ;
                        ;  Div0:
                        ;    FpDiv0 = 1;
m073    MOVLB 1
        BSF   0xD4,FpDiv0
                        ;    goto SATURATE;
        GOTO  m077
                        ;
                        ;  UNDERFLOW:
                        ;    FpUnderFlow = 1;
m074    MOVLB 1
        BSF   0xD4,FpUnderFlow
                        ;  RES0:
                        ;    arg1f24.high8 = 0;
m075    MOVLB 1
        CLRF  arg1f24+2
                        ;    goto MANTISSA;
        GOTO  m078
                        ;
                        ;  OVERFLOW:
                        ;    FpOverflow = 1;
m076    MOVLB 1
        BSF   0xD4,FpOverflow
                        ;  SATURATE:
                        ;    arg1f24.high8 = 0xFF;
m077    MOVLW 255
        MOVLB 1
        MOVWF arg1f24+2
                        ;  MANTISSA:
                        ;    arg1f24.low16 = 0x8000;
m078    MOVLB 1
        CLRF  arg1f24
        MOVLW 128
        MOVWF arg1f24+1
                        ;
                        ;  SET_SIGN:
                        ;    if (!(sign & 0x80))
m079    MOVLB 1
        BTFSS sign_2,7
                        ;        arg1f24.15 = 0;
        BCF   arg1f24+1,7
                        ;    return arg1f24;
        MOVLB 1
        MOVF  arg1f24,W
        RETURN
                        ;}
                        ;
                        ;
                        ;float24 operator+ _fadd24( sharedM float24 arg1f24, sharedM float24 arg2f24)
                        ;{
_fadd24
                        ;    char xtra, temp;
                        ;    char expo = arg1f24.high8 - arg2f24.high8;
        MOVLB 1
        MOVF  arg2f24+2,W
        SUBWF arg1f24+2,W
        MOVWF expo
                        ;    if (!Carry)  {
        BTFSC 0x03,Carry
        GOTO  m080
                        ;        expo = -expo;
        COMF  expo,1
        INCF  expo,1
                        ;        temp = arg1f24.high8;
        MOVF  arg1f24+2,W
        MOVWF temp
                        ;        arg1f24.high8 = arg2f24.high8;
        MOVF  arg2f24+2,W
        MOVWF arg1f24+2
                        ;        arg2f24.high8 = temp;
        MOVF  temp,W
        MOVWF arg2f24+2
                        ;        temp = arg1f24.mid8;
        MOVF  arg1f24+1,W
        MOVWF temp
                        ;        arg1f24.mid8 = arg2f24.mid8;
        MOVF  arg2f24+1,W
        MOVWF arg1f24+1
                        ;        arg2f24.mid8 = temp;
        MOVF  temp,W
        MOVWF arg2f24+1
                        ;        temp = arg1f24.low8;
        MOVF  arg1f24,W
        MOVWF temp
                        ;        arg1f24.low8 = arg2f24.low8;
        MOVF  arg2f24,W
        MOVWF arg1f24
                        ;        arg2f24.low8 = temp;
        MOVF  temp,W
        MOVWF arg2f24
                        ;    }
                        ;    if (expo > sizeof(arg1f24)*8-7)
m080    MOVLW 18
        MOVLB 1
        SUBWF expo,W
        BTFSC 0x03,Carry
                        ;        goto _RETURN_MF;
        GOTO  m098
                        ;    if (!arg2f24.high8)
        MOVLB 1
        MOVF  arg2f24+2,1
        BTFSC 0x03,Zero_
                        ;        goto _RETURN_MF;   // result is arg1f24
        GOTO  m098
                        ;
                        ;    xtra = 0;
        MOVLB 1
        CLRF  xtra
                        ;
                        ;    temp = arg1f24.mid8;
        MOVF  arg1f24+1,W
        MOVWF temp
                        ;    char sign = arg2f24.mid8 ^ arg1f24.mid8;
        MOVF  arg1f24+1,W
        XORWF arg2f24+1,W
        MOVWF sign_3
                        ;    arg1f24.15 = 1;
        BSF   arg1f24+1,7
                        ;    arg2f24.15 = 1;
        BSF   arg2f24+1,7
                        ;
                        ;    while (1)  {
                        ;        W = 8;
m081    MOVLW 8
                        ;        expo -= W;
        MOVLB 1
        SUBWF expo,1
                        ;        if (!Carry)
        BTFSS 0x03,Carry
                        ;            break;
        GOTO  m082
                        ;        xtra = arg2f24.low8;
        MOVLB 1
        MOVF  arg2f24,W
        MOVWF xtra
                        ;        arg2f24.low8 = arg2f24.mid8;
        MOVF  arg2f24+1,W
        MOVWF arg2f24
                        ;        arg2f24.mid8 = 0;
        CLRF  arg2f24+1
                        ;    }
        GOTO  m081
                        ;    expo += W;
m082    MOVLB 1
        ADDWF expo,1
                        ;    if (expo)  {
        BTFSC 0x03,Zero_
        GOTO  m084
                        ;        do  {
                        ;            Carry = 0;
m083    BCF   0x03,Carry
                        ;            arg2f24.low16 = rr( arg2f24.low16);
        MOVLB 1
        RRF   arg2f24+1,1
        RRF   arg2f24,1
                        ;            xtra = rr( xtra);
        RRF   xtra,1
                        ;        } while (--expo > 0);
        DECFSZ expo,1
        GOTO  m083
                        ;    }
                        ;
                        ;
                        ;    if (sign & 0x80)  {
m084    MOVLB 1
        BTFSS sign_3,7
        GOTO  m090
                        ;        // SUBTRACT
                        ;        arg1f24.low8 -= arg2f24.low8;
        MOVF  arg2f24,W
        SUBWF arg1f24,1
                        ;        genSub( arg1f24.mid8, arg2f24.mid8);
        MOVF  arg2f24+1,W
        SUBWFB arg1f24+1,1
                        ;        if (!Carry)  {  // arg2f24 > arg1f24
        BTFSC 0x03,Carry
        GOTO  m085
                        ;            arg1f24.low16 = -arg1f24.low16;
        COMF  arg1f24+1,1
        COMF  arg1f24,1
        INCF  arg1f24,1
        BTFSC 0x03,Zero_
        INCF  arg1f24+1,1
                        ;            // xtra == 0 because arg1f24.exp == arg2f24.exp
                        ;            temp ^= 0x80;  // invert sign
        MOVLW 128
        XORWF temp,1
                        ;        }
                        ;        xtra = -xtra;
m085    MOVLB 1
        COMF  xtra,1
        INCF  xtra,1
                        ;        if (xtra)
        BTFSC 0x03,Zero_
        GOTO  m086
                        ;            arg1f24.low16 --;
        DECF  arg1f24,1
        INCF  arg1f24,W
        BTFSC 0x03,Zero_
        DECF  arg1f24+1,1
                        ;        // adjust result left
                        ;       #define counter expo
                        ;        counter = 3;
m086    MOVLW 3
        MOVLB 1
        MOVWF expo
                        ;        while (!arg1f24.mid8)  {
m087    MOVLB 1
        MOVF  arg1f24+1,1
        BTFSS 0x03,Zero_
        GOTO  m088
                        ;            arg1f24.mid8 = arg1f24.low8;
        MOVF  arg1f24,W
        MOVWF arg1f24+1
                        ;            arg1f24.low8 = xtra;
        MOVF  xtra,W
        MOVWF arg1f24
                        ;            xtra = 0;
        CLRF  xtra
                        ;            arg1f24.high8 -= 8;
        MOVLW 8
        SUBWF arg1f24+2,1
                        ;            if (!Carry)
        BTFSS 0x03,Carry
                        ;                goto RES0;
        GOTO  m094
                        ;            if (--counter == 0)  // max 2 iterations
        MOVLB 1
        DECFSZ expo,1
        GOTO  m087
                        ;                goto RES0;
        GOTO  m094
                        ;        }
                        ;       #undef counter
                        ;        while (!arg1f24.15)  {
m088    MOVLB 1
        BTFSC arg1f24+1,7
        GOTO  m089
                        ;            Carry = 0;
        BCF   0x03,Carry
                        ;            xtra = rl( xtra);
        RLF   xtra,1
                        ;            arg1f24.low16 = rl( arg1f24.low16);
        RLF   arg1f24,1
        RLF   arg1f24+1,1
                        ;            arg1f24.high8 --;
        DECFSZ arg1f24+2,1
                        ;            if (!arg1f24.high8)
        GOTO  m088
                        ;                goto RES0;   // UNDERFLOW?
        GOTO  m094
                        ;        }
                        ;       #ifndef DISABLE_ROUNDING
                        ;        if (FpRounding  &&  (xtra & 0x80))  {
m089    MOVLB 1
        BTFSS 0xD4,FpRounding
        GOTO  m097
        BTFSS xtra,7
        GOTO  m097
                        ;            xtra = 0; // disable recursion
        CLRF  xtra
                        ;            goto INCREMENT;
        GOTO  m093
                        ;        }
                        ;       #endif
                        ;    }
                        ;    else  {
                        ;        // ADD arg1f24 and arg2f24
                        ;        arg1f24.low8 += arg2f24.low8;
m090    MOVLB 1
        MOVF  arg2f24,W
        ADDWF arg1f24,1
                        ;        genAdd( arg1f24.mid8, arg2f24.mid8);
        MOVF  arg2f24+1,W
        ADDWFC arg1f24+1,1
                        ;        if (Carry)  {
        BTFSS 0x03,Carry
        GOTO  m092
                        ;          ADJUST_RIGHT:
                        ;            arg1f24.low16 = rr( arg1f24.low16);
m091    MOVLB 1
        RRF   arg1f24+1,1
        RRF   arg1f24,1
                        ;            xtra = rr( xtra);
        RRF   xtra,1
                        ;            arg1f24.high8 += 1;  // exp
        INCF  arg1f24+2,1
                        ;            if (!arg1f24.high8)
        BTFSC 0x03,Zero_
                        ;                goto OVERFLOW;
        GOTO  m095
                        ;        }
                        ;       #ifndef DISABLE_ROUNDING
                        ;        if (FpRounding  &&  (xtra & 0x80))  {
m092    MOVLB 1
        BTFSS 0xD4,FpRounding
        GOTO  m097
        BTFSS xtra,7
        GOTO  m097
                        ;          INCREMENT:
                        ;            arg1f24.low8 += 1;
m093    MOVLB 1
        INCFSZ arg1f24,1
                        ;            if (!arg1f24.low8)  {
        GOTO  m097
                        ;                arg1f24.mid8 += 1;
        INCFSZ arg1f24+1,1
                        ;                if (!arg1f24.mid8)  {
        GOTO  m097
                        ;                    Carry = 1; // prepare for shift
        BSF   0x03,Carry
                        ;                    arg1f24.0 = 0;  // disable recursion
        BCF   arg1f24,0
                        ;                    goto ADJUST_RIGHT;
        GOTO  m091
                        ;                }
                        ;            }
                        ;        }
                        ;       #endif
                        ;    }
                        ;    goto SET_SIGN;
                        ;
                        ;//  UNDERFLOW:
                        ;//    FpUnderFlow = 1;
                        ;  RES0:
                        ;    arg1f24.high8 = 0;
m094    MOVLB 1
        CLRF  arg1f24+2
                        ;    goto MANTISSA;
        GOTO  m096
                        ;
                        ;  OVERFLOW:
                        ;    FpOverflow = 1;
m095    MOVLB 1
        BSF   0xD4,FpOverflow
                        ;    arg1f24.high8 = 0xFF;
        MOVLW 255
        MOVWF arg1f24+2
                        ;  MANTISSA:
                        ;    arg1f24.low16 = 0x8000;
m096    MOVLB 1
        CLRF  arg1f24
        MOVLW 128
        MOVWF arg1f24+1
                        ;
                        ;  SET_SIGN:
                        ;    if (!(temp & 0x80))
m097    MOVLB 1
        BTFSS temp,7
                        ;        arg1f24.15 = 0;
        BCF   arg1f24+1,7
                        ;
                        ;  _RETURN_MF:
                        ;    return arg1f24;
m098    MOVLB 1
        MOVF  arg1f24,W
        RETURN
                        ;}
                        ;
                        ;
                        ;// SUBTRACTION
                        ;
                        ;float24 operator- _fsub24( sharedM float24 arg1f24, sharedM float24 arg2f24)
                        ;{
_fsub24
                        ;    arg2f24.mid8 ^= 0x80;
        MOVLW 128
        MOVLB 1
        XORWF arg2f24+1,1
                        ;    arg1f24 += arg2f24;
        CALL  _fadd24
                        ;    return arg1f24;
        MOVLB 1
        MOVF  arg1f24,W
        RETURN
                        ;}
                        ;
                        ;
                        ;float24 operator=( int8 arg) @
                        ;float24 operator=( uns8 arg) @
                        ;float24 operator=( int16 arg) @
                        ;float24 operator=( uns16 arg) @
                        ;float24 operator= _int24ToFloat24( sharedM int24 arg1f24)
                        ;{
_int24ToFloat24
                        ;    sharedM float24 arg2f24;   // unused, but required
                        ;    char expo = FpBIAS + 16 - 1;
        MOVLW 142
        MOVLB 1
        MOVWF expo_2
                        ;    char xtra = 0;
        CLRF  xtra_2
                        ;    char sign = 0;
        CLRF  sign_4
                        ;    if (arg1f24 < 0)  {
        BTFSS arg1f24+2,7
        GOTO  m100
                        ;        arg1f24 = -arg1f24;
        COMF  arg1f24+2,1
        COMF  arg1f24+1,1
        COMF  arg1f24,1
        INCFSZ arg1f24,1
        GOTO  m099
        INCF  arg1f24+1,1
        BTFSC 0x03,Zero_
        INCF  arg1f24+2,1
                        ;        sign |= 0x80;
m099    MOVLB 1
        BSF   sign_4,7
                        ;    }
                        ;    if (arg1f24.high8)  {
m100    MOVLB 1
        MOVF  arg1f24+2,1
        BTFSC 0x03,Zero_
        GOTO  m101
                        ;        expo += 8;
        MOVLW 8
        ADDWF expo_2,1
                        ;        xtra = arg1f24.low8;
        MOVF  arg1f24,W
        MOVWF xtra_2
                        ;        arg1f24.low8 = arg1f24.mid8;
        MOVF  arg1f24+1,W
        MOVWF arg1f24
                        ;        arg1f24.mid8 = arg1f24.high8;
        MOVF  arg1f24+2,W
        MOVWF arg1f24+1
                        ;    }
                        ;    else if (!arg1f24.mid8)  {
        GOTO  m103
m101    MOVLB 1
        MOVF  arg1f24+1,1
        BTFSS 0x03,Zero_
        GOTO  m103
                        ;        expo -= 8;
        MOVLW 8
        SUBWF expo_2,1
                        ;        W = arg1f24.low8;
        MOVF  arg1f24,W
                        ;        if (!W)
        BTFSC 0x03,Zero_
                        ;            goto _RETURN_MF;
        GOTO  m105
                        ;        arg1f24.mid8 = W;
        MOVLB 1
        MOVWF arg1f24+1
                        ;        arg1f24.low8 = 0;
        CLRF  arg1f24
                        ;    }
                        ;
                        ;    // arg1f24.mid8 != 0
                        ;    goto TEST_ARG1_B15;
        GOTO  m103
                        ;    do  {
                        ;        xtra = rl( xtra);
m102    MOVLB 1
        RLF   xtra_2,1
                        ;        arg1f24.low16 = rl( arg1f24.low16);
        RLF   arg1f24,1
        RLF   arg1f24+1,1
                        ;        expo --;
        DECF  expo_2,1
                        ;      TEST_ARG1_B15:
                        ;    } while (!arg1f24.15);
m103    MOVLB 1
        BTFSS arg1f24+1,7
        GOTO  m102
                        ;
                        ;   #ifndef DISABLE_ROUNDING
                        ;    if (FpRounding && (xtra & 0x80))  {
        BTFSS 0xD4,FpRounding
        GOTO  m104
        BTFSS xtra_2,7
        GOTO  m104
                        ;        arg1f24.low8 += 1;
        INCFSZ arg1f24,1
                        ;        if (!arg1f24.low8)  {
        GOTO  m104
                        ;            arg1f24.mid8 += 1;
        INCFSZ arg1f24+1,1
                        ;            if (!arg1f24.mid8)  {
        GOTO  m104
                        ;                Carry = 1;
        BSF   0x03,Carry
                        ;                arg1f24.low16 = rr( arg1f24.low16);
        RRF   arg1f24+1,1
        RRF   arg1f24,1
                        ;                expo ++;
        INCF  expo_2,1
                        ;            }
                        ;        }
                        ;    }
                        ;   #endif
                        ;
                        ;    arg1f24.high8 = expo;
m104    MOVLB 1
        MOVF  expo_2,W
        MOVWF arg1f24+2
                        ;    if (!(sign & 0x80))
        BTFSS sign_4,7
                        ;        arg1f24.15 = 0;
        BCF   arg1f24+1,7
                        ;
                        ;  _RETURN_MF:
                        ;    float24 rval @ arg1f24;
                        ;    rval.low24 = arg1f24.low24;
                        ;    return rval;
m105    MOVLB 1
        MOVF  rval,W
        RETURN
                        ;}
                        ;
                        ;
                        ;float24 operator=( uns24 arg) @
                        ;float24 operator= _int32ToFloat24( int32 arg32)
                        ;{
_int32ToFloat24
                        ;    char expo = FpBIAS + 16 - 1;
                        ;    char xtra @ arg32.high8;
                        ;    char sign = 0;
                        ;    if (arg32 < 0)  {
                        ;        arg32 = -arg32;
                        ;        sign |= 0x80;
                        ;    }
                        ;    if (arg32.high8)  {
                        ;        expo += 8;
                        ;        arg32.low8 = arg32.midL8;
                        ;        arg32.midL8 = arg32.midH8;
                        ;        arg32.midH8 = arg32.high8;
                        ;        arg32.high8 = 0;
                        ;    }
                        ;    if (arg32.midH8)  {
                        ;        expo += 8;
                        ;        xtra = arg32.low8;
                        ;        arg32.low8 = arg32.midL8;
                        ;        arg32.midL8 = arg32.midH8;
                        ;    }
                        ;    else if (!arg32.midL8)  {
                        ;        expo -= 8;
                        ;        W = arg32.low8;
                        ;        if (!W)
                        ;            goto _RETURN_MF;
                        ;        arg32.midL8 = W;
                        ;        arg32.low8 = 0;
                        ;    }
                        ;
                        ;    // arg32.midL8 != 0
                        ;    goto TEST_ARG_B15;
                        ;    do  {
                        ;        xtra = rl( xtra);
                        ;        arg32.low16 = rl( arg32.low16);
                        ;        expo --;
                        ;      TEST_ARG_B15:
                        ;    } while (!arg32.15);
                        ;
                        ;   #ifndef DISABLE_ROUNDING
                        ;    if (FpRounding && (xtra & 0x80))  {
                        ;        arg32.low8 += 1;
                        ;        if (!arg32.low8)  {
                        ;            arg32.midL8 += 1;
                        ;            if (!arg32.midL8)  {
                        ;                Carry = 1;
                        ;                arg32.low16 = rr( arg32.low16);
                        ;                expo ++;
                        ;            }
                        ;        }
                        ;    }
                        ;   #endif
                        ;
                        ;    arg32.midH8 = expo;
                        ;    if (!(sign & 0x80))
                        ;        arg32.15 = 0;
                        ;
                        ;  _RETURN_MF:
                        ;    float24 rval @ arg32;
                        ;    rval.low24 = arg32.low24;
                        ;    return rval;
                        ;}
                        ;
                        ;
                        ;uns8 operator=( sharedM float24 arg1f24) @
                        ;int8 operator=( sharedM float24 arg1f24) @
                        ;uns16 operator=( sharedM float24 arg1f24) @
                        ;int16 operator=( sharedM float24 arg1f24) @
                        ;int24 operator= _float24ToInt24( sharedM float24 arg1f24)
                        ;{
_float24ToInt24
                        ;    sharedM float24 arg2f24;   // unused, but required
                        ;    char sign = arg1f24.mid8;
        MOVLB 1
        MOVF  arg1f24+1,W
        MOVWF sign_6
                        ;    char expo = arg1f24.high8 - (FpBIAS-1);
        MOVLW 126
        SUBWF arg1f24+2,W
        MOVWF expo_4
                        ;    if (!Carry)
        BTFSS 0x03,Carry
                        ;        goto RES0;
        GOTO  m111
                        ;    arg1f24.15 = 1;
        MOVLB 1
        BSF   arg1f24+1,7
                        ;
                        ;    arg1f24.high8 = 0;
        CLRF  arg1f24+2
                        ;   #ifndef DISABLE_ROUNDING
                        ;    char xtra = 0;
        CLRF  xtra_4
                        ;   #endif
                        ;
                        ;    // (a): expo = 0..8 : shift 1 byte to the right
                        ;    // (b): expo = 9..16: shift 0 byte
                        ;    // (c): expo = 17..24: shift 1 byte to the left
                        ;   #if __CoreSet__ / 100 == 12
                        ;    expo -= 17;
                        ;    expo = 0xFF - expo;  // COMF (Carry unchanged)
                        ;    if (Carry)  {  // (c)
                        ;   #else
                        ;    expo = 16 - expo;
        MOVF  expo_4,W
        SUBLW 16
        MOVWF expo_4
                        ;    if (!Carry)  {  // (c)
        BTFSC 0x03,Carry
        GOTO  m106
                        ;   #endif
                        ;        expo += 8;
        MOVLW 8
        ADDWF expo_4,1
                        ;        if (!Carry)
        BTFSS 0x03,Carry
                        ;            goto OVERFLOW;
        GOTO  m110
                        ;        arg1f24.high8 = arg1f24.mid8;
        MOVLB 1
        MOVF  arg1f24+1,W
        MOVWF arg1f24+2
                        ;        arg1f24.mid8 = arg1f24.low8;
        MOVF  arg1f24,W
        MOVWF arg1f24+1
                        ;        arg1f24.low8 = 0;
        CLRF  arg1f24
                        ;    }
                        ;    else  {  // (a) (b)
        GOTO  m107
                        ;        // expo = 0 .. 16
                        ;        W = expo - 8;
m106    MOVLW 8
        MOVLB 1
        SUBWF expo_4,W
                        ;        if (Carry)  {  // (a)
        BTFSS 0x03,Carry
        GOTO  m107
                        ;            expo = W;
        MOVWF expo_4
                        ;           #ifndef DISABLE_ROUNDING
                        ;            xtra = arg1f24.low8;
        MOVF  arg1f24,W
        MOVWF xtra_4
                        ;           #endif
                        ;            arg1f24.low8 = arg1f24.mid8;
        MOVF  arg1f24+1,W
        MOVWF arg1f24
                        ;            arg1f24.mid8 = 0;
        CLRF  arg1f24+1
                        ;        }
                        ;    }
                        ;    if (expo)  {
m107    MOVLB 1
        MOVF  expo_4,1
        BTFSC 0x03,Zero_
        GOTO  m109
                        ;        do  {
                        ;            Carry = 0;
m108    BCF   0x03,Carry
                        ;            arg1f24.high8 = rr( arg1f24.high8);
        MOVLB 1
        RRF   arg1f24+2,1
                        ;            arg1f24.low16 = rr( arg1f24.low16);
        RRF   arg1f24+1,1
        RRF   arg1f24,1
                        ;           #ifndef DISABLE_ROUNDING
                        ;            xtra = rr( xtra);
        RRF   xtra_4,1
                        ;           #endif
                        ;        } while (--expo);
        DECFSZ expo_4,1
        GOTO  m108
                        ;    }
                        ;    if (arg1f24.23)  {
m109    MOVLB 1
        BTFSS arg1f24+2,7
        GOTO  m113
                        ;       OVERFLOW:
                        ;        FpOverflow = 1;
m110    MOVLB 1
        BSF   0xD4,FpOverflow
                        ;        W = 0xFF;
        MOVLW 255
                        ;        goto ASSIGNW;
        GOTO  m112
                        ;       RES0:
                        ;        W = 0;
m111    CLRW 
                        ;       ASSIGNW:
                        ;        arg1f24.low8 = W;
m112    MOVLB 1
        MOVWF arg1f24
                        ;        arg1f24.mid8 = W;
        MOVWF arg1f24+1
                        ;        arg1f24.high8 = W;
        MOVWF arg1f24+2
                        ;        arg1f24.23 = 0;
        BCF   arg1f24+2,7
                        ;    }
                        ;    else  {
        GOTO  m115
                        ;       #ifndef DISABLE_ROUNDING
                        ;        if (FpRounding && (xtra & 0x80))  {
m113    MOVLB 1
        BTFSS 0xD4,FpRounding
        GOTO  m114
        BTFSS xtra_4,7
        GOTO  m114
                        ;            arg1f24.low8 += 1;
        INCF  arg1f24,1
                        ;            if (!arg1f24.low8)
        BTFSC 0x03,Zero_
                        ;                arg1f24.mid8 += 1;
        INCF  arg1f24+1,1
                        ;        }
                        ;       #endif
                        ;        if (sign & 0x80)
m114    MOVLB 1
        BTFSS sign_6,7
        GOTO  m115
                        ;            arg1f24.low24 = -arg1f24.low24;
        COMF  arg1f24+2,1
        COMF  arg1f24+1,1
        COMF  arg1f24,1
        INCFSZ arg1f24,1
        GOTO  m115
        INCF  arg1f24+1,1
        BTFSC 0x03,Zero_
        INCF  arg1f24+2,1
                        ;    }
                        ;    int24 rval @ arg1f24;
                        ;    rval = arg1f24.low24;
                        ;    return rval;
m115    MOVLB 1
        MOVF  rval_3,W
        RETURN
                        ;}
                        ;
                        ;
                        ;bit operator< _f24_LT_f24( sharedM float24 arg1f24, sharedM float24 arg2f24)
                        ;{
_f24_LT_f24
                        ;    Carry = 0;
                        ;    if (!(arg1f24.high8 | arg2f24.high8))
                        ;        return Carry;
                        ;    if (!arg1f24.15)  {
                        ;        if (arg2f24.15)
                        ;            return Carry;
                        ;        W = arg1f24.low8 - arg2f24.low8;
                        ;        genSubW( arg1f24.mid8, arg2f24.mid8);
                        ;        genSubW( arg1f24.high8, arg2f24.high8);
                        ;        goto _RETURN_MF;
                        ;    }
                        ;    if (!arg2f24.15)
                        ;        goto _RETURN_MF;
                        ;    W = arg2f24.low8 - arg1f24.low8;
                        ;    genSubW( arg2f24.mid8, arg1f24.mid8);
                        ;    genSubW( arg2f24.high8, arg1f24.high8);
                        ;  _RETURN_MF:
                        ;    if (Carry)
                        ;        return 0;
                        ;    return 1;
                        ;}
                        ;
                        ;
                        ;bit operator>= _f24_GE_f24( sharedM float24 arg1f24, sharedM float24 arg2f24)
                        ;{
_f24_GE_f24
                        ;    Carry = 1;
                        ;    if (!(arg1f24.high8 | arg2f24.high8))
                        ;        return Carry;
                        ;    if (!arg1f24.15)  {
                        ;        if (arg2f24.15)
                        ;            return Carry;
                        ;        W = arg1f24.low8 - arg2f24.low8;
                        ;        genSubW( arg1f24.mid8, arg2f24.mid8);
                        ;        genSubW( arg1f24.high8, arg2f24.high8);
                        ;        return Carry;
                        ;    }
                        ;    Carry = 0;
                        ;    if (!arg2f24.15)
                        ;        return Carry;
                        ;    W = arg2f24.low8 - arg1f24.low8;
                        ;    genSubW( arg2f24.mid8, arg1f24.mid8);
                        ;    genSubW( arg2f24.high8, arg1f24.high8);
                        ;    return Carry;
                        ;}
                        ;
                        ;
                        ;
                        ;bit operator> _f24_GT_f24( sharedM float24 arg1f24, sharedM float24 arg2f24)
                        ;{
_f24_GT_f24
                        ;    Carry = 0;
                        ;    if (!(arg1f24.high8 | arg2f24.high8))
                        ;        return Carry;
                        ;    if (!arg1f24.15)  {
                        ;        if (arg2f24.15)
                        ;            goto _RETURN_MF;
                        ;        W = arg2f24.low8 - arg1f24.low8;
                        ;        genSubW( arg2f24.mid8, arg1f24.mid8);
                        ;        genSubW( arg2f24.high8, arg1f24.high8);
                        ;        goto _RETURN_MF;
                        ;    }
                        ;    if (!arg2f24.15)
                        ;        return Carry;
                        ;    W = arg1f24.low8 - arg2f24.low8;
                        ;    genSubW( arg1f24.mid8, arg2f24.mid8);
                        ;    genSubW( arg1f24.high8, arg2f24.high8);
                        ;  _RETURN_MF:
                        ;    if (Carry)
                        ;        return 0;
                        ;    return 1;
                        ;}
                        ;
                        ;
                        ;
                        ;bit operator<= _f24_LE_f24( sharedM float24 arg1f24, sharedM float24 arg2f24)
                        ;{
_f24_LE_f24
                        ;    Carry = 1;
                        ;    if (!(arg1f24.high8 | arg2f24.high8))
                        ;        return Carry;
                        ;    if (!arg1f24.15)  {
                        ;        Carry = 0;
                        ;        if (arg2f24.15)
                        ;            return Carry;
                        ;        W = arg2f24.low8 - arg1f24.low8;
                        ;        genSubW( arg2f24.mid8, arg1f24.mid8);
                        ;        genSubW( arg2f24.high8, arg1f24.high8);
                        ;        return Carry;
                        ;    }
                        ;    if (!arg2f24.15)
                        ;        return Carry;
                        ;    W = arg1f24.low8 - arg2f24.low8;
                        ;    genSubW( arg1f24.mid8, arg2f24.mid8);
                        ;    genSubW( arg1f24.high8, arg2f24.high8);
                        ;    return Carry;

  ; FILE C:\Users\mr_ro\OneDrive\CC5_8\cc5xfree\MATH24LB.H
                        ;// *************************************************
                        ;// 24 bit floating point math functions
                        ;// Copyright (c) B Knudsen Data, Norway, 2000 - 2009
                        ;// *************************************************
                        ;
                        ;#pragma library 1
                        ;/* PROTOTYPES for page definition in application header file:
                        ;float24 log( float24 arg1f24);
                        ;float24 log10( float24 arg1f24);
                        ;float24 exp10( float24 arg1f24);
                        ;float24 exp( float24 arg1f24);
                        ;float24 cos( float24 arg1f24);
                        ;float24 sin( float24 arg1f24);
                        ;float24 sqrt( float24 arg1f24);
                        ;*/
                        ;
                        ;#ifndef FpFlags_defined
                        ; #error The basic 24 bit floating point math library must be included first
                        ;#endif
                        ;
                        ;#if __CoreSet__ / 100 == 12
                        ; #error Math functions (exp,log,..) are not adapted to 12 bit core devices
                        ;#endif
                        ;
                        ;#if __CoreSet__ < 1410
                        ; #define genAdd(r,a) W=a; btsc(Carry); W=incsz(a); r+=W
                        ; #define genSub(r,a) W=a; btss(Carry); W=incsz(a); r-=W
                        ; #define genAddW(r,a) W=a; btsc(Carry); W=incsz(a); W=r+W
                        ; #define genSubW(r,a) W=a; btss(Carry); W=incsz(a); W=r-W
                        ;#else
                        ; #define genAdd(r,a) W=a; r=addWFC(r)
                        ; #define genSub(r,a) W=a; r=subWFB(r)
                        ; #define genAddW(r,a) W=a; W=addWFC(r)
                        ; #define genSubW(r,a) W=a; W=subWFB(r)
                        ;#endif
                        ;
                        ;
                        ;float24 log( sharedM float24 arg1f24)
                        ;{
log
                        ;    sharedM float24 arg2f24;
                        ;
                        ;    if (arg1f24.mid8 & 0x80)  //  test for negative argument
        MOVLB 1
        BTFSC arg1f24+1,7
                        ;        goto _DOMERR32;
        GOTO  m118
                        ;    if (!arg1f24.high8)   //  test for zero argument
        MOVLB 1
        MOVF  arg1f24+2,1
        BTFSC 0x03,Zero_
                        ;        goto _DOMERR32;
        GOTO  m118
                        ;
                        ;    char savedFlags = FpFlags;   //  save rounding flag
        MOVLB 1
        MOVF  FpFlags,W
        MOVWF savedFlags
                        ;    FpFlags |= 0x40;  //  enable rounding
        BSF   FpFlags,6
                        ;
                        ;    char xexp = arg1f24.high8 - (FpBIAS-1);
        MOVLW 126
        SUBWF arg1f24+2,W
        MOVWF xexp
                        ;    arg1f24.high8 = FpBIAS-1;
        MOVLW 126
        MOVWF arg1f24+2
                        ;
                        ;    arg2f24 = 1.0;
        CLRF  arg2f24
        CLRF  arg2f24+1
        MOVLW 127
        MOVWF arg2f24+2
                        ;
                        ;    //  .70710678118655 = 7E3504F3
                        ;    W = arg1f24.low8 - 0x05;
        MOVLW 5
        SUBWF arg1f24,W
                        ;    W = 0x35;
        MOVLW 53
                        ;    if (!Carry)
        BTFSS 0x03,Carry
                        ;        W = 0x35+1;
        MOVLW 54
                        ;    W = arg1f24.mid8 - W;
        MOVLB 1
        SUBWF arg1f24+1,W
                        ;
                        ;    if (Carry)
        BTFSS 0x03,Carry
        GOTO  m116
                        ;        arg1f24 -= arg2f24;
        CALL  _fsub24
                        ;    else  {
        GOTO  m117
                        ;        arg1f24.high8 += 1;  /* arg1f24 *= 2; */
m116    MOVLB 1
        INCF  arg1f24+2,1
                        ;        arg1f24 -= arg2f24;
        CALL  _fsub24
                        ;        xexp -= 1;
        MOVLB 1
        DECF  xexp,1
                        ;    }
                        ;
                        ;    float24 d = arg1f24;  //  save z
m117    MOVLB 1
        MOVF  arg1f24,W
        MOVWF d
        MOVF  arg1f24+1,W
        MOVWF d+1
        MOVF  arg1f24+2,W
        MOVWF d+2
                        ;
                        ;    // POLL132  LOG32Q,2,0  ; Q(z)
                        ;    arg1f24 += 0.33339502905E+1; /* LOG32Q1 */
        MOVLW 95
        MOVWF arg2f24
        MOVLW 85
        MOVWF arg2f24+1
        MOVLW 128
        MOVWF arg2f24+2
        CALL  _fadd24
                        ;    arg1f24 *= d;
        MOVLB 1
        MOVF  d,W
        MOVWF arg2f24
        MOVF  d+1,W
        MOVWF arg2f24+1
        MOVF  d+2,W
        MOVWF arg2f24+2
        CALL  _fmul24
                        ;    arg1f24 += 0.24993759223E1;  /* LOG32Q0 */
        MOVLW 246
        MOVLB 1
        MOVWF arg2f24
        MOVLW 31
        MOVWF arg2f24+1
        MOVLW 128
        MOVWF arg2f24+2
        CALL  _fadd24
                        ;    float24 c = arg1f24;
        MOVLB 1
        MOVF  arg1f24,W
        MOVWF c
        MOVF  arg1f24+1,W
        MOVWF c+1
        MOVF  arg1f24+2,W
        MOVWF c+2
                        ;
                        ;     //   minimax rational approximation  z-.5*z*z+z*(z*z*P(z)/Q(z))
                        ;    // POL32  LOG32P,1,0  ; P(z)
                        ;    arg1f24 = d;
        MOVF  d,W
        MOVWF arg1f24
        MOVF  d+1,W
        MOVWF arg1f24+1
        MOVF  d+2,W
        MOVWF arg1f24+2
                        ;    arg1f24 *= 0.48646956294; /* LOG32P1 */
        MOVLW 19
        MOVWF arg2f24
        MOVLW 121
        MOVWF arg2f24+1
        MOVLW 125
        MOVWF arg2f24+2
        CALL  _fmul24
                        ;    arg1f24 += 0.83311400452; /* LOG32P0 */
        MOVLW 71
        MOVLB 1
        MOVWF arg2f24
        MOVLW 85
        MOVWF arg2f24+1
        MOVLW 126
        MOVWF arg2f24+2
        CALL  _fadd24
                        ;
                        ;    c = arg1f24 / c;   //  P(z)/Q(z)
        MOVLB 1
        MOVF  c,W
        MOVWF arg2f24
        MOVF  c+1,W
        MOVWF arg2f24+1
        MOVF  c+2,W
        MOVWF arg2f24+2
        CALL  _fdiv24
        MOVLB 1
        MOVF  arg1f24,W
        MOVWF c
        MOVF  arg1f24+1,W
        MOVWF c+1
        MOVF  arg1f24+2,W
        MOVWF c+2
                        ;
                        ;    arg1f24.high8 = d.high8;
        MOVF  d+2,W
        MOVWF arg1f24+2
                        ;    arg2f24.high8 = d.high8;
        MOVF  d+2,W
        MOVWF arg2f24+2
                        ;    arg1f24.mid8 = d.mid8;
        MOVF  d+1,W
        MOVWF arg1f24+1
                        ;    arg2f24.mid8 = d.mid8;
        MOVF  d+1,W
        MOVWF arg2f24+1
                        ;    arg1f24.low8 = d.low8;
        MOVF  d,W
        MOVWF arg1f24
                        ;    arg2f24.low8 = d.low8;
        MOVF  d,W
        MOVWF arg2f24
                        ;    arg1f24 *= arg2f24;       // z * z;
        CALL  _fmul24
                        ;
                        ;    float24 e = arg1f24;
        MOVLB 1
        MOVF  arg1f24,W
        MOVWF e
        MOVF  arg1f24+1,W
        MOVWF e+1
        MOVF  arg1f24+2,W
        MOVWF e+2
                        ;    arg1f24 *= c;          //  z*z*P(z)/Q(z)
        MOVF  c,W
        MOVWF arg2f24
        MOVF  c+1,W
        MOVWF arg2f24+1
        MOVF  c+2,W
        MOVWF arg2f24+2
        CALL  _fmul24
                        ;    arg1f24 *= d;          //  z*(z*z*P(z)/Q(z))
        MOVLB 1
        MOVF  d,W
        MOVWF arg2f24
        MOVF  d+1,W
        MOVWF arg2f24+1
        MOVF  d+2,W
        MOVWF arg2f24+2
        CALL  _fmul24
                        ;
                        ;    arg2f24 = e;
        MOVLB 1
        MOVF  e,W
        MOVWF arg2f24
        MOVF  e+1,W
        MOVWF arg2f24+1
        MOVF  e+2,W
        MOVWF arg2f24+2
                        ;    if (arg2f24.high8)
        MOVF  arg2f24+2,1
        BTFSS 0x03,Zero_
                        ;        arg2f24.high8 --;  // arg2f24 *= 0.5;
        DECF  arg2f24+2,1
                        ;    arg1f24 -= arg2f24;       //  -.5*z*z + z*(z*z*P(z)/Q(z))
        CALL  _fsub24
                        ;    arg1f24 += d;          //  z -.5*z*z + z*(z*z*P(z)/Q(z))
        MOVLB 1
        MOVF  d,W
        MOVWF arg2f24
        MOVF  d+1,W
        MOVWF arg2f24+1
        MOVF  d+2,W
        MOVWF arg2f24+2
        CALL  _fadd24
                        ;
                        ;    if (!xexp)
        MOVLB 1
        MOVF  xexp,1
        BTFSC 0x03,Zero_
                        ;        goto _RETURN_MF;
        GOTO  m119
                        ;
                        ;    e = arg1f24;  //  save
        MOVLB 1
        MOVF  arg1f24,W
        MOVWF e
        MOVF  arg1f24+1,W
        MOVWF e+1
        MOVF  arg1f24+2,W
        MOVWF e+2
                        ;
                        ;    // integer to floating point conversion
                        ;    arg1f24 = (int8) xexp;
        MOVF  xexp,W
        MOVWF arg1f24
        CLRW 
        BTFSC arg1f24,7
        MOVLW 255
        MOVWF arg1f24+1
        MOVWF arg1f24+2
        CALL  _int24ToFloat24
                        ;
                        ;    d = arg1f24;  //  save k
        MOVLB 1
        MOVF  arg1f24,W
        MOVWF d
        MOVF  arg1f24+1,W
        MOVWF d+1
        MOVF  arg1f24+2,W
        MOVWF d+2
                        ;
                        ;    arg1f24 *= -0.000212194440055;
        MOVLW 129
        MOVWF arg2f24
        MOVLW 222
        MOVWF arg2f24+1
        MOVLW 114
        MOVWF arg2f24+2
        CALL  _fmul24
                        ;
                        ;    arg1f24 += e;   //  log(1+z) + k*log(2)
        MOVLB 1
        MOVF  e,W
        MOVWF arg2f24
        MOVF  e+1,W
        MOVWF arg2f24+1
        MOVF  e+2,W
        MOVWF arg2f24+2
        CALL  _fadd24
                        ;
                        ;    e = arg1f24;  //  save
        MOVLB 1
        MOVF  arg1f24,W
        MOVWF e
        MOVF  arg1f24+1,W
        MOVWF e+1
        MOVF  arg1f24+2,W
        MOVWF e+2
                        ;
                        ;    arg1f24 = d * 0.693359375;
        MOVF  d,W
        MOVWF arg1f24
        MOVF  d+1,W
        MOVWF arg1f24+1
        MOVF  d+2,W
        MOVWF arg1f24+2
        MOVLW 128
        MOVWF arg2f24
        MOVLW 49
        MOVWF arg2f24+1
        MOVLW 126
        MOVWF arg2f24+2
        CALL  _fmul24
                        ;
                        ;    arg1f24 += e;      //  log(1+z) + k*log(2)
        MOVLB 1
        MOVF  e,W
        MOVWF arg2f24
        MOVF  e+1,W
        MOVWF arg2f24+1
        MOVF  e+2,W
        MOVWF arg2f24+2
        CALL  _fadd24
                        ;
                        ;    if (!(savedFlags & 0x40))
        MOVLB 1
        BTFSC savedFlags,6
        GOTO  m119
                        ;        FpFlags &= ~0x40;   //  restore rounding flag
        BCF   FpFlags,6
                        ;    goto _RETURN_MF;
        GOTO  m119
                        ;
                        ;  _DOMERR32:
                        ;    FpDomainError = 1;   //  domain error
m118    MOVLB 1
        BSF   0xD4,FpDomainError
                        ;
                        ;  _RETURN_MF:
                        ;    return arg1f24;
m119    MOVLB 1
        MOVF  arg1f24,W
        RETURN
                        ;}
                        ;
                        ;
                        ;
                        ;float24 log10( sharedM float24 arg1f24)
                        ;{
log10
                        ;    sharedM float24 arg2f24;      // allocation 'trick'
                        ;
                        ;    char flags = FpFlags;
                        ;    FpFlags |= 0x40;
                        ;
                        ;    arg1f24 = log( arg1f24);
                        ;
                        ;    arg1f24 *= 0.43429448190325;  //  log10(e);
                        ;
                        ;    if (!(flags & 0x40))
                        ;        FpFlags &= ~0x40;
                        ;
                        ;    return arg1f24;
                        ;}
                        ;
                        ;
                        ;
                        ;char floorMaskTable24( char i)
                        ;{
floorMaskTable24
                        ;    if (i & 4)  {
                        ;        if (i & 2)  {
                        ;            if (i & 1)
                        ;                return 128;
                        ;            return 192;
                        ;        }
                        ;        if (i & 1)
                        ;            return 224;
                        ;        return 240;
                        ;    }
                        ;    if (i & 2)  {
                        ;        if (i & 1)
                        ;            return 248;
                        ;        return 252;
                        ;    }
                        ;    if (i & 1)
                        ;        return 254;
                        ;    return 255;
                        ;}
                        ;
                        ;float24 floor24( sharedM float24 arg1f24)
                        ;{
floor24
                        ;    if (!arg1f24.high8)
                        ;        goto _RETURN_MF;
                        ;
                        ;    uns16 ma = arg1f24.low16;  //  save mantissa
                        ;
                        ;    W = arg1f24.high8 - 127;
                        ;    char tmp = W;
                        ;    if (tmp & 0x80)
                        ;        goto FLOOR24ZERO;
                        ;
                        ;    //  save number of zero bits
                        ;    W = 15 - W;
                        ;
                        ;    char tmpa = W;
                        ;    tmp = W;
                        ;
                        ;    if (tmp & 0x8)  // LSB+3		; divide by eight
                        ;        goto FLOOR24MASKH;
                        ;
                        ;
                        ;    W = floorMaskTable24( tmpa);    //  get mask
                        ;    arg1f24.low8 &= W;
                        ;    if (!(arg1f24.mid8 & 0x80))  //  if negative, round down
                        ;        goto _RETURN_MF;
                        ;
                        ;    char arg1B7 = W;
                        ;    if (!(arg1f24.low8 - ma.low8))
                        ;        goto _RETURN_MF;
                        ;
                        ;    tmp = ~arg1B7;
                        ;    arg1f24.low8 += tmp + 1;
                        ;    if (Zero_)
                        ;        arg1f24.mid8 += 1;
                        ;
                        ;    //  has rounding caused carryout?
                        ;    if (!Zero_)
                        ;        goto _RETURN_MF;
                        ;    arg1f24.mid8 = rr( arg1f24.mid8);
                        ;    arg1f24.low8 = rr( arg1f24.low8);
                        ;
                        ;    //  check for overflow
                        ;    arg1f24.high8 = incsz( arg1f24.high8);
                        ;    goto _RETURN_MF;
                        ;    goto OVERFLOW;
                        ;
                        ;
                        ;  FLOOR24MASKH:
                        ;    W = floorMaskTable24( tmpa);  //  get mask
                        ;    arg1f24.mid8 &= W;
                        ;    arg1f24.low8 = 0;
                        ;
                        ;    //  if negative, round down
                        ;    if (!(arg1f24.mid8 & 0x80))
                        ;        goto _RETURN_MF;
                        ;
                        ;    arg1B7 = W;
                        ;    if (( arg1f24.low8 - ma.low8) != 0)
                        ;        goto FLOOR24RNDH;
                        ;    if (!(arg1f24.mid8 - ma.mid8))
                        ;        goto _RETURN_MF;
                        ;
                        ;  FLOOR24RNDH:
                        ;    tmp = ~arg1B7;
                        ;    arg1f24.mid8 += tmp + 1;
                        ;
                        ;    //  has rounding caused carryout?
                        ;    if (!Carry)
                        ;        goto _RETURN_MF;
                        ;    arg1f24.mid8 = rr( arg1f24.mid8);
                        ;    arg1f24.low8 = rr( arg1f24.low8);
                        ;
                        ;    //  check for overflow
                        ;    arg1f24.high8 = incsz( arg1f24.high8);
                        ;    goto _RETURN_MF;
                        ;    goto OVERFLOW;
                        ;
                        ;
                        ;  FLOOR24ZERO:
                        ;    if (!(arg1f24.mid8 & 0x80))
                        ;        goto RES0;
                        ;    return -1.0;
                        ;
                        ;  RES0:
                        ;    W = 0;
                        ;    goto ASSIGNW;
                        ;
                        ;  OVERFLOW:
                        ;    FpOverflow = 1;
                        ;    W = 0xFF;
                        ;  ASSIGNW:
                        ;    arg1f24.low8 = W;
                        ;    arg1f24.mid8 = W;
                        ;    arg1f24.high8 = W;
                        ;
                        ;  _RETURN_MF:
                        ;    return arg1f24;
                        ;}
                        ;
                        ;
                        ;
                        ;float24 exp10( sharedM float24 arg1f24)
                        ;{
exp10
                        ;    sharedM float24 arg2f24;      // allocation 'trick'
                        ;    float24 c, d;
                        ;    char xexp;
                        ;
                        ;    if (( arg1f24.high8 - 100) & 0x80)
                        ;        goto EXP1;   //  return e**x = 1
                        ;
                        ;    W = 132 - arg1f24.high8;
                        ;    if (!Carry)
                        ;        goto _DOMERR;
                        ;    if (!Zero_)
                        ;        goto ARGOK;
                        ;
                        ;    if (!(arg1f24.mid8 & 0x80))  {
                        ;        //  positive domain check
                        ;        W = 26 - arg1f24.mid8;
                        ;        if (!Carry)
                        ;            goto _DOMERR;
                        ;        if (!Zero_)
                        ;            goto ARGOK;
                        ;
                        ;        W = 33 - arg1f24.low8;
                        ;        if (!Carry)
                        ;            goto _DOMERR;
                        ;    }
                        ;    else  {
                        ;
                        ;        W = 151 - arg1f24.mid8;
                        ;        if (!Carry)
                        ;            goto _DOMERR;
                        ;        if (!Zero_)
                        ;            goto ARGOK;
                        ;
                        ;        W = 184 - arg1f24.low8;
                        ;        if (!Carry)
                        ;            goto _DOMERR;
                        ;    }
                        ;
                        ;  ARGOK:
                        ;
                        ;    char savedFlags = FpFlags;
                        ;    FpFlags |= 0x40;  //  enable rounding
                        ;
                        ;    c = arg1f24;  //  save x
                        ;    arg1f24 *= 3.32192809489;  //  1/log10(2) = 3.32192809489
                        ;    arg1f24 += 0.5;  //  k = [ x / log10(2) + .5 ]
                        ;    arg1f24 = floor24( arg1f24);
                        ;
                        ;    float24 e = arg1f24; //  save float k
                        ;    FpFlags &= ~0x40;
                        ;    //floating point to integer conversion
                        ;    xexp = arg1f24; //  k = [ x / ln(2) + .5 ]
                        ;    FpFlags |= 0x40;
                        ;    arg1f24 = e * -0.30078125; //  c1
                        ;    d = arg1f24 + c;
                        ;    arg1f24 = e * -2.487456637421670e-04;  // c2
                        ;    arg1f24 += d;
                        ;    d = arg1f24;  //  save f
                        ;
                        ;    if (!(d.mid8 & 0x80))  {
                        ;        // POL32  EXP1032H,5,4   ; minimax approximation on [0,log10(2)/2]
                        ;        arg1f24 *= 6.388992868121E-1;/* EXP1032H5 */
                        ;        arg1f24 += 1.154596329197E0; /* EXP1032H4 */
                        ;        arg1f24 *= d;
                        ;        arg1f24 += 2.035920309947E0; /* EXP1032H3 */
                        ;        arg1f24 *= d;
                        ;        arg1f24 += 2.650909138708E0; /* EXP1032H2 */
                        ;        arg1f24 *= d;
                        ;        arg1f24 += 2.302585504840E0; /* EXP1032H1 */
                        ;    }
                        ;    else  {
                        ;        // POL32 EXP1032L,5,4  ; minimax approximation on [-log10(2)/2,0]
                        ;        arg1f24 *= 4.544952589676E-1;/* EXP1032L5 */
                        ;        arg1f24 += 1.157459289066E0; /* EXP1032L4 */
                        ;        arg1f24 *= d;
                        ;        arg1f24 += 2.033640565225E0; /* EXP1032L3 */
                        ;        arg1f24 *= d;
                        ;        arg1f24 += 2.650914554552E0; /* EXP1032L2 */
                        ;        arg1f24 *= d;
                        ;        arg1f24 += 2.302584716116E0; /* EXP1032L1 */
                        ;    }
                        ;    arg1f24 *= d;
                        ;    if (!(savedFlags & 0x40))
                        ;        FpFlags &= ~0x40;
                        ;    arg1f24 += 1.0; /* EXP1032H0/EXP1032L0 */
                        ;
                        ;    arg1f24.high8 += xexp;
                        ;    goto _RETURN_MF;
                        ;
                        ;  EXP1:
                        ;    arg1f24 = 1.0;   //  return 10**x = 1.0
                        ;    goto _RETURN_MF;
                        ;
                        ;  _DOMERR:
                        ;    FpDomainError = 1;   //  domain error
                        ;
                        ;  _RETURN_MF:
                        ;    return arg1f24;
                        ;}
                        ;
                        ;
                        ;
                        ;float24 exp( sharedM float24 arg1f24)
                        ;//     Maximum argument : 88.7228391117 = log(2**128)
                        ;//     Minimum argument : -87.3365447506 = log(2**-126)
                        ;{
exp
                        ;    sharedM float24 arg2f24;
                        ;    float24 c, d;
                        ;    char xexp;
                        ;
                        ;    if (( arg1f24.high8 - 94) & 0x80)
                        ;        goto EXP1;   //  return e**x = 1
                        ;
                        ;    W = 133 - arg1f24.high8;
                        ;    if (!Carry)
                        ;        goto _DOMERR;
                        ;    if (!Zero_)
                        ;        goto ARGOK;
                        ;
                        ;    if (!(arg1f24.mid8 & 0x80))  {
                        ;
                        ;        W = 49 - arg1f24.mid8;
                        ;        if (!Carry)
                        ;            goto _DOMERR;
                        ;        if (!Zero_)
                        ;            goto ARGOK;
                        ;
                        ;        W = 114 - arg1f24.midL8;
                        ;        if (!Carry)
                        ;            goto _DOMERR;
                        ;    }
                        ;    else {
                        ;
                        ;        W = 174 - arg1f24.mid8;
                        ;        if (!Carry)
                        ;            goto _DOMERR;
                        ;        if (!Zero_)
                        ;            goto ARGOK;
                        ;
                        ;        W = 172 - arg1f24.midL8;
                        ;        if (!Carry)
                        ;            goto _DOMERR;
                        ;    }
                        ;
                        ;  ARGOK:
                        ;
                        ;    char savedFlags = FpFlags;
                        ;    FpFlags |= 0x40;  //  enable rounding
                        ;
                        ;    c = arg1f24;  //  save x
                        ;    arg1f24 *= 1.44269504089;
                        ;    arg1f24 += 0.5; //  k = [ x / ln(2) + .5 ]
                        ;    arg1f24 = floor24( arg1f24);
                        ;
                        ;    float24 e = arg1f24;
                        ;    xexp = arg1f24;   //  k = [ x / ln(2) + .5 ]
                        ;    arg1f24 = e * -0.69140625; // c1
                        ;    d = arg1f24 + c;
                        ;    arg1f24 = e * -1.740930559945286e-03;  // c2
                        ;    arg1f24 += d;
                        ;    d = arg1f24;  //  save f
                        ;
                        ;    if (!(d.mid8 & 0x80))  {
                        ;        // POL32   EXP32H,5,0
                        ;        arg1f24 *= 0.989943653774E-2; /* EXP32H5 */
                        ;        arg1f24 += 0.410473706887E-1; /* EXP32H4 */
                        ;        arg1f24 *= d;
                        ;        arg1f24 += 0.166777360103;    /* EXP32H3 */
                        ;        arg1f24 *= d;
                        ;        arg1f24 += 0.499991163105;    /* EXP32H2 */
                        ;        arg1f24 *= d;
                        ;        arg1f24 += 1.00000025499;     /* EXP32H1 */
                        ;    }
                        ;    else  {
                        ;        // POL32   EXP32L,5,0
                        ;        arg1f24 *= 0.699995870637E-2; /* EXP32L5 */
                        ;        arg1f24 += 0.411548782678E-1; /* EXP32L4 */
                        ;        arg1f24 *= d;
                        ;        arg1f24 += 0.166574299807;    /* EXP32L3 */
                        ;        arg1f24 *= d;
                        ;        arg1f24 += 0.499992371926;    /* EXP32L2 */
                        ;        arg1f24 *= d;
                        ;        arg1f24 += 0.999999766814;    /* EXP32L1 */
                        ;    }
                        ;    arg1f24 *= d;
                        ;    arg1f24 += 1.0;   /* EXP32H0 or EXP32L0 */
                        ;    arg1f24.high8 += xexp;
                        ;
                        ;    if (!(savedFlags & 0x40))
                        ;        FpFlags &= ~0x40;   //  restore rounding flag
                        ;    goto _RETURN_MF;
                        ;
                        ;  EXP1:
                        ;    arg1f24 = 1.0;   //  return 10**x = 1.0
                        ;    goto _RETURN_MF;
                        ;
                        ;  _DOMERR:
                        ;    FpDomainError = 1;   //  domain error
                        ;
                        ;  _RETURN_MF:
                        ;    return arg1f24;
                        ;}
                        ;
                        ;
                        ;
                        ;
                        ;
                        ;
                        ;float24 cosin24( sharedM float24 arg1f24, sharedM float24 arg2f24, char cosinus)
                        ;{
cosin24
                        ;    float24 c, d;
                        ;    char j;
                        ;
                        ;    char savedFlags = FpFlags;  //  save rounding flag
                        ;    FpFlags |= 0x40;  //  enable rounding
                        ;
                        ;    char csign = 0;    //  initialize sign
                        ;
                        ;    if (!cosinus  &&  (arg1f24.mid8 & 0x80))
                        ;        csign |= 0x80;
                        ;
                        ;    arg1f24.mid8 &= ~0x80;  //  use |x|
                        ;
                        ;    //  loss threshold check
                        ;    // arg1f24 <= +512.0
                        ;    // arg1f24 >= -512.0
                        ;    if (arg1f24.high8 >= 0x88)
                        ;        FpDomainError = 1;   //  domain error
                        ;
                        ;    c = arg1f24;  //  save |x|
                        ;
                        ;    // fixed point multiplication by 4/pi
                        ;    arg1f24 *= 1.27323954474;   // 4/pi
                        ;
                        ;    FpFlags &= ~0x40;
                        ;
                        ;    //  y = [ |x| * (4/pi) ]
                        ;    arg1f24.low16 = arg1f24;  // floating point to integer conversion
                        ;
                        ;    FpFlags |= 0x40;
                        ;
                        ;    if (arg1f24.low8 & 0x1)
                        ;        arg1f24.low16 += 1;  // make arg1f24 even
                        ;
                        ;    //  j = y mod 8
                        ;    j = arg1f24.low8 & 7;  // 0,2,4,6
                        ;    if (j >= 4)  {
                        ;        csign ^= 128;
                        ;        j -= 4;
                        ;    }
                        ;
                        ;    arg1f24 = arg1f24.low16;  // integer to floating point conversion
                        ;
                        ;    //  save y in DARG
                        ;    d.high8 = arg1f24.high8;
                        ;    if (Zero_)
                        ;        goto ZEQX;
                        ;    d.low16 = arg1f24.low16;
                        ;
                        ;    arg1f24 *= -7.851562500000000e-01;
                        ;    c = arg1f24 + c;    //  z1 = |x| - y * (p1)
                        ;    arg1f24 = d * -2.419133974475018e-04;
                        ;    arg1f24 += c;
                        ;
                        ;    //  save z in c
                        ;    c.high8 = arg1f24.high8;
                        ;    arg2f24.high8 = arg1f24.high8;
                        ;    c.mid8 = arg1f24.mid8;
                        ;    arg2f24.mid8 = arg1f24.mid8;
                        ;    c.low8 = arg1f24.low8;
                        ;    arg2f24.low8 = arg1f24.low8;
                        ;
                        ;    goto POLYNOM;
                        ;
                        ;   ZEQX:
                        ;    arg1f24.high8 = c.high8;
                        ;    arg2f24.high8 = c.high8;
                        ;    arg1f24.mid8 = c.mid8;
                        ;    arg2f24.mid8 = c.mid8;
                        ;    arg1f24.low8 = c.low8;
                        ;    arg2f24.low8 = c.low8;
                        ;
                        ;   POLYNOM:
                        ;
                        ;
                        ;
                        ;    arg1f24 *= arg2f24;   // z * z
                        ;    d = arg1f24;   //  save z * z
                        ;
                        ;    if ((( rr( j) ^ j) & 0x1) ^ cosinus)  {
                        ;        // POL24  COS24,3,0
                        ;
                        ;        arg1f24 *= -1.35859090e-03;  // 117,178,18,191
                        ;        arg1f24 += 4.16550264e-02;   // 122,42,158,118
                        ;        arg1f24 *= d;
                        ;        arg1f24 += -4.99998569e-01;  // 125,255,255,208
                        ;        arg1f24 *= d;
                        ;        arg1f24 += 1.0;
                        ;    }
                        ;    else  {
                        ;        /// POL24  SIN24,2,0
                        ;        arg1f24 *= 8.12155753e-03;   // 120,5,16,72
                        ;        arg1f24 += -1.66601613e-01;  // 124,170,153,157
                        ;        arg1f24 *= d;
                        ;        arg1f24 += 9.99994993e-01;   // 126,127,255,172
                        ;        arg1f24 *= c;
                        ;    }
                        ;
                        ;    W = 128;  // LSB+1
                        ;    if (cosinus  &&  (j & 0x2))
                        ;        csign ^= W;
                        ;    if (csign & 0x80)
                        ;        arg1f24.mid8 ^= W;
                        ;
                        ;    if (savedFlags & 0x40)
                        ;        FpFlags |= 0x40;  //  restore rounding flag
                        ;    return arg1f24;
                        ;}
                        ;
                        ;
                        ;float24 cos( sharedM float24 arg1f24)
                        ;{
cos
                        ;    sharedM float24 arg2f24;      // allocation 'trick'
                        ;    arg1f24 = cosin24( arg1f24, arg2f24, 1);
                        ;    return arg1f24;
                        ;}
                        ;
                        ;
                        ;float24 sin( sharedM float24 arg1f24)
                        ;{
sin
                        ;    sharedM float24 arg2f24;      // allocation 'trick'
                        ;    arg1f24 = cosin24( arg1f24, arg2f24, 0);
                        ;    return arg1f24;
                        ;}
                        ;
                        ;
                        ;#if !defined __CC5XFREE__
                        ;
                        ;float24 sqrt( float24 arg)
                        ;// Copyright (c) Jim van Zee, Seattle, WA., 2004
                        ;{
                        ;    uns8 arg_exp @ arg.high8;    // arg exponent (offset by FpBIAS)
                        ;    uns24 root = 0;              // result (treated as an integer)
                        ;    float24 sqrtf @ root;        // result (treated as a float)
                        ;    uns24 remain;
                        ;    uns8 nr_bits;
                        ;
                        ;    if (arg.mid8 & 0x80) {  // test for negative argument
                        ;        FpDomainError=1;
                        ;        goto END;           // negative #s return '0'
                        ;    }
                        ;    if (!arg_exp)
                        ;        goto END;           // 0->0 (all bytes are 0)
                        ;
                        ;    arg.15 = 1;             // restore hidden bit
                        ;    remain = 0;             // clear remainder
                        ;    nr_bits = 16;           // initialize bit count
                        ;
                        ;    // Here's a 'tricky bit': 'even' exponents work out OK, but 'odd'
                        ;    // exponents need one less shift initially in order to align the
                        ;    // bits in a 'powers-of-four' pattern (two-bits-at-a-time).
                        ;
                        ;    btss(arg_exp.0);          // skip if exponent is odd
                        ;    do {
                        ;        remain.23=1;          // set 2x shift flag
                        ;        root = rl(root);        // exponent= 'spill byte'
                        ;        root.0=1;               // add '1' to form '2N+1'
                        ;        root.1=0;               // clear next root bit
                        ;        do {
                        ;            arg.low16 = rl(arg.low16); // shift mantissa into 'remain'
                        ;            remain = rl(remain);       // two-bits-at-a-time (add 0's)
                        ;        } while(Carry);         // Carry=1 the first time
                        ;        arg.0=0;                // clear the carry-in bit
                        ;
                        ;        // now compare root and remainder; if remain >= root, subtract
                        ;        // to get the new remainder & set bit=1; otherwise leave bit=0.
                        ;
                        ;        //        if (remain >= root) // 3-byte compare
                        ;        //        {   remain -= root; // update remainder
                        ;        //            root.1 = 1;   } // set this bit = 1
                        ;
                        ;        W = remain.low8 - root.low8;  // compare remain w/root
                        ;        genSubW( remain.mid8, root.mid8);
                        ;        genSubW( remain.high8, root.high8);
                        ;
                        ;        // If remain >= root, the next bit is '1', otherwise '0'
                        ;        if (Carry) {          // remain -= root;
                        ;            remain.high8 = W;   // save 'spill byte'
                        ;            remain.low8 -= root.low8;   // do subtraction
                        ;            genSub( remain.mid8, root.mid8);
                        ;            root.1 = 1; // note: lsb is bit1, not bit0!
                        ;        }
                        ;
                        ;    } while (--nr_bits); // 16 bit mantissa
                        ;
                        ;    // Finally unshift root (only need to do 16 bits, since msb->0!)
                        ;    root.low16 = rr(root.low16);       // '2N+1' -> 'N'
                        ;    root.15 = 0;            // clear hidden bit
                        ;
                        ;    // and set exponent = arg_exp/2 (we used this as the spill byte)
                        ;    arg_exp += FpBIAS;      // double the bias
                        ;    root.high8=rr(arg_exp); // root exp = arg_exp/2+FpBIAS
                        ;  END:
                        ;    return sqrtf;           // neg & zero args return 0
                        ;}
                        ;
                        ;#else
                        ;
                        ;float24 sqrt( sharedM float24 arg1f24)
                        ;{
sqrt
                        ;    sharedM float24 arg2f24;      // allocation 'trick'
                        ;
                        ;    if (arg1f24.mid8 & 0x80)     // test for negative argument
                        ;        goto _DOMERR;
                        ;    if (!arg1f24.high8)          // return if argument zero
                        ;        goto _RETURN_MF;
                        ;
                        ;    char cexp = arg1f24.high8;    // save exponent
                        ;    char savedFLAGS = FpFlags;
                        ;    FpFlags |= 0x40;           // enable rounding
                        ;
                        ;    arg1f24.high8 = FpBIAS;   // compute z
                        ;    float24 d = arg1f24;
                        ;
                        ;    if (arg1f24.mid8 & 0x40)  {
                        ;        // POL24  SQRT24H,4,0
                        ;        arg1f24 *= -5.6351436252E-3;  // SQRT24H4
                        ;        arg1f24 += 5.5047377031E-2; // SQRT24H3
                        ;        arg1f24 *= d;
                        ;        arg1f24 += -2.3944355047E-1;  // SQRT24H2
                        ;        arg1f24 *= d;
                        ;        arg1f24 += 8.3106978456E-1; // SQRT24H1
                        ;        arg1f24 *= d;
                        ;        arg1f24 += 3.5963132863E-1;  // SQRT24H0
                        ;    }
                        ;    else  {
                        ;        // POL24  SQRT24L,4,0
                        ;        arg1f24 *= -1.8702682470E-2;  // SQRT24L4
                        ;        arg1f24 += 1.3009144111E-1; // SQRT24L3
                        ;        arg1f24 *= d;
                        ;        arg1f24 += -4.0192034196E-1;  // SQRT24L2
                        ;        arg1f24 *= d;
                        ;        arg1f24 += 9.8831235597E-1;  // SQRT24L1
                        ;        arg1f24 *= d;
                        ;        arg1f24 += 3.0221977303E-1;  // SQRT24L0
                        ;    }
                        ;
                        ;    if (!(cexp & 0x1))      // is cexp even or odd?
                        ;        arg1f24 *= 1.41421356237;  // sqrt(2)
                        ;
                        ;    // divide exponent by two
                        ;    cexp += 127;
                        ;    arg1f24.high8 = rr( cexp);
                        ;
                        ;    if (!(savedFLAGS & 0x40))
                        ;        FpFlags &= ~0x40;
                        ;
                        ;    goto _RETURN_MF;
                        ;
                        ;  _DOMERR:
                        ;    FpDomainError = 1;   //  domain error
                        ;
                        ;  _RETURN_MF:
                        ;    return arg1f24;

  ; FILE DischrgSlv.c
                        ;
                        ;
                        ;#include "MATH24F.H"
                        ;#include "MATH24LB.H"
                        ;
                        ;#pragma codepage 1
                        ;		
                        ;void CalcDegC (void)
                        ;{
CalcDegC
                        ;	#pragma rambank 1
                        ;
                        ;	float24 calc,calc1,calc2,ValCTN;
                        ;
                        ;	// process value of temperature
                        ;	// first calculate value of voltage in mV
                        ;	TMR1H =0;
        MOVLB 0
        CLRF  TMR1H
                        ;	TMR1L = 0;
        CLRF  TMR1L
                        ;	TMR1ON = 1;
        BSF   0x18,TMR1ON
                        ;	calc = TempADC; 
        MOVLB 1
        MOVF  TempADC,W
        MOVWF arg1f24
        MOVF  TempADC+1,W
        MOVWF arg1f24+1
        CLRF  arg1f24+2
        BTFSC arg1f24+1,7
        DECF  arg1f24+2,1
        CALL  _int24ToFloat24
        MOVLB 1
        MOVF  rval,W
        MOVWF calc_2
        MOVF  rval+1,W
        MOVWF calc_2+1
        MOVF  rval+2,W
        MOVWF calc_2+2
                        ;	calc1 = calc/1023;		// convert to  0...0.999
        MOVF  calc_2,W
        MOVWF arg1f24
        MOVF  calc_2+1,W
        MOVWF arg1f24+1
        MOVF  calc_2+2,W
        MOVWF arg1f24+2
        MOVLW 192
        MOVWF arg2f24
        MOVLW 127
        MOVWF arg2f24+1
        MOVLW 136
        MOVWF arg2f24+2
        CALL  _fdiv24
        MOVLB 1
        MOVF  arg1f24,W
        MOVWF calc1
        MOVF  arg1f24+1,W
        MOVWF calc1+1
        MOVF  arg1f24+2,W
        MOVWF calc1+2
                        ;	
                        ;	// then value of resitor in ohms : R = (Vs * R1) / (Ve - Vs)
                        ;	calc2 = 5 * calc1;		// calc2 = vs  0..4.096v
        CLRF  arg1f24
        MOVLW 32
        MOVWF arg1f24+1
        MOVLW 129
        MOVWF arg1f24+2
        MOVF  calc1,W
        MOVWF arg2f24
        MOVF  calc1+1,W
        MOVWF arg2f24+1
        MOVF  calc1+2,W
        MOVWF arg2f24+2
        CALL  _fmul24
        MOVLB 1
        MOVF  arg1f24,W
        MOVWF calc2
        MOVF  arg1f24+1,W
        MOVWF calc2+1
        MOVF  arg1f24+2,W
        MOVWF calc2+2
                        ;	calc1 = calc2 * 18000;		// Vs * r1  r1 = 18K
        MOVF  calc2,W
        MOVWF arg1f24
        MOVF  calc2+1,W
        MOVWF arg1f24+1
        MOVF  calc2+2,W
        MOVWF arg1f24+2
        MOVLW 160
        MOVWF arg2f24
        MOVLW 12
        MOVWF arg2f24+1
        MOVLW 141
        MOVWF arg2f24+2
        CALL  _fmul24
        MOVLB 1
        MOVF  arg1f24,W
        MOVWF calc1
        MOVF  arg1f24+1,W
        MOVWF calc1+1
        MOVF  arg1f24+2,W
        MOVWF calc1+2
                        ;	calc2 = 5.000 - calc2; 		//ve - vs
        CLRF  arg1f24
        MOVLW 32
        MOVWF arg1f24+1
        MOVLW 129
        MOVWF arg1f24+2
        MOVF  calc2,W
        MOVWF arg2f24
        MOVF  calc2+1,W
        MOVWF arg2f24+1
        MOVF  calc2+2,W
        MOVWF arg2f24+2
        CALL  _fsub24
        MOVLB 1
        MOVF  arg1f24,W
        MOVWF calc2
        MOVF  arg1f24+1,W
        MOVWF calc2+1
        MOVF  arg1f24+2,W
        MOVWF calc2+2
                        ;	ValCTN = calc1 / calc2;		// val r ctn
        MOVF  calc1,W
        MOVWF arg1f24
        MOVF  calc1+1,W
        MOVWF arg1f24+1
        MOVF  calc1+2,W
        MOVWF arg1f24+2
        MOVF  calc2,W
        MOVWF arg2f24
        MOVF  calc2+1,W
        MOVWF arg2f24+1
        MOVF  calc2+2,W
        MOVWF arg2f24+2
        CALL  _fdiv24
        MOVLB 1
        MOVF  arg1f24,W
        MOVWF ValCTN
        MOVF  arg1f24+1,W
        MOVWF ValCTN+1
        MOVF  arg1f24+2,W
        MOVWF ValCTN+2
                        ;	// apply formula of SteinHart-Hart
                        ;	calc1 = log(ValCTN);	//log R
        MOVF  ValCTN,W
        MOVWF arg1f24
        MOVF  ValCTN+1,W
        MOVWF arg1f24+1
        MOVF  ValCTN+2,W
        MOVWF arg1f24+2
        CALL  log
        MOVLB 1
        MOVF  arg1f24,W
        MOVWF calc1
        MOVF  arg1f24+1,W
        MOVWF calc1+1
        MOVF  arg1f24+2,W
        MOVWF calc1+2
                        ;	calc = CoefC * calc1;	//+ (C *(log R)^3)
        MOVLB 0
        MOVF  CoefC,W
        MOVLB 1
        MOVWF arg1f24
        MOVLB 0
        MOVF  CoefC+1,W
        MOVLB 1
        MOVWF arg1f24+1
        MOVLB 0
        MOVF  CoefC+2,W
        MOVLB 1
        MOVWF arg1f24+2
        MOVF  calc1,W
        MOVWF arg2f24
        MOVF  calc1+1,W
        MOVWF arg2f24+1
        MOVF  calc1+2,W
        MOVWF arg2f24+2
        CALL  _fmul24
        MOVLB 1
        MOVF  arg1f24,W
        MOVWF calc_2
        MOVF  arg1f24+1,W
        MOVWF calc_2+1
        MOVF  arg1f24+2,W
        MOVWF calc_2+2
                        ;	calc = calc * calc1;
        MOVF  calc_2,W
        MOVWF arg1f24
        MOVF  calc_2+1,W
        MOVWF arg1f24+1
        MOVF  calc_2+2,W
        MOVWF arg1f24+2
        MOVF  calc1,W
        MOVWF arg2f24
        MOVF  calc1+1,W
        MOVWF arg2f24+1
        MOVF  calc1+2,W
        MOVWF arg2f24+2
        CALL  _fmul24
        MOVLB 1
        MOVF  arg1f24,W
        MOVWF calc_2
        MOVF  arg1f24+1,W
        MOVWF calc_2+1
        MOVF  arg1f24+2,W
        MOVWF calc_2+2
                        ;	calc = calc * calc1;
        MOVF  calc_2,W
        MOVWF arg1f24
        MOVF  calc_2+1,W
        MOVWF arg1f24+1
        MOVF  calc_2+2,W
        MOVWF arg1f24+2
        MOVF  calc1,W
        MOVWF arg2f24
        MOVF  calc1+1,W
        MOVWF arg2f24+1
        MOVF  calc1+2,W
        MOVWF arg2f24+2
        CALL  _fmul24
        MOVLB 1
        MOVF  arg1f24,W
        MOVWF calc_2
        MOVF  arg1f24+1,W
        MOVWF calc_2+1
        MOVF  arg1f24+2,W
        MOVWF calc_2+2
                        ;	calc2 = CoefB * calc1;	//+ (B * log R)
        MOVLB 0
        MOVF  CoefB,W
        MOVLB 1
        MOVWF arg1f24
        MOVLB 0
        MOVF  CoefB+1,W
        MOVLB 1
        MOVWF arg1f24+1
        MOVLB 0
        MOVF  CoefB+2,W
        MOVLB 1
        MOVWF arg1f24+2
        MOVF  calc1,W
        MOVWF arg2f24
        MOVF  calc1+1,W
        MOVWF arg2f24+1
        MOVF  calc1+2,W
        MOVWF arg2f24+2
        CALL  _fmul24
        MOVLB 1
        MOVF  arg1f24,W
        MOVWF calc2
        MOVF  arg1f24+1,W
        MOVWF calc2+1
        MOVF  arg1f24+2,W
        MOVWF calc2+2
                        ;	calc += calc2;
        MOVF  calc_2,W
        MOVWF arg1f24
        MOVF  calc_2+1,W
        MOVWF arg1f24+1
        MOVF  calc_2+2,W
        MOVWF arg1f24+2
        MOVF  calc2,W
        MOVWF arg2f24
        MOVF  calc2+1,W
        MOVWF arg2f24+1
        MOVF  calc2+2,W
        MOVWF arg2f24+2
        CALL  _fadd24
        MOVLB 1
        MOVF  arg1f24,W
        MOVWF calc_2
        MOVF  arg1f24+1,W
        MOVWF calc_2+1
        MOVF  arg1f24+2,W
        MOVWF calc_2+2
                        ;	calc += CoefA;			//+A
        MOVF  calc_2,W
        MOVWF arg1f24
        MOVF  calc_2+1,W
        MOVWF arg1f24+1
        MOVF  calc_2+2,W
        MOVWF arg1f24+2
        MOVLB 0
        MOVF  CoefA,W
        MOVLB 1
        MOVWF arg2f24
        MOVLB 0
        MOVF  CoefA+1,W
        MOVLB 1
        MOVWF arg2f24+1
        MOVLB 0
        MOVF  CoefA+2,W
        MOVLB 1
        MOVWF arg2f24+2
        CALL  _fadd24
        MOVLB 1
        MOVF  arg1f24,W
        MOVWF calc_2
        MOVF  arg1f24+1,W
        MOVWF calc_2+1
        MOVF  arg1f24+2,W
        MOVWF calc_2+2
                        ;	calc = 1/calc;			// 1/T completes formula 
        CLRF  arg1f24
        CLRF  arg1f24+1
        MOVLW 127
        MOVWF arg1f24+2
        MOVF  calc_2,W
        MOVWF arg2f24
        MOVF  calc_2+1,W
        MOVWF arg2f24+1
        MOVF  calc_2+2,W
        MOVWF arg2f24+2
        CALL  _fdiv24
        MOVLB 1
        MOVF  arg1f24,W
        MOVWF calc_2
        MOVF  arg1f24+1,W
        MOVWF calc_2+1
        MOVF  arg1f24+2,W
        MOVWF calc_2+2
                        ;	calc -= 273.15;			// convert deg K to deg C
        MOVF  calc_2,W
        MOVWF arg1f24
        MOVF  calc_2+1,W
        MOVWF arg1f24+1
        MOVF  calc_2+2,W
        MOVWF arg1f24+2
        MOVLW 147
        MOVWF arg2f24
        MOVLW 8
        MOVWF arg2f24+1
        MOVLW 135
        MOVWF arg2f24+2
        CALL  _fsub24
        MOVLB 1
        MOVF  arg1f24,W
        MOVWF calc_2
        MOVF  arg1f24+1,W
        MOVWF calc_2+1
        MOVF  arg1f24+2,W
        MOVWF calc_2+2
                        ;	//then convert to integer and assign value for return
                        ;	Temp = calc;
        MOVF  calc_2,W
        MOVWF arg1f24
        MOVF  calc_2+1,W
        MOVWF arg1f24+1
        MOVF  calc_2+2,W
        MOVWF arg1f24+2
        CALL  _float24ToInt24
        MOVLB 1
        MOVF  rval_3,W
        MOVWF Temp
        MOVF  rval_3+1,W
        MOVWF Temp+1
                        ;	TMR1ON = 0;
        MOVLB 0
        BCF   0x18,TMR1ON
                        ;}
        RETURN
                        ;
                        ;
                        ;#pragma codepage 3
        ORG 0x1800
                        ;#pragma origin 0x1800
        ORG 0x1800
                        ;
                        ;/**********************************************************
                        ;		RS232 SERIAL BOOTLOADER
                        ; 
                        ; >>>>>>>>>>>>>>>>>>> SPECIFIC 16F EXTENDED SERIES ><<<<<<<<<	
                        ;  - All polled, no interrupt is used in this soft.
                        ; - All parameters must be set in the corresponding .h file.
                        ; 
                        ; ===> after compil copy resulting asm into bo.asm.
                        ; 	  then recompile in assembly after replacement 
                        ; 	  of CALL to user soft by a GOTO usermain 
                        ;************************************************************/
                        ;
                        ;// Clocking
                        ;#define b_CPUCLK					4L	// in Mhz
                        ;#define b_CYCLK					CPUCLK / 4000L	// Instruction cycle (cpu div by 4)
                        ;
                        ;// process value of USART BRG VALUE, BRGH = 1, BRG16 = 1
                        ;#define b_BAUDR			57600L			// value of baud rate needed
                        ;#define b_CONSTBR1		b_CPUCLK * 1000000L
                        ;#define b_CONSTBR2		b_CONSTBR1 / 4
                        ;#define b_CONSTBR3		b_CONSTBR2 / b_BAUDR
                        ;#define b_BAUDGEN		b_CONSTBR3 - 1
                        ;
                        ;#if (b_BAUDGEN) > (255)
                        ;	#error BootLD Baud rate value not possible with BRDH=1  
                        ;#endif
                        ;/* **************** FLASH PROGRAM CAPACITY ***************/
                        ;// capacity of pgm memory in bytes (2 times number of 14bits words)
                        ;// 16 for 8k pgm words
                        ;#define FLASHCAPACITY 250		// ex 16 k for 16f876
                        ;
                        ;/********************************************
                        ;		GLOBAL VARIABLES
                        ;********************************************/
                        ;#pragma rambank 3
                        ;bit boot_OK, boot_Verif;
                        ;char rxdata, bi, boot_tp;
                        ;// dump values sent to pc in case or error
                        ;char dmpadrh,dmpadrl,dmpdathrd,dmpdatlrd,dmpdathwr,dmpdatlwr;
                        ;#pragma rambank 4
                        ;char boot_bufflash[64];
                        ;#pragma rambank 3
                        ;
                        ;/* **************** FLASH PROGRAM CAPACITY ***************/
                        ;// capacity of pgm memory in bytes (2 times number of 14bits words)
                        ;// 16 for 8k pgm words
                        ;#define FLASHCAPACITY 250		// ex 16 k for 16f876
                        ;
                        ;/********************************************
                        ;		HARDWARE DEFINITIONS
                        ;********************************************/
                        ;// Define the switch port that will trigger bootloading
                        ;// switch activation must be 0 if switch makes 0 when pressed
                        ;// otherwise must be 1
                        ;#define SWITCH PORTA.5
                        ;#define TrisSw TRISA.5
                        ;#define SwitchActivation 0
                        ;
                        ;// If a led is available for status info, define it here
                        ;//#define LED LATA.4
                        ;//#define TrisLed TRISA.4 = 0
                        ;//#define LEDON 1;
                        ;//#define LEDOFF 0;
                        ;
                        ;
                        ;/*------------- End Interrupts services --------------*/
                        ;
                        ;/********************************************************
                        ;     BOOTLOADER ROUTINES
                        ; **********************************************************/
                        ;
                        ;
                        ;/* ********** FLASH WRITE P16F*********** */
                        ;
                        ;#pragma rambank 3
                        ;
                        ;void bootprocess (void)
                        ;{
bootprocess
                        ;// *** main bootloader
                        ;
                        ;	char rcvdata, i, j, BCC; 
                        ;	uns16 boot_fadr,btloop;
                        ;	char tp;
                        ;	bit OutRng;
                        ;	char kflash;
                        ;	
                        ;	bInitialize();
        CALL  bInitialize
                        ;	GIE = 0;		// no interrupt, polling only
        BCF   0x0B,GIE
                        ;//  host synch
                        ;	bi = 0;
        MOVLB 3
        CLRF  bi
                        ;	OutRng = 0;
        BCF   0x1AA,OutRng
                        ;	boot_tp=0;
        CLRF  boot_tp
                        ;	kflash = FLASHCAPACITY / 2;
        MOVLW 125
        MOVWF kflash
                        ;	while (bi == 0)
m120    MOVLB 3
        MOVF  bi,1
        BTFSS 0x03,Zero_
        GOTO  m121
                        ;	{
                        ;				rxdata = boot_waitsrl();
        CALL  boot_waitsrl
        MOVLB 3
        MOVWF rxdata
                        ;		if (rxdata == 'R')
        MOVF  rxdata,W
        XORLW 82
        BTFSS 0x03,Zero_
        GOTO  m120
                        ;		{
                        ;			nop();
        NOP  
                        ;			nop();
        NOP  
                        ;			rxdata = boot_waitsrl();
        CALL  boot_waitsrl
        MOVLB 3
        MOVWF rxdata
                        ;
                        ;			if (rxdata == 'M')
        MOVF  rxdata,W
        XORLW 77
        BTFSS 0x03,Zero_
        GOTO  m120
                        ;			{
                        ;				nop();
        NOP  
                        ;				nop();
        NOP  
                        ;				rxdata = boot_waitsrl();
        CALL  boot_waitsrl
        MOVLB 3
        MOVWF rxdata
                        ;				if (rxdata == 'b')
        MOVF  rxdata,W
        XORLW 98
        BTFSS 0x03,Zero_
        GOTO  m120
                        ;				{
                        ;					nop();
        NOP  
                        ;					nop();
        NOP  
                        ;					rxdata = boot_waitsrl();
        CALL  boot_waitsrl
        MOVLB 3
        MOVWF rxdata
                        ;					if (rxdata == 't')
        MOVF  rxdata,W
        XORLW 116
        BTFSS 0x03,Zero_
        GOTO  m120
                        ;					{
                        ;//						LED = LEDOFF;
                        ;						boot_outsrl ('b');			// Device reply with c to complete handshake
        MOVLW 98
        CALL  boot_outsrl
                        ;						boot_outsrl ('t');
        MOVLW 116
        CALL  boot_outsrl
                        ;						boot_outsrl (FLASHCAPACITY);
        MOVLW 250
        CALL  boot_outsrl
                        ;						bi = 1;
        MOVLW 1
        MOVLB 3
        MOVWF bi
                        ;					}	
                        ;				}
                        ;			}
                        ;		} 
                        ;	}
        GOTO  m120
                        ;
                        ;// tfr data 
                        ;	boot_fadr = 0;
m121    MOVLB 3
        CLRF  boot_fadr
        CLRF  boot_fadr+1
                        ;
                        ;// transfer format is :
                        ;// 27 as sart of block
                        ;// address high, address low, in hex.
                        ;// then 64 bytes follows, then check caracter
                        ;// When address is 0xff00: stop
                        ;
                        ;	while (boot_fadr != 0xFF00)	// must complete with address FF00 to stop tfr
m122    MOVLB 3
        INCF  boot_fadr+1,W
        IORWF boot_fadr,W
        BTFSC 0x03,Zero_
        GOTO  m132
                        ;	{
                        ;		rxdata = boot_waitsrl();
        CALL  boot_waitsrl
        MOVLB 3
        MOVWF rxdata
                        ;		while (rxdata != 27)		// start of block 
m123    MOVLB 3
        MOVF  rxdata,W
        XORLW 27
        BTFSC 0x03,Zero_
        GOTO  m126
                        ;		{
                        ;			if (rxdata == 28)	// verif loop
        MOVF  rxdata,W
        XORLW 28
        BTFSS 0x03,Zero_
        GOTO  m125
                        ;			{
                        ;				if (verif (boot_fadr) == 1)
        MOVF  boot_fadr,W
        MOVWF fadr_2
        MOVF  boot_fadr+1,W
        MOVWF fadr_2+1
        CALL  verif
        BTFSS 0x03,Carry
        GOTO  m124
                        ;				{
                        ;					boot_outsrl (6);
        MOVLW 6
        CALL  boot_outsrl
                        ;				}
                        ;				else
        GOTO  m125
                        ;				{
                        ;					boot_outsrl(8);		// for test, must be 8
m124    MOVLW 8
        CALL  boot_outsrl
                        ;				}		
                        ;			}
                        ;			rxdata = boot_waitsrl();
m125    CALL  boot_waitsrl
        MOVLB 3
        MOVWF rxdata
                        ;		}
        GOTO  m123
                        ;		rcvdata = boot_waitsrl();
m126    CALL  boot_waitsrl
        MOVLB 3
        MOVWF rcvdata
                        ;		BCC = rcvdata;
        MOVF  rcvdata,W
        MOVWF BCC
                        ;		boot_fadr.high8 = rcvdata;
        MOVF  rcvdata,W
        MOVWF boot_fadr+1
                        ;		rcvdata = boot_waitsrl();
        CALL  boot_waitsrl
        MOVLB 3
        MOVWF rcvdata
                        ;		BCC += rcvdata;
        MOVF  rcvdata,W
        ADDWF BCC,1
                        ;		boot_fadr.low8 = rcvdata;
        MOVF  rcvdata,W
        MOVWF boot_fadr
                        ;		if (boot_fadr == 0xFF00) break;
        INCF  boot_fadr+1,W
        IORWF boot_fadr,W
        BTFSC 0x03,Zero_
        GOTO  m132
                        ;		for (i = 0;i!=64;i++)
        MOVLB 3
        CLRF  i_6
m127    MOVLB 3
        MOVF  i_6,W
        XORLW 64
        BTFSC 0x03,Zero_
        GOTO  m128
                        ;		{
                        ;			rcvdata = boot_waitsrl();
        CALL  boot_waitsrl
        MOVLB 3
        MOVWF rcvdata
                        ;			BCC += rcvdata;
        MOVF  rcvdata,W
        ADDWF BCC,1
                        ;			boot_bufflash[i] = rcvdata;
        MOVLW 32
        ADDWF i_6,W
        MOVWF FSR0L
        MOVLW 2
        MOVWF FSR0H
        MOVF  rcvdata,W
        MOVWF INDF0
                        ;		}
        INCF  i_6,1
        GOTO  m127
                        ;		rcvdata = boot_waitsrl();	// BCC caracter
m128    CALL  boot_waitsrl
        MOVLB 3
        MOVWF rcvdata
                        ;		if (rcvdata == BCC)  
        MOVF  rcvdata,W
        XORWF BCC,W
        BTFSS 0x03,Zero_
        GOTO  m131
                        ;		{
                        ;			boot_OK=1;
        BSF   0x1B8,boot_OK
                        ;			if (OutRng == 0)
        BTFSC 0x1AA,OutRng
        GOTO  m130
                        ;			{		
                        ;				boot_writeflash (boot_fadr);
        MOVF  boot_fadr,W
        MOVWF fadr
        MOVF  boot_fadr+1,W
        MOVWF fadr+1
        CALL  boot_writeflash
                        ;				if (boot_OK == 1)
        MOVLB 3
        BTFSS 0x1B8,boot_OK
        GOTO  m129
                        ;				{
                        ;					boot_outsrl (6);		// check is ok, reply ack
        MOVLW 6
        CALL  boot_outsrl
                        ;				}
                        ;				else
        GOTO  m122
                        ;				{
                        ;					boot_outsrl (8);		// reply 8 for error write
m129    MOVLW 8
        CALL  boot_outsrl
                        ;					boot_outsrl (dmpadrh);
        MOVLB 3
        MOVF  dmpadrh,W
        CALL  boot_outsrl
                        ;					boot_outsrl(dmpadrl);
        MOVLB 3
        MOVF  dmpadrl,W
        CALL  boot_outsrl
                        ;					boot_outsrl(dmpdathrd);
        MOVLB 3
        MOVF  dmpdathrd,W
        CALL  boot_outsrl
                        ;					boot_outsrl(dmpdatlrd);
        MOVLB 3
        MOVF  dmpdatlrd,W
        CALL  boot_outsrl
                        ;					boot_outsrl(dmpdathwr);
        MOVLB 3
        MOVF  dmpdathwr,W
        CALL  boot_outsrl
                        ;					boot_outsrl(dmpdatlwr);
        MOVLB 3
        MOVF  dmpdatlwr,W
        CALL  boot_outsrl
                        ;
                        ;				}
                        ;			}
                        ;			else 
        GOTO  m122
                        ;			{
                        ;				boot_outsrl(9);
m130    MOVLW 9
        CALL  boot_outsrl
                        ;			}			
                        ;	
                        ;		}	
                        ;		else
        GOTO  m122
                        ;		{
                        ;				boot_outsrl (7);	// reply nack, comm error
m131    MOVLW 7
        CALL  boot_outsrl
                        ;		}
                        ;	}
        GOTO  m122
                        ;}
m132    RETURN
                        ;
                        ;void boot_writeflash (uns16 fadr) // 64 bytes at once in bufflash
                        ; {
boot_writeflash
                        ;	char i,j,k,l,m,n,pointr;
                        ;	uns16 svfadr;
                        ;	uns16 locadr;
                        ;	
                        ;	svfadr = fadr;
        MOVLB 3
        MOVF  fadr,W
        MOVWF svfadr
        MOVF  fadr+1,W
        MOVWF svfadr+1
                        ;	locadr = fadr;
        MOVF  fadr,W
        MOVWF locadr
        MOVF  fadr+1,W
        MOVWF locadr+1
                        ;	boot_OK = 1;
        BSF   0x1B8,boot_OK
                        ;	GIE = 0;		// should be already at 0, for standardizi	
        BCF   0x0B,GIE
                        ;	EEIE = 0;
        MOVLB 1
        BCF   0x92,EEIE
                        ;	if (fadr < 0x1800)	// protect booloader zone
        MOVLW 24
        MOVLB 3
        SUBWF fadr+1,W
        BTFSC 0x03,Carry
        GOTO  m135
                        ;	{
                        ;		// *** first erase block
                        ;		EEADRH = locadr.high8;
        MOVF  locadr+1,W
        MOVWF EEADRH
                        ;		EEADRL = locadr.low8;
        MOVF  locadr,W
        MOVWF EEADRL
                        ;		EEIF = 0;
        MOVLB 0
        BCF   0x12,EEIF
                        ;		CFGS = 0;
        MOVLB 3
        BCF   0x195,CFGS
                        ;		EEPGD = 1;
        BSF   0x195,EEPGD
                        ;		FREE = 1;
        BSF   0x195,FREE
                        ;		WREN = 1;
        BSF   0x195,WREN
                        ;		EECON2 = 0x55;
        MOVLW 85
        MOVWF EECON2
                        ;		EECON2 = 0xAA;
        MOVLW 170
        MOVWF EECON2
                        ;		WR = 1;
        BSF   0x195,WR
                        ;		nop();
        NOP  
                        ;		nop();
        NOP  
                        ;		FREE = 0;
        BCF   0x195,FREE
                        ;		
                        ;		//  ***  then write data
                        ;		EEADRH = locadr.high8;
        MOVF  locadr+1,W
        MOVWF EEADRH
                        ;		EEADRL = locadr.low8;
        MOVF  locadr,W
        MOVWF EEADRL
                        ;		EEPGD = 1;
        BSF   0x195,EEPGD
                        ;		CFGS = 0;
        BCF   0x195,CFGS
                        ;		WREN = 1;
        BSF   0x195,WREN
                        ;		LWLO = 1;	// select latches
        BSF   0x195,LWLO
                        ;		EEIF =0;
        MOVLB 0
        BCF   0x12,EEIF
                        ;		// write latches loop
                        ;		for (k = 0; k != 32; k++)
        MOVLB 3
        CLRF  k
m133    MOVLB 3
        MOVF  k,W
        XORLW 32
        BTFSC 0x03,Zero_
        GOTO  m134
                        ;		{
                        ;			EEIF = 0;
        MOVLB 0
        BCF   0x12,EEIF
                        ;			svfadr = locadr + k;
        MOVLB 3
        MOVF  locadr+1,W
        MOVWF svfadr+1
        MOVF  k,W
        ADDWF locadr,W
        MOVWF svfadr
        BTFSC 0x03,Carry
        INCF  svfadr+1,1
                        ;			pointr = k * 2;
        BCF   0x03,Carry
        RLF   k,W
        MOVWF pointr
                        ;			boot_bufflash[pointr+1] &= 0x3F;
        MOVLW 33
        ADDWF pointr,W
        MOVWF FSR0L
        MOVLW 2
        MOVWF FSR0H
        MOVLW 63
        ANDWF INDF0,1
                        ;			EEDATL = boot_bufflash[pointr];
        MOVLW 32
        ADDWF pointr,W
        MOVWF FSR0L
        MOVLW 2
        MOVWF FSR0H
        MOVF  INDF0,W
        MOVWF EEDATL
                        ;			EEDATH = boot_bufflash[pointr+1];
        MOVLW 33
        ADDWF pointr,W
        MOVWF FSR0L
        MOVLW 2
        MOVWF FSR0H
        MOVF  INDF0,W
        MOVWF EEDATH
                        ;			EECON2 = 0x55;
        MOVLW 85
        MOVWF EECON2
                        ;			EECON2 = 0xAA;
        MOVLW 170
        MOVWF EECON2
                        ;			WR = 1;
        BSF   0x195,WR
                        ;			nop();
        NOP  
                        ;			nop();
        NOP  
                        ;			EEADRL++;
        INCF  EEADRL,1
                        ;		}
        INCF  k,1
        GOTO  m133
                        ;			// write flash now
                        ;		EEIF = 0;
m134    MOVLB 0
        BCF   0x12,EEIF
                        ;		LWLO = 0;		// select flash
        MOVLB 3
        BCF   0x195,LWLO
                        ;		EEADRL = locadr.low8;
        MOVF  locadr,W
        MOVWF EEADRL
                        ;		EEDATL = boot_bufflash[0];
        MOVLB 4
        MOVF  boot_bufflash,W
        MOVLB 3
        MOVWF EEDATL
                        ;		EEDATH = boot_bufflash[1];		
        MOVLB 4
        MOVF  boot_bufflash+1,W
        MOVLB 3
        MOVWF EEDATH
                        ;		EECON2 = 0x55;
        MOVLW 85
        MOVWF EECON2
                        ;		EECON2 = 0xAA;
        MOVLW 170
        MOVWF EECON2
                        ;		WR = 1;
        BSF   0x195,WR
                        ;		nop();
        NOP  
                        ;		nop();
        NOP  
                        ;		nop();
        NOP  
                        ;		nop();
        NOP  
                        ;		nop();
        NOP  
                        ;		nop();
        NOP  
                        ;		nop();
        NOP  
                        ;		nop();
        NOP  
                        ;		WREN = 0;
        BCF   0x195,WREN
                        ;//		LED = !LED;
                        ;	}
                        ;	else boot_OK = 1;
        GOTO  m136
m135    MOVLB 3
        BSF   0x1B8,boot_OK
                        ;}
m136    RETURN
                        ;
                        ;bit verif (uns16 fadr)	
                        ;{
verif
                        ;	char i,j,k,l,m,n,pointr;
                        ;	uns16 svfadr;
                        ;	uns16 locadr;
                        ;	
                        ;	boot_OK = 1;
        MOVLB 3
        BSF   0x1B8,boot_OK
                        ;// Method 2 read flash inprogramming mode
                        ;	if (fadr < 0x1800)	// ignore booloader zone
        MOVLW 24
        SUBWF fadr_2+1,W
        BTFSC 0x03,Carry
        GOTO  m138
                        ;	{
                        ;		EEIF = 0;
        MOVLB 0
        BCF   0x12,EEIF
                        ;		CFGS = 0;
        MOVLB 3
        BCF   0x195,CFGS
                        ;		EEPGD = 1;
        BSF   0x195,EEPGD
                        ;		for (n = 0; n != 32; n++)
        CLRF  n_2
m137    MOVLB 3
        MOVF  n_2,W
        XORLW 32
        BTFSC 0x03,Zero_
        GOTO  m138
                        ;		{
                        ;			svfadr = fadr + n;
        MOVF  fadr_2+1,W
        MOVWF svfadr_2+1
        MOVF  n_2,W
        ADDWF fadr_2,W
        MOVWF svfadr_2
        BTFSC 0x03,Carry
        INCF  svfadr_2+1,1
                        ;			EEIF = 0;
        MOVLB 0
        BCF   0x12,EEIF
                        ;			CFGS = 0;
        MOVLB 3
        BCF   0x195,CFGS
                        ;			EEPGD = 1;
        BSF   0x195,EEPGD
                        ;			EEADRL = svfadr.low8;
        MOVF  svfadr_2,W
        MOVWF EEADRL
                        ;			EEADRH = svfadr.high8;
        MOVF  svfadr_2+1,W
        MOVWF EEADRH
                        ;			pointr = n * 2;		
        BCF   0x03,Carry
        RLF   n_2,W
        MOVWF pointr_2
                        ;			RD = 1;
        BSF   0x195,RD
                        ;			nop();
        NOP  
                        ;			nop();
        NOP  
                        ;			nop();
        NOP  
                        ;			nop();
        NOP  
                        ;			k = EEDATL;
        MOVF  EEDATL,W
        MOVWF k_2
                        ;			j = EEDATH;
        MOVF  EEDATH,W
        MOVWF j_6
                        ;			j = j & 0x3F;
        MOVLW 63
        ANDWF j_6,1
                        ;			l = boot_bufflash[pointr] & 0x3F;
        MOVLW 32
        ADDWF pointr_2,W
        MOVWF FSR0L
        MOVLW 2
        MOVWF FSR0H
        MOVLW 63
        ANDWF INDF0,W
        MOVWF l_2
                        ;			m = boot_bufflash[pointr+1];
        MOVLW 33
        ADDWF pointr_2,W
        MOVWF FSR0L
        MOVLW 2
        MOVWF FSR0H
        MOVF  INDF0,W
        MOVWF m_2
                        ;			if (j !=l)	boot_OK = 0;
        MOVF  j_6,W
        XORWF l_2,W
        BTFSS 0x03,Zero_
        BCF   0x1B8,boot_OK
                        ;			if (k != m) boot_OK = 0;
        MOVLB 3
        MOVF  k_2,W
        XORWF m_2,W
        BTFSS 0x03,Zero_
        BCF   0x1B8,boot_OK
                        ;		}
        MOVLB 3
        INCF  n_2,1
        GOTO  m137
                        ;	}
                        ;	return boot_OK;
m138    BCF   0x03,Carry
        MOVLB 3
        BTFSC 0x1B8,boot_OK
        BSF   0x03,Carry
        RETURN
                        ;}
                        ;	
                        ;#pragma rambank 3
                        ;//  *** serial port routines
                        ;void boot_outsrl (char outcar)
                        ;	{
boot_outsrl
        MOVLB 3
        MOVWF outcar
                        ;	while (TRMT == 0);
m139    MOVLB 3
        BTFSS 0x19E,TRMT
        GOTO  m139
                        ;	TXREG = outcar;
        MOVLB 3
        MOVF  outcar,W
        MOVWF TXREG
                        ;	}
        RETURN
                        ;
                        ;char boot_waitsrl (void)
                        ;{
boot_waitsrl
                        ;while (RCIF == 0)
m140    MOVLB 0
        BTFSC 0x11,RCIF
        GOTO  m141
                        ;	{nop();
        NOP  
                        ;	nop();
        NOP  
                        ;	}
        GOTO  m140
                        ;return RCREG;
m141    MOVLB 3
        MOVF  RCREG,W
        RETURN
                        ;}
                        ;
                        ;
                        ;void bInitialize(void)
                        ;{
bInitialize
                        ;	INTCON = 0;		//  disable all interrupts /
        CLRF  INTCON
                        ;	STATUS = 0;
        CLRF  STATUS
                        ;	PORTA = 0; 
        MOVLB 0
        CLRF  PORTA
                        ;	PORTC = 0;  
        CLRF  PORTC
                        ;	TRISA = bin(111111);
        MOVLW 63
        MOVLB 1
        MOVWF TRISA
                        ;	TRISC = bin(11111111);
        MOVLW 255
        MOVWF TRISC
                        ;
                        ;// init periph interrupts 
                        ;	PIE1 = bin(00000000); // disabled int adc, usart, all polled
        CLRF  PIE1
                        ;	PIR1 = 0;
        MOVLB 0
        CLRF  PIR1
                        ;	GIE = 0;			// no interrupt, polling hrdw
        BCF   0x0B,GIE
                        ;	clearRAM();
        MOVLW 239
        MOVWF FSR0L
        MOVLW 35
        MOVWF FSR0H
        MOVLW 0
m142    MOVWI INDF0--
        BTFSC FSR0H,5
        GOTO  m142
        MOVWF FSR0H
m143    MOVWI INDF0--
        BTFSC FSR0L,4
        GOTO  m143
                        ;// init USART 19.2 Kbps / 8 bits
                        ;	//config USART
                        ;	TXSTA = 0b00100110;
        MOVLW 38
        MOVLB 3
        MOVWF TXSTA
                        ;	RCSTA = 0b10010000;
        MOVLW 144
        MOVWF RCSTA
                        ;	BAUDCON = 0b00001000;
        MOVLW 8
        MOVWF BAUDCON
                        ;	SPBRGL = b_BAUDGEN;
        MOVLW 16
        MOVWF SPBRGL
                        ;	SPBRGH = 0;
        CLRF  SPBRGH
                        ;	#if (b_BAUDGEN) > (255)
                        ;	SPBRGH = b_BAUDGEN / 256;
                        ;	#endif
                        ;	TRISC.4 = 1;
        MOVLB 1
        BSF   TRISC,4
                        ;	TRISC.5 = 1;
        BSF   TRISC,5
                        ;	nop();
        NOP  
                        ;	bi = RCREG;		// dummy read to clear buffer
        MOVLB 3
        MOVF  RCREG,W
        MOVWF bi
                        ;	nop();
        NOP  
                        ;	bi = RCREG;
        MOVF  RCREG,W
        MOVWF bi
                        ;}	
        RETURN

        END


; *** KEY INFO ***

; 0x0281 P0   59 word(s)  2 % : main
; 0x0219 P0   78 word(s)  3 % : Init
; 0x0267 P0   26 word(s)  1 % : InitVar
; 0x0097 P0   18 word(s)  0 % : tempo
; 0x01F3 P0   38 word(s)  1 % : MainLoop
; 0x00D5 P0  244 word(s) 11 % : ProcCmd
; 0x01C9 P0   42 word(s)  2 % : ProcADC
; 0x0004 P0  147 word(s)  7 % : intsrvc
; 0x00A9 P0   44 word(s)  2 % : TxData

; 0x0B16 P1  323 word(s) 15 % : CalcDegC
; 0x0800 P1   89 word(s)  4 % : _fmul24
; 0x0859 P1  121 word(s)  5 % : _fdiv24
; 0x08D2 P1  173 word(s)  8 % : _fadd24
; 0x097F P1    7 word(s)  0 % : _fsub24
; 0x0986 P1   71 word(s)  3 % : _int24ToFloat24
; 0x09CD P1   87 word(s)  4 % : _float24ToInt24
; 0x0A24 P1  242 word(s) 11 % : log

; 0x1800 P3  180 word(s)  8 % : bootprocess
; 0x18B4 P3  130 word(s)  6 % : boot_writeflash
; 0x1936 P3   79 word(s)  3 % : verif
; 0x1985 P3    9 word(s)  0 % : boot_outsrl
; 0x198E P3    9 word(s)  0 % : boot_waitsrl
; 0x1997 P3   47 word(s)  2 % : bInitialize

; RAM usage: 193 bytes (59 local), 831 bytes free
; Maximum call level: 5 (+1 for interrupt)
;  Codepage 0 has  697 word(s) :  34 %
;  Codepage 1 has 1113 word(s) :  54 %
;  Codepage 2 has    0 word(s) :   0 %
;  Codepage 3 has  454 word(s) :  22 %
; Total of 2264 code words (27 %)
